#!/usr/bin/perl

#
### CONTROL PANEL SCRIPT FOR ULTIMATE BULLETIN BOARD ##
#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1997, 1998, 1999, 2000.
#
#       ------------ cpanel2.cgi -------------
#
#  This file contains some of the control panel functionality for
#  the UBB.  It is called from the controlpanel pages (cp.html).
#
#  NOTE: you MAY NOT distribute this script under any
#  circumstance.  This means that you may not sell, trade, or in
#  any other way give this script to another user who is not
#  licensed to use it.  Infopop Corporation offers no
#  warranties on this script.  The owner/licensee of the script is
#  solely responsible for any problems caused by installation of
#  the script or use of the script, including messages that may be
#  posted on the BB.
#
#  All copyright notices regarding the Ultimate Bulletin Board
#  must remain intact on the scripts and in the HTML
#  for the scripts.
#
# For more info on the Ultimate BB, 
# see http://www.UltimateBB.com
#
###############################################################
#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

print ("Content-type: text/html\n\n");
eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "mods.file";
require "Date.pl";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";
};


if ($@) {
    print "Fehler beim Aufruf der Datei(en): $@\n";
    print "Stellen Sie sicher, da&szlig; diese Datei(en) vorhanden ist/sind, die Zugriffsrechte und Systempfade korrekt eingestellt sind.";
 exit;
}

&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);

if ($Name eq "action") {
		$action = $Value;
}

if ($action eq 'setgenvars') { # only process for this routine

	&checkpathlock; # see if paths are locked

	if ($Name eq "BBEmail") {
		$BBEmail = $Value;
		$BBEmail =~ s/@/\\@/;
	}
			
	if ($Name eq "BBRules") {
		$BBRules = $Value;
		$BBRules =~ s/"/&quot;/g;
		$BBRules =~ s/\@/\\@/g;
		$BBRules = &ConvertReturns($BBRules);
	}
		
	if ($Name eq "COPPAWording") {
		$COPPAWording = $Value;
		$COPPAWording =~ s/"/&quot;/g;
		$COPPAWording =~ s/\@/\\@/g;
		$COPPAWording = &ConvertReturns($COPPAWording);
	}
	if ($Name eq "COPPAInstructions") {
		$COPPAInstructions = $Value;
		$COPPAInstructions =~ s/"/&quot;/g;
		$COPPAInstructions =~ s/\@/\\@/g;
		$COPPAInstructions = &ConvertReturns($COPPAInstructions);
	}	
	
	if ($Name eq "BBClosedMessage") {
		$BBClosedMessage = $Value;
		$BBClosedMessage =~ s/"/&quot;/g;
		$BBClosedMessage =~ s/\@/\\@/g;
		$BBClosedMessage = &ConvertReturns($BBClosedMessage);
	}		
		
	if ($Name eq "censorwords") {
		$censorwords = $Value;
		$censorwords = &EliminateReturns($censorwords);
		$censorwords =~ s/<BR>//ig;
		$censorwords =~ s/<P>//ig;
		$censorwords =~ s/"/&quot;/g;
		$censorwords =~ s/\@/\\@/g;
	}
	if ($Name eq "EmailBan") {
		$EmailBan = $Value;
		$EmailBan = &EliminateReturns($EmailBan);
		$EmailBan =~ s/<BR>//ig;
		$EmailBan =~ s/<P>//ig;
		$EmailBan =~ s/"/&quot;/g;
		$EmailBan =~ s/\@/\\@/g;
	}
	if ($Name eq "YourCopyrightNotice") {
		$YourCopyrightNotice = $Value;
		$YourCopyrightNotice = &EliminateReturns($YourCopyrightNotice);
		$YourCopyrightNotice =~ s/"/&quot;/g;
		$YourCopyrightNotice =~ s/<BR>//ig;
		$YourCopyrightNotice =~ s/<P>//ig;
		$YourCopyrightNotice =~ s/\@/\\@/g;
	}
	if ($Name eq "Header") {
		$Header = $Value;
		$Header = &LimitReturns($Header);
	}
	if ($Name eq "Footer") {
		$Footer = $Value;
		$Footer = &LimitReturns($Footer);
	}
	if ($Name eq "MyHomePage") {
		$MyHomePage = $Value;
	}
	if ($Name eq "HomePageURL") {
		$HomePageURL = $Value;
	}
	if ($Name eq "BBName") {
		$BBName = $Value;
	}
	if ($Name eq "ForumsPath") {
		$ForumsPath = $Value;
	}
	if ($Name eq "MembersPath") {
		$MembersPath = $Value;
	}
	if ($Name eq "CGIPath") {
		$CGIPath = $Value;
	}
	if ($Name eq "VariablesPath") {
		$VariablesPath = $Value;
	}
	if ($Name eq "NonCGIPath") {
		$NonCGIPath = $Value;
	}
	if ($Name eq "CGIURL") {
		$CGIURL = $Value;
	}
	if ($Name eq "NonCGIURL") {
		$NonCGIURL = $Value;
	}
} # end if action = setgenvars

	if ($Name eq "UserNameCheck") {
		$UserNameCheck = $Value;
		$UserNameCheckFile = $UserNameCheck;
		$UserNameCheckFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserName = &UNHTMLIFY($UserName);
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
		$UserNameCoded = $UserName;
		$UserNameCoded = &HTMLIFY($UserNameCoded);
		$UserNameCoded =~ tr/ /+/;
	}
	if ($Name eq "Password") {
		$Password = $Value;
		$PasswordCoded = $Password;
		$PasswordCoded =~ tr/ /+/;
		}
	if ($Name eq "PasswordCheck") {
		$PasswordCheck = $Value;
		$PasswordCheckCoded = $PasswordCheck;
		$PasswordCheckCoded =~ tr/ /+/;
	}
	if ($Name eq "number") {
		$number = $Value;
		$number =~ s/\D//sg;
	}
	if ($Name eq "UpdateType") {
		$UpdateType = $Value;
	}		
	if ($Name eq "TotalForums") {
		$TotalForums = $Value;
	}
} #end foreach loop


#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}

if ($action eq "mods") {
	&Mods;
	exit;
}

if ($action eq "setgenvars") {
	&SetGenVars;
	exit;
}
if ($action eq "doindex") {
	&DoIndex;
   	exit;
}

if ($action eq "sendstyle") {
	&SendStyle;
	exit;
}

if ($action eq "sendvarID") {
	&SendVarID;
	exit;
}

if ($action eq "continueMC") {
	$OldFormat = $in{'OldFormat'};
	if (-e "$MembersPath/holdmems.cgi") {
		&ContinueMC($in{'startwith'}, $OldFormat);
	}  else {
		&StandardHTMLCP("Keine Mitgliederdaten sind zu konvertieren!");
	}
}

if ($action eq "DoGenVars") {
	&DoGenVars;
	exit;
}

if ($action eq "ContinueIndexing") {
	&ConfirmAdminModCookie;

	if ($IndexMethod eq "ONEFILE") {
	&ReIndex("$in{'start'}", "$in{'threadpoint'}");
	}  else {
	&ReIndex2("$in{'start'}", "$in{'threadpoint'}");
	}
	exit;
}


# end
exit(0);

sub SendVarID {
##verify that this user is an administrator
#check to see which Member Format is in place, process accordingly
if (-e "$MembersPath/memberslist.cgi") {

$ProfileNumber = &GetUserNumber($in{'UserName'});
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

}  else {

$ProfileNumber = $UserNameFile;


$NameFound = "no";
  if (-e "$MembersPath/$ProfileNumber.cgi") {
      $NameFound = "yes";
    } 
}

if ($NameFound eq "yes") {
	@theprofile = &OpenProfile("$ProfileNumber.cgi");
	chomp($theprofile[1]);
	if ($Password eq "$theprofile[1]") {
	$Permission = "$theprofile[4]";
		chomp($Permission);
	&CheckPermissions;
	   if ($AdminPermission eq "true") {
	   &DoGenVars;
	   }  else {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Administratoren bestimmt.");
	   }
	} else {
	&StandardHTMLCP("Das eingegebene Kennwort ist nicht korrekt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	}
}  else {
&StandardHTMLCP("Der von Ihnen angegebene Benutzername existiert nicht in unserem System - bitte nutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
}  ##END IF/ELSE NAME CHECK BLOCK

} # end SendVarsID sr


sub DoGenVars { # show general settings only for the first time install or authorized admins
if (($AdminPermission ne "true") && (-e "$CGIPath/edit.cgi") && (-e "$MembersPath/memberslist.cgi")  && (-d "$NonCGIPath/Forum3") ) {
	&StandardHTMLCP("Sie m&uuml;ssen sich identifizieren, Ihr UBB ist bereits konfiguriert - bitte nutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	exit;
}  else {
	
	$BBRules =~ s/&quot;/"/ig;
	$BBRules =~ s/<BR>/\n/ig;
	$BBRules =~ s/<p>/\n\n/ig;

	$COPPAWording =~ s/&quot;/"/ig;
	$COPPAWording =~ s/<BR>/\n/ig;
	$COPPAWording =~ s/<p>/\n\n/ig;

	$COPPAInstructions =~ s/&quot;/"/ig;
	$COPPAInstructions =~ s/<BR>/\n/ig;
	$COPPAInstructions =~ s/<p>/\n\n/ig;

	$Header =~ s/\\@/\@/sg;
	#$Header =~ s/\\"/\"/sg;
	$Footer =~ s/\\@/\@/sg;
	#$Footer =~ s/\\"/\"/sg;	

	$BBClosedMessage =~ s/&quot;/"/ig;
	$BBClosedMessage =~ s/<BR>/\n/ig;
	$BBClosedMessage =~ s/<p>/\n\n/ig;

if ($ForumDisplayMax eq "") {
	$FDM40 = "SELECTED";
}
elsif ($ForumDisplayMax == 25) {
	$FDM25 = "SELECTED";
}
elsif ($ForumDisplayMax == 35) {
	$FDM35 = "SELECTED";
}
elsif ($ForumDisplayMax == 40) {
	$FDM40 = "SELECTED";
}
elsif ($ForumDisplayMax == 50) {
	$FDM50 = "SELECTED";
}
elsif ($ForumDisplayMax == 75) {
	$FDM75 = "SELECTED";
}  else {
	$FDMNONE = "SELECTED";
}

if ($HTMLDisplayMax eq "") {
	$HDM40 = "SELECTED";
}
elsif ($HTMLDisplayMax == 15) {
	$HDM15 = "SELECTED";
}
elsif ($HTMLDisplayMax == 25) {
	$HDM25 = "SELECTED";
}
elsif ($HTMLDisplayMax == 35) {
	$HDM35 = "SELECTED";
}
elsif ($HTMLDisplayMax == 40) {
	$HDM40 = "SELECTED";
}
elsif ($HTMLDisplayMax == 50) {
	$HDM50 = "SELECTED";
}
elsif ($HTMLDisplayMax == 75) {
	$HDM75 = "SELECTED";
}  else {
	$HDMNONE = "SELECTED";
}
if ($DaysPruneDefault eq "") {
	$Days20 = "SELECTED";
}
elsif ($DaysPruneDefault == 1) {
	$Days1 = "SELECTED";
}
elsif ($DaysPruneDefault == 2) {
	$Days2 = "SELECTED";
}
elsif ($DaysPruneDefault == 5) {
	$Days5 = "SELECTED";
}
elsif ($DaysPruneDefault == 10) {
	$Days10 = "SELECTED";
}
elsif ($DaysPruneDefault == 20) {
	$Days20 = "SELECTED";
}
elsif ($DaysPruneDefault == 30) {
	$Days30 = "SELECTED";
}
elsif ($DaysPruneDefault == 45) {
	$Days45 = "SELECTED";
}
elsif ($DaysPruneDefault == 60) {
	$Days60 = "SELECTED";
}
elsif ($DaysPruneDefault == 75) {
	$Days75 = "SELECTED";
}
elsif ($DaysPruneDefault == 100) {
	$Days100 = "SELECTED";
}
elsif ($DaysPruneDefault == 1000) {
	$Days1000 = "SELECTED";
}  else {
	$Days365 = "SELECTED";
}
		
if ($CategoryView eq "yes") {
	$CategoryViewOn = "CHECKED";
}  else {
	$CategoryViewOff = "CHECKED";
}
if ($AllowSearch eq "FALSE") {
	$AllowSearchOff = "CHECKED";
}  else {
	$AllowSearchOn = "CHECKED";
}
if ($showcopytype eq "text") {
	$showcopytypeTEXT = "CHECKED";
}  else {
	$showcopytypeIMAGE = "CHECKED";
}

if ($AllowTotalSearch eq "FALSE") {
	$AllowTotalSearchOff = "CHECKED";
}  else {
	$AllowTotalSearchOn = "CHECKED";
}

if ($IndexMethod eq "ONEFILE") {
	$IndexMethodOne = "CHECKED";
}  else {
	$IndexMethodPer = "CHECKED";
}
if ($AllowIcons eq "TRUE") {
	$IconsOn = "CHECKED";
}  else {
	$IconsOff = "CHECKED";
}

if ($ReplyQuote eq "NO") {
	$ReplyQuoteOff = "CHECKED";
}  else {
	$ReplyQuoteOn = "CHECKED";
}

if ($InlineFrame eq "TRUE") {
	$InlineOn = "CHECKED";
}  else {
	$InlineOff = "CHECKED";
}
if ($CategoriesOnly eq "true") {
	$CategoriesOnlyOn = "CHECKED";
}  else {
	$CategoriesOnlyOff = "CHECKED";
}		

if ($EmailVerify eq "ON") {
	$EmailVerifyOn = "CHECKED";
}  else {
	$EmailVerifyOff = "CHECKED";
}

if ($EditOption eq "ON") {
	$EditOptionOn = "CHECKED";
}
elsif ($EditOption eq "OFF") {
	$EditOptionOff = "CHECKED";
}  else {
	$EditOptionND = "CHECKED";
}
					
if ($ForumDescriptions eq "yes") {
	$ForumDescriptionsOn = "CHECKED";
}  else {
	$ForumDescriptionsOff = "CHECKED";
}
		
if ($ContactLinkType eq 'URL') {
	$ContactLinkTypeURL = 'CHECKED';	
} else { $ContactLinkTypeEmail = 'CHECKED';
}

if ($IP eq "ON") {
	$IPOn = "CHECKED";
}
elsif ($IP eq "LOGONLY") {
	$IPLO = "CHECKED";
}  else {
	$IPOff = "CHECKED";
}

if ($log_admin_activity eq 'YES') {
	$log_admin_activityON = 'CHECKED';	
}else {
	$log_admin_activityOFF = 'CHECKED';	
}	
if ($Censor eq "ON") {
	$CensorOn = "CHECKED";
}  else {
	$CensorOff = "CHECKED";
}
if ($FloodCheck eq "ON") {
	$FloodOn = "CHECKED";
}  else {
	$FloodOff = "CHECKED";
}

if ($FloodCheckSpan eq "") {
	$FloodCheckSpan = "60";
}

if ($AdminTitle eq "") {
	$AdminTitle = "Administrator";
}
if ($ModeratorTitle eq "") {
	$ModeratorTitle = "Moderator";
}		
if ($MemberTitle eq "") {
	$MemberTitle = "Mitglied";
}
if ($JrMemberTitle eq "") {
	$JrMemberTitle = "Junior-Mitglied";
}

if ($ShowMods eq 'no') {
	$ShowModsOff = 'CHECKED';	
} else {$ShowModsOn = 'CHECKED';
	
}

if ($DisplayMemberTotal eq "true") {
	$MemberTotalOn = "CHECKED";
}  else {
	$MemberTotalOff = "CHECKED";
}		
if ($BBStatus eq "OFF") {
	$BBStatusOff = "CHECKED";
}  else {
	$BBStatusOn = "CHECKED";
}

if ($BBClosedMessage eq '') {
	$BBClosedMessage = "Die Foren sind aufgrund Wartungsarbeiten derzeit leider nicht erreichbar - bitte versuchen Sie es sp&auml;ter nocheinmal!";
}

if ($SetCookies eq "DirectorySpecific") {
	$COOKIESDS = "CHECKED";
}  else {
	$COOKIESBroad = "CHECKED";
}
if ($SuspendRegister eq "true") {
	$SRTrue = "CHECKED";
}  else {
	$SRFalse = "CHECKED";
}
if ($ForumTotalOption eq "Both") {
	$FTOBoth = "CHECKED";
}
elsif  ($ForumTotalOption eq "Topics"){
	$FTOTopics = "CHECKED";
}	else {
	$FTOPosts = "CHECKED";
}


if ($DisplayRegistration eq "NO") {
	$DisplayRegNo = "CHECKED";
}  else {
	$DisplayRegYes = "CHECKED";
}	

if ($AllowSignature eq "YES") {
	$AllowSigYes = "CHECKED";
}  else {
	$AllowSigNo = "CHECKED";
}	

if ($AllowSignatureImage eq "YES") {
	$AllowSigImageYes = "CHECKED";
}  else {
	$AllowSigImageNo = "CHECKED";
}	

if ($UseEmail eq "ON") {
	$EmailOn = "CHECKED";
}  else {
	$EmailOff = "CHECKED";
}		
		
if ($HotIcons eq "OFF")  {
	$HotIconsOff = "CHECKED";
}  else {
	$HotIconsOn = "CHECKED";
}	

if ($HotCount eq "") {
	$HotCount = "15";
}	

if ($EmailBlock eq "ON") {
	$EmailBlockOn = "CHECKED";
}  else {
	$EmailBlockOff = "CHECKED";
}		

if ($EnglishSubjectCheck eq "ON") {
	$ESCON = "CHECKED";
}  else {
	$ESCOFF = "CHECKED";
}		
		
if ($ReverseThreads eq "TRUE") {
	$ReverseThreadOn = "CHECKED";
}  else {
	$ReverseThreadOff = "CHECKED";
}		
if ($TimeFormat eq "24HR") {
	$Time24HR = "CHECKED";
}  else {
	$TimeAMPM = "CHECKED";
}		
if ($DateFormat eq "Euro") {
	$DateEuro = "CHECKED";
}
elsif ($DateFormat eq "EuroX") {
	$DateEuroX = "CHECKED";
}
elsif ($DateFormat eq "USX") {
	$DateUSX = "CHECKED";
}  else {
	$DateUS = "CHECKED";
}

if ($AuthorColumn eq "Location") {
	$LocationAC = "CHECKED";
}
elsif ($AuthorColumn eq "PostTotal") {
	$PostTotalAC = "CHECKED";
}  else {
	$MinimumAC = "CHECKED";
}

if ($EmailCheck eq "true") {
	$EmailTrue = "CHECKED";
}  else {
	$EmailFalse = "CHECKED";
}
if ($CGIPath eq '') {
	if($ENV{'SCRIPT_FILENAME'}){ #*nix
	 	$thiscgipath = $ENV{'SCRIPT_FILENAME'};	
	} elsif ($ENV{'PATH_TRANSLATED'}) { # Win32
		$thiscgipath = $ENV{'PATH_TRANSLATED'};
		$thiscgipath =~ s/\\/\//g; 
	}
	@cgipath = split(/\//, $thiscgipath);
	pop(@cgipath);
	$CGIPath = join("\/", @cgipath);
	$VariablesPath = $CGIPath;
	$MembersPath = ("$CGIPath" . "/Members");
	$cgiext = pop(@cgipath);
}
if ($NonCGIPath eq '') {
	$NonCGIPath = "$ENV{'DOCUMENT_ROOT'}/ubb";
	$ForumsPath = "$ENV{'DOCUMENT_ROOT'}/ubb";
}

if ($NonCGIURL eq '') {
	$NonCGIURL = "http://$ENV{'HTTP_HOST'}/ubb";
}
if ($CGIURL eq '') {
	$CGIURL = "http://$ENV{'HTTP_HOST'}/$cgiext";
}
if ($HomePageURL eq '') {
	$HomePageURL = "http://$ENV{'HTTP_HOST'}";
}
if ($BBEmail eq '') {
	$BBEmail = "$ENV{'SERVER_ADMIN'}";
}



if ($MemberMinimum eq "") {
	$MemberMinimum = "31";
}

if ($TimeZoneOffset eq "") {
	$TimeZoneOffset = "0";
}

#new options 03-03-00

if ($UBBFriendUSE eq "OFF") {
	$UBBFriendOFF = "CHECKED";
}
elsif ($UBBFriendUSE eq "RegUsers") {
	$UBBFriendREGONLY = "CHECKED";
}  else {
	$UBBFriendON = "CHECKED";
}

if ($ModerateRegs eq "ON") {
	$ModerateRegsON = "CHECKED";
}
elsif ($MemberNotify eq "COPPA") {
	$ModerateRegsCOPPA = "CHECKED";
}  else {
	$ModerateRegsOFF  = "CHECKED";
}

if ($COPPACheck eq "ON") {
	$COPPACheckON = "CHECKED";
}
   else {
	$COPPACheckOFF  = "CHECKED";
}


if ($COPPAType eq 'COPPAFormOnly') {
	$COPPAFormOnlyOn = "CHECKED";	
}
elsif ($COPPAType eq 'COPPADenied') {
	$COPPADeniedOn = "CHECKED";	
}
else {
	$COPPARegOn = "CHECKED";	
}

if ($OnRegsNotifyAdmin eq "ON") {
	$OnRegsNotifyAdminON = "CHECKED";
}
elsif ($OnRegsNotifyAdmin eq "COPPA") {
	$OnRegsNotifyAdminCOPPA = "CHECKED";
}
   else {
	$OnRegsNotifyAdminOFF  = "CHECKED";
}

if ($ShowPrivacyLink eq 'ON'){
$ShowPrivacyLinkON = 'CHECKED';
}
else {
$ShowPrivacyLinkOFF = 'CHECKED';	
}

if ($COPPAWording eq '') {
	$COPPAWording = "Hier mu&szlig; der Website-Betreiber eine Beschreibung der Bedingungen zum COPPA-Gesetz seiner Website einf&uuml;gen.";	
}
if ($COPPAInstructions eq '') {
	$COPPAInstructions = "Hier mu&szlig; der Website-Betreiber exakte Informationen angeben, wie der Benutzer die COPPA-Best&auml;tigung &uuml;bermitteln kann.";	
}

# check email availability and default to sendmail on *nix

if ($SendMailLocation eq "") {
	if (-e "/usr/bin/sendmail") {
		$SendMailLocation = "/usr/bin/sendmail";
	}
	elsif (-e "/usr/sbin/sendmail") {
		$SendMailLocation = "/usr/sbin/sendmail";
	}
	elsif (-e "/usr/lib/sendmail") {
	$SendMailLocation = "/usr/lib/sendmail";
	} 
}

if ($SMTPEmail eq "On") {
	$SMTPOn = "CHECKED";
} 
elsif ($SendMailLocation ne '')  {
	$SMTPOff = "CHECKED"; # this means sendmail is on
}
else {
	$SMTPOn = "CHECKED";
}

 ## spellcheck added 10/03/2000

if ($SpellCheck eq "NO") {
	$SCKFalse = "CHECKED";
}  else {
	$SCKTrue = "CHECKED";
}



if (-e "$MembersPath/emailfile.cgi") {
$DiagnosticWording = qq[<INPUT TYPE="CHECKBOX" NAME="Diagnostic" VALUE="yes"> <B>Markieren Sie dieses Feld, um einen Reset der Z&auml;hlungen aller Beitr&auml;ge und Zeiten in Ihrem UBB durchzuf&uuml;hren (Nur notwendig, wenn Sie der Meinung sind, die Angaben seien falsch).];
$EmailFile = "";
}  else {
$EmailFile = qq(<INPUT TYPE="HIDDEN" NAME="EmailFile" VALUE="add">);
$DiagnosticWording = "";
}

$PageTitle = "G E N E R E L L E &nbsp;&nbsp;&nbsp;&nbsp; E I N S T E L L U N G E N";
&HEADERHTML;

print<<THIS;
Um Ihre Umgebungsvariablen zu pr&uuml;fen, klicken Sie bitte <A HREF="cpanel.cgi?action=env">hier</A>.
<P>
Socket Test: Wenn Sie pr&uuml;fen m&ouml;chten, ob auf Ihrem System in der Perl-Installation das Socket-Modul installiert ist, klicken Sie bitte <A HREF="ubbmisc.cgi?action=sockettest">hier</A>. Wenn Sie einen Fehler oder eine leere Seite erhalten, wird das Socket-Modul nicht installiert sein.
<HR>
<P>
<FORM ACTION="cpanel2.cgi" NAME="THEFORM" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="setgenvars">
<INPUT TYPE="HIDDEN" NAME="EmailBan" VALUE="$EmailBan">
$EmailFile
<table border=0 cellpadding=0 cellspacing=0   width=100%><TR><td bgcolor="#000000">

<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00"><br>ABSOLUTE PFADANGABEN</FONT></B>
</TD></TR>
<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Absolute Pfadangaben stellen den physischen Pfad auf Ihrem Server dar. Hierbei handelt es sich um komplette Pfadangaben. Absolute Pfade werden bei Win32/NT-Servern anders dargestellt als in UNIX-Systemen. Hier ein Beispiel f&uuml;r Pfadangaben unter UNIX und NT:
<p>
F&uuml;r UNIX-Server:  &nbsp;&nbsp;&nbsp;&nbsp;<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#FF0000">/usr/home/ihredomain/www/cgi-bin</font>
<BR>
F&uuml;r Win32/NT servers:&nbsp;&nbsp;&nbsp;&nbsp; <FONT SIZE="1" FACE="Verdana, Arial" COLOR="#FF0000">C:/home/ihredomain/cgi-bin</FONT>
<P>
HINWEIS: Die oben gezeigten Pfade sind Beispiele, nicht Ihre Systempfade!
<P>
Wenn Sie unter Win32/NT installieren, verwenden Sie bitte die Syntax des gezeigten Beispiels (Slashs anstelle Backslashs).
<BR>
Wenn Sie UBB das erste Mal installieren, werden die notwendigen kompletten oder teilweisen Pfadangaben aus Ihrem System extrahiert und bereits dargestellt.  Diese Pfade m&uuml;ssen nicht stimmen, erleichtern Ihnen jedoch die Einrichtung.</B></FONT>
</td></tr>
THIS

&InputTextRow("#dedfdf", "Absoluter Pfad f&uuml;r das UBB-CGI-Verzeichnis", "" , "CGIPath", "40", "250");
&InputTextRow("#f7f7f7", "Absoluter Pfad f&uuml;r das UBB-NonCGI-Verzeichnis", "" , "NonCGIPath", "40", "250");
&InputTextRow("#dedfdf", "Absoluter Pfad zum Members-Verzeichnis", "Dieser Pfad sollte mit /Members (wie z.B. \"/usr/home/yourdomain/www/cgi-bin/Members\") enden." , "MembersPath", "40", "250");
&InputTextRow("#f7f7f7", "Absoluter Pfad zu den Variablen-Dateien", "<B>Hier sollten Sie den gleichen Pfad wie den f&uuml;r das UBB-CGI-Verzeichnis verwenden.</B> Sollten Sie in Ihrem CGI-Verzeichnis keine Schreibrechte besitzen, legen Sie die Variablen-Dateien (UltBB.setup, forums.cgi, mods.file, Styles.file) in ein anderes Verzeichnis. Auf dieses Verzeichnis sollte man aus Sicherheitsgr&uuml;nden nicht mit einem Browser zugreifen k&ouml;nnen.", "VariablesPath", "40", "250");

print<<THIS2;
</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">URL-Angaben</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Bitte geben Sie hier die kompletten Hyperlinks an. Komplett bedeutet zum Beispiel http://www.yourdomain.com/cgi-bin</B></FONT>
</td></tr>
THIS2

&InputTextRow("#dedfdf", "URL zum UBB-CGI-Verzeichnis", "", "CGIURL", "40", "250");
&InputTextRow("#f7f7f7", "URL zum UBB-NonCGI-Verzeichnis", "", "NonCGIURL", "40", "250");
&InputTextRow("#dedfdf", "URL zu Ihrer Homepage", "Die komplette URL-Angabe zu Ihrer Homepage (nicht UBB).  Diese wird f&uuml;r Links zu Ihrer Homepage aus UBB heraus genutzt.", "HomePageURL", "40", "250");
&InputTextRow("#f7f7f7", "<p>URL zu Ihrem COPPA-Hinweisen", "Die komplette URL-Angabe zu Ihren COPPA-Hinweisen.</p>", "PrivacyURL", "40", "250");


print<<THIS3;
</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">DARSTELLUNGSOPTIONEN</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Bitte f&uuml;llen Sie die folgenden Felder aus, hier definieren Sie den Namen Ihres UBB, Ihrer Homepage, Ihrer eMail-Adresse, Kopf- und Fu&szlig;zeilen auf jeder Seite usw.</B></FONT>
</td></tr>
THIS3

&InputTextRow("#f7f7f7", "Name Ihres UBB", "", "BBName", "30", "250");
&InputTextRow("#dedfdf", "Name Ihrer Homepage", "Dieser Name wird bei Links aus UBB zur&uuml;ck zu Ihrer Homepage verwendet.", "MyHomePage", "30", "250");
&InputTextRow("#f7f7f7", "<p>Kontakt - eMail-Adresse", "</b> Diese eMail-Adresse wird bei Klick auf \"Kontakt\" verwendet.</p>", "BBEmail", "30", "250");
&InputTextRow("#dedfdf", "<p>Kontakt - URL", "</b> Diese URL wird bei Klick auf \"Kontakt\" verwendet, bitte geben Sie eine komplette URL ein. </p>", "ContactURL", "40", "250");
&InputRadioRow("#f7f7f7", "<p>Typ des \"Kontakt\"-Links", "</b>W&auml;hlen Sie hier, ob bei Klick auf \"Kontakt\" entweder die oben eingegebene eMail-Adresse oder die URL verwendet werden soll.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"ContactLinkType\" VALUE=\"Email\" $ContactLinkTypeEmail> eMail verwenden<br>
<INPUT TYPE=\"RADIO\" NAME=\"ContactLinkType\" VALUE=\"URL\" $ContactLinkTypeURL> URL verwenden");

print<<THIS4;
<TR bgcolor="#f7f7f7">
<td width=50%>
<p><FONT SIZE="2" FACE="Verdana, Arial"><B>Zeitraum der Themenansicht</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial">Die Standardeinstellung f&uuml;r die Anzeige der "Zeige Beitr&auml;ge der letzten x Tage".  Benutzer k&ouml;nnen diese Anzeige in den Einstellungen von UBB individuell anpassen, jedoch wird generell ein Standardwert definiert. Empfohlen: 20.</FONT></p>
</td>
<td width=50% valign=top>
<SELECT NAME="DaysPruneDefault">
	<OPTION value="1" $Days1>Zeige Beitr&auml;ge des letzten Tages
	<OPTION value="2" $Days2>Zeige Beitr&auml;ge der letzten zwei Tage
	<OPTION value="5" $Days5>Zeige Beitr&auml;ge der letzten f&uuml;nf Tage
	<OPTION value="10" $Days10>Zeige Beitr&auml;ge der letzten 10 Tage
	<OPTION value="20" $Days20>Zeige Beitr&auml;ge der letzten 20 Tage
	<OPTION value="30" $Days30>Zeige Beitr&auml;ge der letzten 30 Tage
	<OPTION value="45" $Days45>Zeige Beitr&auml;ge der letzten 45 Tage
	<OPTION value="60" $Days60>Zeige Beitr&auml;ge der letzten 60 Tage
	<OPTION value="75" $Days75>Zeige Beitr&auml;ge der letzten 75 Tage
	<OPTION value="100" $Days100>Zeige Beitr&auml;ge der letzten 100 Tage
	<OPTION value="365" $Days365>Zeige Beitr&auml;ge des letzten Jahres
	<OPTION value="1000" $Days1000>Zeige alle Beitr&auml;ge
</SELECT>
</td></tr>
THIS4

&InputAreaRow("#dedfdf", "<p>Kopfzeile", "Hier k&ouml;nnen Sie individuelle Grafiken oder Texte, Werbebanner etc. definieren. Die Kopfzeile wird auf jeder prim&auml;ren Seite von UBB angezeigt. Diese Angaben sind optional. Lassen Sie dieses Feld ggf. leer.</p>", "Header", "30", "5");

&InputAreaRow("#f7f7f7", "<p>Fu&szlig;zeile", "Hier k&ouml;nnen Sie individuelle Grafiken oder Texte, Werbebanner etc. definieren. Die Fu&szlig;zeile wird auf jeder prim&auml;ren Seite von UBB angezeigt. Diese Angaben sind optional. Lassen Sie dieses Feld ggf. leer.</p>", "Footer", "30", "5");

&InputRadioRow("#dedfdf", "<p>Kategorien anzeigen", "</b>Wenn Sie Kategorien verwenden, werden die Foren zu der zugeordneten Kategorie angezeigt. Ist diese Angabe aktiviert, wird auf der Hauptseite von UBB eine Listung nach Kategorien angezeigt. Wenn Sie keine Kategorien verwenden, m&uuml;ssen Sie hier NEIN aktivieren.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"CategoryView\" VALUE=\"yes\" $CategoryViewOn> Ja<br>
<INPUT TYPE=\"RADIO\" NAME=\"CategoryView\" VALUE=\"no\" $CategoryViewOff> Nein");

&InputRadioRow("#f7f7f7", "<p>Nur Kategorien auf der ersten Seite zeigen?", "</b>Bei einer gro&szlig;en Anzahl von Foren ist es durchaus sinnvoll, auf der Startseite nur die Kategorien anzuzeigen, die einzelnen Foren werden dann nicht angezeigt.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"CategoriesOnly\" VALUE=\"true\" $CategoriesOnlyOn> Ja<br>
<INPUT TYPE=\"RADIO\" NAME=\"CategoriesOnly\" VALUE=\"false\" $CategoriesOnlyOff> Nein");

&InputRadioRow("#dedfdf", "<p>Forum-Beschreibungen anzeigen?", "</b>Hier wird unter jedem Forum die ausf&uuml;hrlichere Beschreibung dargestellt.<p>", "<INPUT TYPE=\"RADIO\" NAME=\"ForumDescriptions\" VALUE=\"yes\" $ForumDescriptionsOn> Ja<br>
<INPUT TYPE=\"RADIO\" NAME=\"ForumDescriptions\" VALUE=\"no\" $ForumDescriptionsOff> Nein");

&InputRadioRow("#f7f7f7", "<p>Link zu den COPPA-Hinweisen zeigen ?", "</b>Sie k&ouml;nnen einen Link zu Ihren COPPA-Hinweisen auf jeder UBB-Seite anzeigen.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"ShowPrivacyLink\" VALUE=\"ON\" $ShowPrivacyLinkON> Ja<br>
<INPUT TYPE=\"RADIO\" NAME=\"ShowPrivacyLink\" VALUE=\"OFF\" $ShowPrivacyLinkOFF> Nein");

&InputAreaRow("#dedfdf", "<p>Regeln Ihres UBB", "Hier k&ouml;nnen Sie den Text mit Regeln und Hinweisen zu Ihrem UBB definieren, dieser wird bei der Registration eines neuen Mitglieds angezeigt.</p>", "BBRules", "35", "8");
&InputAreaRow("#f7f7f7", "<p>Vorwort zu COPPA bei Registration anzeigen?", "Bei Anwendung der COPPA-Pr&uuml;fung wird vor der eigentlichen Registration dieser Text angezeigt.</p>", "COPPAWording", "35", "8");
&InputAreaRow("#dedfdf", "<p>COPPA-Anweisungstext", "Dieser Text wird an nach Registration eines Mitglieds mit dem Alter von 13 oder weniger Jahren versandt. Hier k&ouml;nnen Sie die genaue Verfahrensweise zur rechtm&auml;&szlig;igen Registration beschreiben.</p>", "COPPAInstructions", "35", "8");
&InputAreaRow("#f7f7f7", "Copyright-Hinweise", "Dieser Hinweis erscheint direkt unter jeder Seite vor dem Copyright-Hinweis von UBB. Sie k&ouml;nnen dieses Feld leer lassen.</p>", "YourCopyrightNotice", "30", "3");

&InputRadioRow("#dedfdf", "Infopop Copyright", "Die UBB-Lizenz <b>verlangt die sichtbare Anzeige</b> des Infopop-Copyrights auf allen Seiten. Sie k&ouml;nnen den Copyright-Hinweis entweder als Text oder Grafik anzeigen lassen.", "<INPUT TYPE=\"RADIO\" NAME=\"showcopytype\" VALUE=\"image\" $showcopytypeIMAGE> Bild<br>
<INPUT TYPE=\"RADIO\" NAME=\"showcopytype\" VALUE=\"text\" $showcopytypeTEXT> Text");

&InputRadioRow("#f7f7f7", "Anzeige von eMail-Adressen unterbinden?", "Standardm&auml;&szlig;ig werden eMail-Adressen von registrierten Benutzern bei Beitr&auml;gen angezeigt. Sie k&ouml;nnen diese Anzeige generell unterbinden. F&uuml;r Administratoren oder Moderatoren bleiben die eMail-Adressen in der Systemadministration von UBB sichtbar.", "<INPUT TYPE=\"RADIO\" NAME=\"EmailBlock\" VALUE=\"ON\" $EmailBlockOn> eMail-Adressen nicht anzeigen<BR>
<INPUT TYPE=\"RADIO\" NAME=\"EmailBlock\" VALUE=\"OFF\" $EmailBlockOff> eMail-Adressen anzeigen");

&InputRadioRow("#dedfdf", "Signaturen erlauben?", "Benutzer k&ouml;nnen in ihrem Profil eine Signatur definieren, die bei jedem Beitrag am Ende angezeigt werden. In Signaturen kann UBB-Code, jedoch kein HTML-Code verwendet werden. Der UBB-Code f&uuml;r Grafiken kann standardm&auml;&szlig;ig nicht verwendet werden.", "<INPUT TYPE=\"RADIO\" NAME=\"AllowSignature\" VALUE=\"YES\" $AllowSigYes> Signaturen erlauben<BR>
<INPUT TYPE=\"RADIO\" NAME=\"AllowSignature\" VALUE=\"NO\" $AllowSigNo> Keine Signaturen erlauben");

&InputRadioRow("#f7f7f7", "Grafiken in Signaturen erlauben?", "Sie k&ouml;nnen Ihren Benutzern die Verwendung des UBB-Image-Codes innerhalb ihrer Signaturen erlauben.", "<INPUT TYPE=\"RADIO\" NAME=\"AllowSignatureImage\" VALUE=\"YES\" $AllowSigImageYes> Grafiken in Signaturen erlauben<BR>
<INPUT TYPE=\"RADIO\" NAME=\"AllowSignatureImage\" VALUE=\"no\" $AllowSigImageNo> Keine Grafiken in Signaturen erlauben");


&InputRadioRow("#dedfdf", "Anzeige der Gesamtmenge von Themen und/oder Beitr&auml;gen?", "Auf der ersten Seite von UBB bei der Auflistung von Kategorien und Foren kann die Gesamtmenge der Themen und/oder Beitr&auml;ge des jeweiligen Forums angezeigt werden.", "<INPUT TYPE=\"RADIO\" NAME=\"ForumTotalOption\" VALUE=\"Topics\" $FTOTopics> Zeige Gesamtmenge der Themen<BR>
<INPUT TYPE=\"RADIO\" NAME=\"ForumTotalOption\" VALUE=\"Posts\" $FTOPosts> Zeige Gesamtmenge der Beitr&auml;ge<BR>
<INPUT TYPE=\"RADIO\" NAME=\"ForumTotalOption\" VALUE=\"Both\" $FTOBoth> Zeige Gesamtmenge der Themen und Beitr&auml;ge");

&InputRadioRow("#f7f7f7", "Reihenfolge der Anzeige der Themen/Beitr&auml;ge?", "Standardm&auml;&szlig;ig (und empfohlen) werden Beitr&auml;ge in chronologischer Reihenfolge angezeigt. Sie k&ouml;nnen die Reihenfolge umkehren (&Auml;ltester Beitrag zuerst!) Diese Einstellung gilt nur f&uuml;r HTML-Seiten der Foren.", "<INPUT TYPE=\"RADIO\" NAME=\"ReverseThreads\" VALUE=\"FALSE\" $ReverseThreadOff> Neuester Beitrag zuerst<BR>
<INPUT TYPE=\"RADIO\" NAME=\"ReverseThreads\" VALUE=\"TRUE\" $ReverseThreadOn> &Auml;ltester Beitrag zuerst");


&InputRadioRow("#dedfdf", "Anzeige der Mitgliederanzahl?", "Auf der Startseite von UBB k&ouml;nnen Sie die Gesamtzahl Ihrer Mitglieder anzeigen lassen.", "<INPUT TYPE=\"RADIO\" NAME=\"DisplayMemberTotal\" VALUE=\"true\" $MemberTotalOn> Mitgliederanzahl anzeigen<BR>
<INPUT TYPE=\"RADIO\" NAME=\"DisplayMemberTotal\" VALUE=\"false\" $MemberTotalOff> Mitgliederanzahl nicht anzeigen");

&InputAreaRow("#f7f7f7", "HTML-Header", "Sie k&ouml;nnen eine Kopfzeile definieren, die in dem HEAD-Bereich der meisten UBB-Seiten angezeigt werden. Hier k&ouml;nnen Sie eigene Meta-Tags oder CSS-Variablen usw. definieren. Beachten Sie, da&szlig; der Code innerhalb der HEAD-Definition der HTML-Seiten eingef&uuml;gt wird. Bitte f&uuml;gen Sie HTTP-EQUIV=\"Pragma\" nicht ein, da dies bereits durch UBB geschieht. Dieses Feld k&ouml;nnen Sie leer lassen.", "HeaderInsert", "30", "5");


&InputRadioRow("#dedfdf", "Nachrichten-Icons erlauben?", "Bei jedem Beitrag kann ein Benutzer aus einer Auswahl von Icons (z.B. Smileys, Ausrufezeichen o.a.) eines seiner Beitrag zuordnen!", "<INPUT TYPE=\"RADIO\" NAME=\"AllowIcons\" VALUE=\"TRUE\" $IconsOn> Ja<BR>
<INPUT TYPE=\"RADIO\" NAME=\"AllowIcons\" VALUE=\"FALSE\" $IconsOff> Nein");

&InputRadioRow("#f7f7f7", "Antwort mit Zitat erlauben?", "Wenn Sie diese Funktion aktivieren, kann ein Benutzer einen Beitrag eines anderen Benutzers in seiner Antwort zitieren.", "<INPUT TYPE=\"RADIO\" NAME=\"ReplyQuote\" VALUE=\"YES\" $ReplyQuoteOn> Ja<BR>
<INPUT TYPE=\"RADIO\" NAME=\"ReplyQuote\" VALUE=\"NO\" $ReplyQuoteOff> Nein");


&InputRadioRow("#dedfdf", "Inline-Frame bei Antwort auf einen Beitrag einf&uuml;gen?", "Um die Antwort auf einen Beitrag zu erleichtern, k&ouml;nnen Sie ein Inline-Frame mit dem Original-Beitrag anzeigen lassen. Achtung: Einige Browser k&ouml;nnen keine Inline-Frames darstellen, bei diesen wird anstelle dessen ein Link zur Original-Nachricht dargestellt.", "<INPUT TYPE=\"RADIO\" NAME=\"InlineFrame\" VALUE=\"TRUE\" $InlineOn> Inline-Frame anzeigen<BR>
<INPUT TYPE=\"RADIO\" NAME=\"InlineFrame\" VALUE=\"FALSE\" $InlineOff> Inline-Frame nicht anzeigen");

print<<THIS5;
<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Maximale Anzeige der Themen pro Seite</B><BR></FONT>
</td><td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Bitte w&auml;hlen Sie:<BR><SELECT NAME="ForumDisplayMax">
	<OPTION value="25" $FDM25>25 Themen pro Seite
	<OPTION value="35" $FDM35>35 Themen pro Seite
	<OPTION value="40" $FDM40>40 Themen pro Seite
	<OPTION value="50" $FDM50>50 Themen pro Seite
	<OPTION value="75" $FDM75>75 Themen pro Seite
	<OPTION value="NONE" $FDMNONE>Kein Maximum

</SELECT>
</FONT>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Maximale Anzeige der Beitr&auml;ge pro Thema (HMTL-Seiten)</B><BR></FONT>
</td><td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Bitte w&auml;hlen Sie:<BR><SELECT NAME="HTMLDisplayMax">
	<OPTION value="15" $HDM15>15 Beitr&auml;ge pro Seite
	<OPTION value="25" $HDM25>25 Beitr&auml;ge pro Seite
	<OPTION value="35" $HDM35>35 Beitr&auml;ge pro Seite
	<OPTION value="40" $HDM40>40 Beitr&auml;ge pro Seite
	<OPTION value="50" $HDM50>50 Beitr&auml;ge pro Seite
	<OPTION value="75" $HDM75>75 Beitr&auml;ge pro Seite
	<OPTION value="NONE" $HDMNONE>Kein Maximum

</SELECT>
</FONT>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Hot!-Funktion verwenden?</B><BR>
<font size="1" face="Verdana, Arial">Diese Funktion hebt Themen mit besonders hoher Aktivit&auml;t hervor. Die Icons werden mit einer animierten Flamme dargestellt. Die Mindestmenge der Beitr&auml;ge pro Thema kann rechts eingegeben werden.</font>
<P>
<input type="radio" name="HotIcons" value="ON" $HotIconsOn> Hot! benutzen
<BR>
<input type="radio" name="HotIcons" value="OFF" $HotIconsOff> Hot! nicht benutzen
</FONT>
</td><td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><b>Wieviel Antworten m&uuml;ssen f&uuml;r Hot! vorhanden sein?</b><P>
<center><b>Mindestens:</b> <input type="text" name="HotCount" value="$HotCount" size="2" maxlength="3"> Antworten</center>
</FONT>
</td></tr>

</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">SUCH-OPTIONEN</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B><p>UBB enth&auml;lt eine eigenen Suchmaschine, welchen den Benutzern erlaubt, nach diversen Kriterien in den Beitr&auml;gen zu suchen. Diese Funktion kann den Server stark belasten. Bedingt durch die Belastung k&ouml;nnen Sie die Suche deaktivieren. UBB verwendet eigene Index-Dateien f&uuml;r den Such-Proze&szlig;. Diese Index-Dateien k&ouml;nnen auf zwei Arten erstellt werden: Eine Index-Datei f&uuml;r alle Foren oder je Forum eine individuelle Index-Seite. Pro und Kontras zu beiden Methoden: Sie haben viele Foren jedoch wenig Beitr&auml;ge und verwenden dann eine Index-Seite f&uuml;r die Suche, dieses sollte die Suche beschleunigen. Wenn Sie weniger Foren aber viele Beitr&auml;ge haben, verwenden Sie je Forum eine Index-Datei. Wenn Sie von einer zur anderen Methode wechseln, m&uuml;ssen Sie die Index-Dateien generell neu erstellen.</B></p></FONT>
</td></tr>
THIS5

&InputRadioRow("#f7f7f7", "Suche erlauben?", "Wenn Sie Ihren Benutzern die Suche nicht erlauben m&ouml;chten, schalten Sie diese Funktion aus. Der Link zur Suchfunktion wird dann in UBB nicht dargestellt.", "<INPUT TYPE=\"RADIO\" NAME=\"AllowSearch\" VALUE=\"TRUE\" $AllowSearchOn> Suche erlauben<BR>
<INPUT TYPE=\"RADIO\" NAME=\"AllowSearch\" VALUE=\"FALSE\" $AllowSearchOff> Suche nicht erlauben");


&InputRadioRow("#dedfdf", "Suche in allen Foren erlauben?", "Das Suchen durch alle vorhandenen Foren kann den Server sehr stark belasten, auch wenn es eine komfortable Funktion f&uuml;r Ihre Benutzer darstellt. Wenn Sie diese Funktion deaktivieren, k&ouml;nnen Ihre Benutzer trotzdem in dem jeweiligen Forum suchen.", "<INPUT TYPE=\"RADIO\" NAME=\"AllowTotalSearch\" VALUE=\"TRUE\" $AllowTotalSearchOn> Suche in allen Foren aktivieren<BR>
<INPUT TYPE=\"RADIO\" NAME=\"AllowTotalSearch\" VALUE=\"FALSE\" $AllowTotalSearchOff> Suche in allen Foren deaktivieren");

&InputRadioRow("#f7f7f7", "Index-Methode", "Standardm&auml;&szlig;ig wird je Forum eine Index-Datei erstellt (Siehe Erkl&auml;rungen oben).", "<INPUT TYPE=\"RADIO\" NAME=\"IndexMethod\" VALUE=\"PERFORUM\" $IndexMethodPer> Eine Index-Datei je Forum erzeugen <BR>
<INPUT TYPE=\"RADIO\" NAME=\"IndexMethod\" VALUE=\"ONEFILE\" $IndexMethodOne> Eine Index-Datei f&uuml;r alle Foren erzeugen");

print<<THIS58;
</TABLE>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">EMAIL - OPTIONEN</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<p><B>UBB bietet zwei Varianten zur Behandlung von eMails an. Die bevorzugte Methode ist die Verwendung Ihres SMTP-Servers durch entsprechende Perl-Socket-Module. Hierf&uuml;r m&uuml;ssen Sie einen eMail- oder generellen Zugriff auf einen SMTP-Server besitzen. Ebenfalls m&uuml;ssen die entsprechenden Perl-Socket-Module auf Ihrem Server installiert sein. Die Alternative dazu ist die Verwendung von UNIX sendmail. Sie m&uuml;ssen einen UNIX-Server verwenden, der die Benutzung von Sendmail zul&auml;&szlig;t.</B></FONT></p>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Email An/Aus</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Um alle eMail-Funktionen von UBB zu nutzen, aktivieren Sie diese Funktion. Damit aktivieren Sie die Funktionen \"Kennwort vergessen\", \"Registrations-&Uuml;berpr&uuml;fung (Kennwort-Versand) per eMail\", \"Abonnements\", \"eMail-Versand an alle registrierten Benutzer\", \"Moderator-Benachrichtigung\" sowie weitere Funktionen, welche den Versand einer eMail erfordern.</p></FONT>

</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><INPUT TYPE="RADIO" NAME="UseEmail" VALUE="ON" $EmailOn> eMail-Funktionen aktivieren<BR>
<INPUT TYPE="RADIO" NAME="UseEmail" VALUE="OFF" $EmailOff> eMail-Funktionen deaktivieren</FONT>
</td></tr>


<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>eMail-Konfiguration</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Benutzer eines Unix/Linux-Servers verwenden am einfachsten sendmail zum Versand der eMails. Windows NT/PWS-Server m&uuml;ssen die SMTP-Option verwenden.</p></FONT>

</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">
<INPUT TYPE="RADIO" NAME="SMTPEmail" VALUE="Off" $SMTPOff> SendMail [Nur Unix/Linux]<br>
<INPUT TYPE="RADIO" NAME="SMTPEmail" VALUE="On" $SMTPOn> SMTP [WinNT/32]</FONT>

</td></tr>



<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Absoluter Pfad zu sendmail [Nur Unix/Linux]</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Sie m&uuml;ssen hier den korrekten Pfad zu sendmail angeben, z.B. /usr/bin/sendmail</font></p>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="SendMailLocation" VALUE="$SendMailLocation" SIZE=25 MAXLENGTH=50>
</td></tr>


<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Name des SMTP-Servers [WinNT/32]</B></FONT><br>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Dies ist der Name des SMTP-Servers, welchen Sie zum Versand von eMails nutzen m&ouml;chten, wie z.B. smtp.yourdomain.com oder mail.yourdomain.com. Es k&ouml;nnte genauso nur Ihr Domainname, Ihre IP-Adresse oder ein spezieller Server-Name Ihres ISP sein. Wenn Sie sendmail benutzen, lassen Sie dieses Feld leer.</font></p>
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial">
<INPUT TYPE="TEXT" NAME="EmailServer" VALUE="$EmailServer" SIZE=25 MAXLENGTH=50>
</td></tr>


<tr bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>UBBFriend</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Hier k&ouml;nnen Sie UBBFriend f&uuml;r Ihre Benutzer konfigurieren. UBBFriend stellt die M&ouml;glichkeit dar, andere Internet-Benutzer per eMail &uuml;ber einen interessanten Beitrag zu informieren. Hinweis: eMail-Funktionen m&uuml;ssen f&uuml;r UBBFriend aktiviert sein!</p></FONT>
<CENTER><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080">
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><INPUT TYPE="RADIO" NAME="UBBFriendUSE" VALUE="ON" $UBBFriendON> An <BR>
<FONT SIZE="2" FACE="Verdana, Arial"><INPUT TYPE="RADIO" NAME="UBBFriendUSE" VALUE="OFF" $UBBFriendOFF> Aus </FONT><br>
<FONT SIZE="2" FACE="Verdana, Arial"><INPUT TYPE="RADIO" NAME="UBBFriendUSE" VALUE="RegUsers" $UBBFriendREGONLY> Nur f&uuml;r registrierte Benutzer verf&uuml;gbar</FONT>
</CENTER>
</td></tr>

</table>
<P>

<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">DATUM- UND ZEIT-OPTIONEN</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<p><B>UBB kann Datums- und Zeitangaben in verschiedenen Syntax darstellen. Alle Datums- und Zeitangaben basieren auf den von Ihrem Server vorgegebenen Werten. Sie k&ouml;nnen die Zeitunterschiede zwischen Ihrem Server-Standort und Ihrem pers&ouml;nlichen Standort im Offset-Feld &auml;ndern. Beispiel: Sie leben in an der Ostk&uuml;ste Amerikas, Ihr Server steht jedoch an der Westk&uuml;ste der USA - dann verwenden Sie die Zeitzone EST zur Anzeige, m&uuml;ssen jedoch zu der Server-Zeit 3 Stunden addieren (in dem Sie eine 3 in das Offset-Feld eingeben). Ist Ihr Zeitunterschied negativ, geben Sie diesen bitte auch als negative Zahl (z.B. -2) ein.</B></FONT></p>
</td></tr>
THIS58

&InputTextRow("#dedfdf", "<p>Zeitzone", "</b>Hier geben Sie Ihre aktuelle Zeitzone wie z.B. US, GMT oder EST ein. Dieses Feld k&ouml;nnen Sie leer lassen.</p>", "TimeZone", "20", "35");

&InputTextRow("#f7f7f7", "<p>Offset des Servers", "</b>Hier geben Sie den Zeitunterschied Ihres Standorts zum Server in Stunden ein. Der Standardwert ist 0.</p>", "TimeZoneOffset", "3", "4");

&InputRadioRow("#dedfdf", "Format des Datums", "Das europ&auml;ische Format ist TT-MM-JJ, in den USA jedoch MM-TT-JJ. Erweiterte Formate zeigen den vollen Monatsnamen.", "<INPUT TYPE=\"RADIO\" NAME=\"DateFormat\" VALUE=\"US\" $DateUS> US Format (04-25-98)<BR>
<INPUT TYPE=\"RADIO\" NAME=\"DateFormat\" VALUE=\"USX\" $DateUSX> Erweitertes US Format (April 25, 1998)<BR>
<INPUT TYPE=\"RADIO\" NAME=\"DateFormat\" VALUE=\"Euro\" $DateEuro> Europ&auml;isches Format (25.04.98)<BR>
<INPUT TYPE=\"RADIO\" NAME=\"DateFormat\" VALUE=\"EuroX\" $DateEuroX> Erweitertes europ&auml;isches Format (25. April 1998)");

&InputRadioRow("#f7f7f7", "Format der Zeit", "Sie k&ouml;nnen zwischen 12 Stunden-Format (AM/PM) oder 24-Stunden-Format w&auml;hlen.", "
<INPUT TYPE=\"RADIO\" NAME=\"TimeFormat\" VALUE=\"AMPM\" $TimeAMPM> AM/PM Zeit-Format<BR>
<INPUT TYPE=\"RADIO\" NAME=\"TimeFormat\" VALUE=\"24HR\" $Time24HR> 24-Stunden-Format (23:15)");


print<<THIS6;
</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">REGISTRATIONS-OPTIONEN</FONT></B>
</TD></TR>
<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Hier k&ouml;nnen Sie die verschiedenen Einstellungen zur Registration vornehmen:</B></FONT>
</td></tr>
THIS6

&InputRadioRow("#dedfdf", "eMail-Adresse des Benutzers &uuml;berpr&uuml;fen?", "Um eine h&ouml;here Sicherheit zu erhalten, aktivieren Sie diese Funktion. Der Benutzer erh&auml;lt dann sein Zugangskennwort zu Ihrem UBB per eMail &uuml;bermittelt, und kann erst nach Erhalt Nachrichten verfassen.", "<INPUT TYPE=\"RADIO\" NAME=\"EmailVerify\" VALUE=\"ON\" $EmailVerifyOn> Ja<br>
<INPUT TYPE=\"RADIO\" NAME=\"EmailVerify\" VALUE=\"OFF\" $EmailVerifyOff> Nein");

&InputRadioRow("#F7F7F7", "Auf doppelte eMail &uuml;berpr&uuml;fen?", "Standardm&auml;&szlig;ig ist die Registration eines Benutzers nur einmal je angegebener eMail-Adresse m&ouml;glich.", "<INPUT TYPE=\"RADIO\" NAME=\"EmailCheck\" VALUE=\"true\" $EmailTrue> &Uuml;berpr&uuml;fung aktivieren<br>
<INPUT TYPE=\"RADIO\" NAME=\"EmailCheck\" VALUE=\"false\" $EmailFalse> &Uuml;berpr&uuml;fung deaktivieren");

&InputRadioRow("#dedfdf", "Children's Online Privacy Protection [COPPA]", "Mit dieser Option wird nach dem amerikanischen COPPA-Gesetz eine Alters&uuml;berpr&uuml;fung vorgenommen. Benutzer mit einem Alter von 13 oder weniger Jahren ben&ouml;tigen die schriftliche Einwilligung ihrer Eltern oder Erziehungsberechtigten. Ist diese Funktion aktiviert, wird bei der Registration das Alter abgefragt. Unterliegt ein Benutzer dem COPPA-Gesetz, wird eine besondere Registrationsseite angezeigt. <b>Hinweis:</b> Das COPPA-Gesetz gilt auch f&uuml;r deutsche Websites, die auf einem <b>amerikanischen</b> Server installiert sind.", "<INPUT TYPE=\"RADIO\" NAME=\"COPPACheck\" VALUE=\"ON\" $COPPACheckON>  COPPA aktivieren<br><INPUT TYPE=\"RADIO\" NAME=\"COPPACheck\" VALUE=\"OFF\" $COPPACheckOFF> COPPA deaktivieren");

&InputRadioRow("#dedfdf", "COPPA - Typ", "Bitte whlen Sie, wie Sie COPPA verwenden mchten.", "<INPUT TYPE=\"radio\" NAME=\"COPPAType\" VALUE=\"COPPAReg\" $COPPARegOn>  Online-Registration erlauben<br><INPUT TYPE=\"radio\" NAME=\"COPPAType\" VALUE=\"COPPAFormOnly\" $COPPAFormOnlyOn> Nur die druckbare Version anzeigen<br><INPUT TYPE=\"radio\" NAME=\"COPPAType\" VALUE=\"COPPADenied\" $COPPADeniedOn> Keine COPPA-pflichtigen Benutzer erlauben");

&InputRadioRow("#F7F7F7", "&Uuml;berpr&uuml;fung neuer Registrationen", "Standardm&auml;&szlig;ig kann sich ein neuer Benutzer ohne &Uuml;berpr&uuml;fung des Website-Betreibers anmelden und nach Erhalt seines Kennworts direkt Beitr&auml;ge verfassen. Mit dieser Option k&ouml;nnen Sie eine manuelle Freischaltung neuer Benutzer durch die Administration aktivieren. Benutzer k&ouml;nnen dann nur nach Freischaltung durch einen Administrator Beitr&auml;ge verfassen oder auf vorhandene Beitr&auml;ge antworten.", "<INPUT TYPE=\"RADIO\" NAME=\"ModerateRegs\" VALUE=\"ON\" $ModerateRegsON> Freischaltung aktivieren<br>
<INPUT TYPE=\"RADIO\" NAME=\"ModerateRegs\" VALUE=\"OFF\" $ModerateRegsOFF> Freischaltung deaktivieren");

&InputRadioRow("#dedfdf", "Information an den Administrator bei neuer Registration?", "UBB kann dem Administrator eine eMail zur Information senden, sobald sich ein neuer Benutzer registriert hat.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"OnRegsNotifyAdmin\" VALUE=\"ON\" $OnRegsNotifyAdminON> Information bei jeder Registration<br>
<INPUT TYPE=\"RADIO\" NAME=\"OnRegsNotifyAdmin\" VALUE=\"OFF\" $OnRegsNotifyAdminOFF> Keine Information<br><INPUT TYPE=\"RADIO\" NAME=\"OnRegsNotifyAdmin\" VALUE=\"COPPA\" $OnRegsNotifyAdminCOPPA> Information nur bei COPPA-pflichtigen Benutzern");

&InputTextRow("#f7f7f7", "<p>eMail-Adresse f&uuml;r die Information bei neuer Registration", "</b>An diese eMail-Adresse werden die o.g. Informationen bei neuen Registrationen versandt. Diese Adresse ist gleichzeitig auch die ver&ouml;ffentlichte Kontakt-Adresse bei Fragen zur Registration in Ihrem UBB.</p>", "RegsAdminEmail", "40", "88");

&InputRadioRow("#dedfdf", "Registration erlauben?", "Zu Service-Zwecken oder anderen Gelegenheiten k&ouml;nnen Sie die Registration neuer Benutzer deaktivieren.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"SuspendRegister\" VALUE=\"true\" $SRTrue> Keine neuen Benutzer aktzeptieren.<br>
<INPUT TYPE=\"RADIO\" NAME=\"SuspendRegister\" VALUE=\"false\" $SRFalse> Neue Benutzer aktzeptieren.");
&InputRadioRow("#f7f7f7", "Registrations-Felder in Ihrem UBB benutzen?", "Lassen Sie diese Funktion immer auf <u>Ja</u>, solange auch nur eines Ihrer Foren eine Registration verlangt. Wenn Sie Ihr UBB v&ouml;llig offen und ohne jegliche Registration verwenden m&ouml;chten, aktivieren Sie Nein.</p>", "<INPUT TYPE=\"RADIO\" NAME=\"DisplayRegistration\" VALUE=\"YES\" $DisplayRegYes> Ja<BR>
<INPUT TYPE=\"RADIO\" NAME=\"DisplayRegistration\" VALUE=\"NO\" $DisplayRegNo> Nein");

print<<THIS7;
</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">ZUS&Auml;TZLICHE OPTIONEN</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Weitere Optionen zu Ihrem UBB:</B></FONT>
</td></tr>
THIS7

&InputRadioRow("#dedfdf", "UBB aktivieren?", "Hier k&ouml;nnen Sie zu Service- oder anderen Zwecken Ihr UBB deaktivieren, die Benutzer erhalten entsprechend einen Hinweis.", "<INPUT TYPE=\"RADIO\" NAME=\"BBStatus\" VALUE=\"ON\" $BBStatusOn> UBB aktivieren
<BR>
<INPUT TYPE=\"RADIO\" NAME=\"BBStatus\" VALUE=\"OFF\" $BBStatusOff> UBB deaktivieren");

&InputAreaRow("#f7f7f7", "<p>Nachricht bei deaktiviertem UBB", "Hier k&ouml;nnen Sie die Nachricht konfigurieren, die ein Benutzer bei Zugriff auf ein deaktiviertes UBB angezeigt bekommt.</p>", "BBClosedMessage", "35", "8");

&InputTextRow("#f7f7f7", "<p>Minimale Anzahl der erstellten Nachrichten, um vollwertiges Mitglied zu werden.", "</b>Registrierte Benutzer hei&szlig;en Junior-Mitglieder. Nach einer von Ihnen definierten Menge an erstellten Beitr&auml;gen wechselt der Benutzer zum Status Mitglied. Standardm&auml;&szlig;ig sind 31 Beitr&auml;ge definiert.</p>", "MemberMinimum", "5", "5");

print<<THIS8;
<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Alternative Benutzer-Titel?</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Es existieren vier verschiedene Titel f&uuml;r Mitglieder: Administratoren, Moderatoren, Mitglieder und Junior-Mitglieder. Hier k&ouml;nnen Sie indiviudelle Titel (so z.B. Gefreiter, Feldwebel, Hauptmann und Major!) definieren.</FONT></p>
</td>
<td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial">
Administrator:<BR>
<INPUT TYPE="TEXT" NAME="AdminTitle" VALUE="$AdminTitle" SIZE=20 MAXLENGTH=60>
<P>
Moderator:<BR>
<INPUT TYPE="TEXT" NAME="ModeratorTitle" VALUE="$ModeratorTitle" SIZE=20 MAXLENGTH=60>
<P>
Mitglied:<BR>
<INPUT TYPE="TEXT" NAME="MemberTitle" VALUE="$MemberTitle" SIZE=20 MAXLENGTH=60>
<P>
Junior-Mitglied:</font>
<BR><INPUT TYPE="TEXT" NAME="JrMemberTitle" VALUE="$JrMemberTitle" SIZE=20 MAXLENGTH=60>
</td></tr>
<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Zensor-Option</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Mit dieser Option k&ouml;nnen Sie unerw&uuml;nschte Begriffe oder Worte in Ihrem UBB zensieren, diese werden durch Sternchen ersetzt.</p><p>Bitte beachten Sie die Hinweise zur Zensur-Option auf der rechten Seite!</p></FONT>
<CENTER><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080"><INPUT TYPE="RADIO" NAME="Censor" VALUE="ON" $CensorOn> Ja
<INPUT TYPE="RADIO" NAME="Censor" VALUE="OFF" $CensorOff> Nein
</FONT></CENTER>
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Zensierte Begriffe</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Tragen Sie hier alle Worte oder Begriffe ein, die zensiert werden sollen. Benutzen Sie keine Kommas, trennen Sie die Worte einfach durch einen Leerschritt. Beachten Sie, da&szlig; Worte die einen Teil eines zensierten Wortes beinhalten, zensiert werden. Um einzelne Begriffe genauer zu zensieren, setzen Sie diese in spitze Klammern. So wird das Wort {Doof} als "****" dargestellt, Doofkopf jedoch nicht.
</FONT><BR>
<TEXTAREA NAME="censorwords" ROWS=3 COLS=30 WRAP="VIRTUAL">$censorwords
</TEXTAREA>
</td></tr>
THIS8

&InputRadioRow("#dedfdf", "D&uuml;rfen Beitr&auml;ge editiert werden?", "Administratoren und Moderatoren k&ouml;nnen immer Beitr&auml;ge editieren oder l&ouml;schen, Sie k&ouml;nnen diese Funktion ebenfalls Benutzern ausschlie&szlig;lich f&uuml;r die eigenen Beitr&auml;ge zur Verf&uuml;gung stellen.", "<FONT SIZE=\"2\" FACE=\"Verdana, Arial\"><INPUT TYPE=\"RADIO\" NAME=\"EditOption\" VALUE=\"ON\" $EditOptionOn> Ja<BR>
<INPUT TYPE=\"RADIO\" NAME=\"EditOption\" VALUE=\"NODELETE\" $EditOptionND> Ja, aber kein L&ouml;schen der Beitr&auml;ge<BR>
<INPUT TYPE=\"RADIO\" NAME=\"EditOption\" VALUE=\"OFF\" $EditOptionOff> Nein</FONT>
");

&InputRadioRow("#f7f7f7", "IP-Nummern protokollieren?", "Aus Sicherheitsgr&uuml;nden k&ouml;nnen Sie die IP-Nummer des Benutzers protokollieren, der einen Beitrag erstellt.", "<INPUT TYPE=\"RADIO\" NAME=\"IP\" VALUE=\"ON\" $IPOn> IP protokollieren & im Beitrag anzeigen <BR>
<INPUT TYPE=\"RADIO\" NAME=\"IP\" VALUE=\"LOGONLY\" $IPLO> IP protokollieren aber nicht anzeigen<BR>
<INPUT TYPE=\"RADIO\" NAME=\"IP\" VALUE=\"OFF\" $IPOff> IP nicht protokollieren");

&InputRadioRow("#dedfdf", "Administrations-Zugriffe protokollieren?", "Aus Sicherheitsgr&uuml;nden k&ouml;nnen Sie alle Zugriffe auf die Administration von UBB protokollieren lassen, das Protokoll wird im NonCGI-Banlist-Verzeichnis gespeichert.", "<INPUT TYPE=\"RADIO\" NAME=\"log_admin_activity\" VALUE=\"YES\" $log_admin_activityON> Zugriffe protokollieren<BR>
<INPUT TYPE=\"RADIO\" NAME=\"log_admin_activity\" VALUE=\"NO\" $log_admin_activityOFF> Zugriffe nicht protokollieren");

&InputRadioRow("#f7f7f7", "Cookies", "Wenn Sie mehrere UBBs auf einem Domain(Server) installieren, k&ouml;nnen Sie hier die Cookies explizit f&uuml;r jedes UBB setzen lassen.", "<INPUT TYPE=\"RADIO\" NAME=\"SetCookies\" VALUE=\"DirectorySpecific\" $COOKIESDS> Cookies nur f&uuml;r dieses UBB<BR>
<INPUT TYPE=\"RADIO\" NAME=\"SetCookies\" VALUE=\"Broad\" $COOKIESBroad> Cookies f&uuml;r das gesamte Domain");

&InputRadioRow("#dedfdf", "Informationen &uuml;ber den Autor?", "Bei jedem Beitrag k&ouml;nnen &uuml;ber den Autor diverse Informationen angezeigt werden. Standardm&auml;ssig wird nur der Benutzername angezeigt.", "<INPUT TYPE=\"RADIO\" NAME=\"AuthorColumn\" VALUE=\"Minimum\" $MinimumAC> Nur Benutzernamen und Status anzeigen.<BR>
<INPUT TYPE=\"RADIO\" NAME=\"AuthorColumn\" VALUE=\"PostTotal\" $PostTotalAC> Benutzername, Status, Datum der Registration und Anzahl der erstellten Beitr&auml;ge anzeigen.<BR><INPUT TYPE=\"RADIO\" NAME=\"AuthorColumn\" VALUE=\"Location\" $LocationAC> Alles oben genannte plus Wohnort des Autors.<BR>");

&InputRadioRow("#f7f7f7", "<p>Spalte mit Moderatoren anzeigen?", "</b>Hier k&ouml;nnen Sie die Anzeige der Moderatoren in der &Uuml;bersicht von UBB ein- und ausschalten.<p>", "<INPUT TYPE=\"radio\" NAME=\"ShowMods\" VALUE=\"yes\" $ShowModsOn> Ja<br>
<INPUT TYPE=\"RADIO\" NAME=\"ShowMods\" VALUE=\"no\" $ShowModsOff> Nein");

&InputRadioRow("#dedfdf", "Mindestens ein Buchstabe oder eine Zahl im Thema notwendig?", "F&uuml;r jedes Thema ist die Eingabe von mindestens einem Buchstaben oder einer Zahl Pflicht, ansonsten wird der Beitrag nicht erstellt. Dadurch kann das Erstellen von Beitr&auml;gen ohne Thema verhindert werden.", "<INPUT TYPE=\"RADIO\" NAME=\"EnglishSubjectCheck\" VALUE=\"ON\" $ESCON> Ja, Eingabe verlangen!<BR>
<INPUT TYPE=\"RADIO\" NAME=\"EnglishSubjectCheck\" VALUE=\"OFF\" $ESCOFF> Nein");

print qq(
<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><p><B>Flood! Funktion?</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial">Mit dieser Funktion kann das mutwillige mehrfache Erstellen eines Beitrags durch einen Benutzer verhindert werden. Ist die Funktion Flood! aktiviert, k&ouml;nnen Benutzer erst nach einer definierten Zeitspanne wieder einen Beitrag erstellen. Hat ein Benutzer einen Beitrag erstellt, Sie die Funktion Flood! mit 60 Sekunden aktiviert, kann Ihr Benutzer erst nach 60 Sekunden den n&auml;chsten Beitrag verfassen! Administratoren und Moderatoren sind von Flood! ausgenommen.</p></FONT>
<CENTER><FONT SIZE="2" FACE="Verdana, Arial"><INPUT TYPE="RADIO" NAME="FloodCheck" VALUE="ON" $FloodOn> Flood! an
<INPUT TYPE="RADIO" NAME="FloodCheck" VALUE="OFF" $FloodOff> Flood! aus
</FONT></CENTER>
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Flood! Zeitspanne</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial">Bitte geben Sie die Zeitspanne in Sekunden ein, empfohlen 60. Bitte nur die Ziffern der Sekunden eingeben.
</FONT><BR>
<center><input type="text" name="FloodCheckSpan" value="$FloodCheckSpan" size="3" maxlength="4"></center>
</td></tr>
); # end qq
&InputRadioRow("#dedfdf", "SpellChecker.net Modul verwenden?", "Sie knnen Ihren Benutzern die Verwendung eines Rechtschreibprfungsmoduls von <a href=\"http://www.spellchecker.net\" target=\"_blank\">SpellChecker.net</a> erlauben.<br><B>Hinweis:</b> Achten Sie auf die korrekten Einstellungen in der Datei sproxy.ini im UBB-cgi-bin-Verzeichnis!</B>&nbsp;<a href=\"http://www.thinkfactory.de/cgi-bin/faq/ubb/faq.cgi\" target=\"_blank\">Hilfe!</a>", "<INPUT TYPE=\"RADIO\" NAME=\"SpellCheck\" VALUE=\"YES\" $SCKTrue> SpellChecker.net-Modul verwenden<BR>
<INPUT TYPE=\"RADIO\" NAME=\"SpellCheck\" VALUE=\"NO\" $SCKFalse> SpellChecker.net-Modul nicht verwenden");

print<<THIS10
</table>
</td></tr></table>
<P>
<FONT SIZE="1" FACE="Verdana, Arial">
$DiagnosticWording</FONT></B>
<P>
<br>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Bitte identifizieren Sie sich:</font>
<P>
<FONT Size="1" FACE="Verdana, Arial" COLOR="#808000">(HINWEIS: Wenn Sie UBB erstmalig installieren, verwenden Sie den standardm&auml;&szlig;igen Benutzernamen und Kennwort)</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Benutzername: <INPUT TYPE="TEXT" NAME="UserNameCheck" SIZE=25 MAXLENGTH=25>&nbsp;&nbsp;&nbsp;&nbsp; Kennwort <INPUT TYPE="PASSWORD" NAME="PasswordCheck" SIZE=13 MAXLENGTH=13></FONT></B></CENTER>
<p><center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Einstellungen speichern"></center>
</form>
</BODY></HTML>
THIS10
}
} #end do genvars


sub SendStyle {
&VerifyAdminCP($UserName, $Password);
if ($Proceed eq "true") {
	 &DoProcessStyle;
}  
}

sub DoProcessStyle {
	
&log_admin_activity ("DoProcessStyle") if ($log_admin_activity eq 'YES');
	
open (FILE, ">$VariablesPath/Styles.file") or die( &StandardHTML("Die Datei Styles.file konnte nicht zum Schreiben ge&ouml;ffnet werden. $!") );

foreach $one(@in) {
	($Name, $Value) = split ("=", $one);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	$Value =~ s/\@/\\@/g;
	$Value =~ s/"/\\"/g;
		if (($Name ne "UserName") && ($Name ne "Password")) {
	print FILE ("\$$Name = \"$Value\";\n");
	}
}

	print FILE ("1;\n");
close (FILE);
chmod (0777, "$VariablesPath/Styles.file");

$ConfirmLine = "Die optischen Einstellungen wurden gespeichert.<P>Um die ver&auml;nderten Einstellungen in vorhandenen Beitr&auml;gen zu aktivieren, m&uuml;ssen Sie die Funktion \"Update der Beitr&auml;ge\" ausf&uuml;hren. Diese Funktion sollten Sie erst dann durchf&uuml;hren, wenn Sie alle Einstellungen vorgenommen haben.<br>";
&ConfirmHTML2;

} ## END DO PROCESS VARS




sub SetGenVars {

&HackChecker;

### CHECK USERNAME - must be an admin
##verify that this user is an administrator

#check to see which Member Format is in place, process accordingly
if (-e "$MembersPath/memberslist.cgi") {
$ProfileNumber = &GetUserNumber($in{'UserNameCheck'});
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}
}  else {

$ProfileNumber = $UserNameCheckFile;

$NameFound = "no";
  if (-e "$MembersPath/$ProfileNumber.cgi") {
      $NameFound = "yes";
    } 
}

####

if ($NameFound eq "yes") {
	@profilestats = &OpenProfile("$ProfileNumber.cgi");
			chomp($profilestats[1]);
	if ($in{'PasswordCheck'} eq "$profilestats[1]") {
	$Permission = "$profilestats[4]";
	chomp($Permission);
	&CheckPermissions;
	   if ($AdminPermission eq "true") {
	   &DoProcessGenVars;
	   }  else {
	    &StandardHTMLCP("Diese Funktion ist ausschlie&szlig;lich f&uuml;r Administratoren verf&uuml;gbar.");
	   }
	} else {
	&StandardHTMLCP("Das von Ihnen eingegebene Kennwort ist falsch - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	}
}  else {

	unless(-d "$MembersPath") {
		&StandardHTMLCP("Der absolute Pfad zu dem Members-Verzeichnis ist falsch.<p>Bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und &uuml;berpr&uuml;fen Sie Ihre Angaben!");	
	}
	else {
		&StandardHTMLCP("Der von Ihnen eingegebene Benutzername ist in unserem System nicht bekannt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	}


}  ##END IF/ELSE NAME CHECK BLOCK

}  ##END Set Gen Vars

sub DoProcessGenVars {
if ((-e "$in{'NonCGIPath'}/ubbcode.html") && (-e "$in{'CGIPath'}/cpanel.cgi")) {

if ($in{'CategoriesOnly'} eq "true") {
	$in{'CategoryView'} = "yes";
	unless (-e "$in{'NonCGIPath'}/categories.file") {
	die(&StandardHTMLCP("Fehler: Es sind keine Kategorien definiert worden.<p>Bitte stellen Sie die Option der Verwendung von Kategorien auf Nein<br>und speichern Sie die generellen Einstellungen erneut.<p>Neue Kategorien k&ouml;nnen Sie im Men&uuml; Forum-Einstellungen erstellen.<p>Bitte benutzen Sie die ZURUuml;CK-Funktion Ihres Browsers."));	
	}
}


if ($in{'ContactLinkType'} eq 'URL') {
	$ContactLink = $in{'ContactURL'};	
}
else {
	$ContactLink = "mailto:$in{'BBEmail'}";	
	$ContactLink =~ s/@/\\@/g;
}

$ForumsPath = ($ForumsPath || $NonCGIPath); # make sure it is defined for initial configuration

&log_admin_activity ("DoProcessGenVars") if ($log_admin_activity eq 'YES');

&CheckBadChars("$VariablesPath $MembersPath $CGIPath $NonCGIPath $in{'SendMailLocation'}"); # check for invalid chars

open (FILE, ">$VariablesPath/UltBB.setup") or die( &StandardHTMLCP("Die Datei UltBB.setup konnte nicht zum Schreiben ge&ouml;ffnet werden. Hier die genaue Fehlermeldung:</p>$!</p><p>&Uuml;berpr&uuml;fen Sie:</p><ul><li>Das der Pfad $VariablesPath existiert.</li><li>[Unix/Linux] Das die Datei UltBB.setup die Rechte 777 besitzt.</li><li>[Windows NT/32] Das die Verzeichnisse $VariablesPath und $NonCGIPath die Rechte 'Change' oder 'RWXD' f&uuml;r den Benutzer IUSR_$ENV{'COMPUTERNAME'} besitzen. Diese &Auml;nderungen kann nur ein NT-Administrator am Server vornehmen.</li></ul></p>") );

foreach $one(@in) {
	($Name, $Value) = split ("=", $one);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	$Value =~ s/\(/\\(/g;
	$Value =~ s/\)/\\)/g;
	$Value =~ s/\@/\\@/g unless (($Name eq "Header") || ($Name eq "Footer")) ;
	$Value =~ s/"/\\"/g unless (($Name eq "Header") || ($Name eq "Footer"));
	
	
	if ( ($Name eq "RegsAdminEmail") && ($in{$Name} eq '') ) {
	$Value = $in{'BBEmail'};
	$Value =~ s/\@/\\@/g;
	}

	if (($Name eq "HeaderInsert")  || ($Name eq "Header") || ($Name eq "Footer")) {
	$Value = &LimitReturns($Value);
	}

	if (($Name eq "$YourCopyrightNotice") || ($Name eq "BBEmail") || ($Name eq "censorwords")) {
	$Value = &EliminateReturns($Value);
 	}

	if (($Name eq "BBRules") || ($Name eq "COPPAWording") || ($Name eq "COPPAInstructions") || ($Name eq "BBClosedMessage"))  {
	$Value = &ConvertReturns($Value);
	}

	if ( ($Name ne "Header") && ($Name ne "Footer") && ($Name ne "UserNameCheck") && ($Name ne "PasswordCheck") && ($Name ne "Submit") && ($Name ne "EmailBan")) {
	print FILE ("\$$Name = qq\($Value\);\n");
	}
	if (($Name eq "Header") ||  ($Name eq "Footer")) {
	print FILE ("\$$Name = q\($Value\);\n"); # q = no interpolation
	}

	
} # end foreach

	print FILE ('$ContactLink = ' . '"' . $ContactLink . '";' . "\n");
	print FILE ('$ForumsPath = ' . '"' . $NonCGIPath . '";');
	print FILE ("\n1;\n");
close (FILE);

#check for banlist files
unless (-d "$NonCGIPath/BanLists") {
mkdir ("$NonCGIPath/BanLists", 0777) || die (&StandardHTML("In dem Verzeichnis $NonCGIPath konnte kein Unterverzeichnis erstellt werden. Hier die Fehlermeldung:</p><p>$!</p><p>&Uuml;berpr&uuml;fen Sie, ob das NonCGI-Verzeichnis die korrekten Rechte besitzt.</p>") );
chmod(0777, "$NonCGIPath/BanLists");
}

if ($in{'EmailBan'} ne "") {
	$EmailBanList = &EliminateReturns($in{'EmailBan'});
	@BanList = split(/\s/, $EmailBanList);
	open(BAN, ">$NonCGIPath/BanLists/EmailBan.cgi");
	foreach $uno(@BanList) {
		chomp($uno);
		print BAN "$uno\n";
	}
	close(BAN);
	chmod(0777, "$NonCGIPath/BanLists/EmailBan.cgi");
}


# create forum directories and set permissions on directories
unless (-e "$NonCGIPath/Forum7") {
chmod(0777, "$NonCGIPath");
chmod(0755, "$CGIPath");
chmod(0777, "$MembersPath");
chmod(0777, "$MembersPath/Admin5.cgi");

mkdir ("$NonCGIPath/Forum1", 0777) || ($mkdirerror .= "Forum1, ");
chmod(0777, "$NonCGIPath/Forum1");
mkdir ("$NonCGIPath/Forum2", 0777) || ($mkdirerror .= "Forum2, ");
chmod(0777, "$NonCGIPath/Forum2");
mkdir ("$NonCGIPath/Forum3", 0777) || ($mkdirerror .= "Forum3, ");
chmod(0777, "$NonCGIPath/Forum3");
mkdir ("$NonCGIPath/Forum4", 0777) || ($mkdirerror .= "Forum4, ");
chmod(0777, "$NonCGIPath/Forum4");
mkdir ("$NonCGIPath/Forum5", 0777) || ($mkdirerror .= "Forum5, ");
chmod(0777, "$NonCGIPath/Forum5");
mkdir ("$NonCGIPath/Forum6", 0777) || ($mkdirerror .= "Forum6, ");
chmod(0777, "$NonCGIPath/Forum6");
mkdir ("$NonCGIPath/Forum7", 0777) || ($mkdirerror .= "Forum7, ");
chmod(0777, "$NonCGIPath/Forum7");
mkdir ("$NonCGIPath/Forum8", 0777) || ($mkdirerror .= "Forum8, ");
chmod(0777, "$NonCGIPath/Forum8");
mkdir ("$NonCGIPath/Forum9", 0777) || ($mkdirerror .= "Forum9  ");
chmod(0777, "$NonCGIPath/Forum9");

for ($i=1;$i<=9;$i++) { # make index file to prevent directory browsing
	open (INDEX, ">$NonCGIPath/Forum$i/index.html"); 
	print INDEX "";
	close (INDEX);
	chmod(0666, "$NonCGIPath/Forum$i/index.html");
}


if ($mkdirerror) { die(&StandardHTMLCP("<p>Die Unterverzeichnisse [ $mkdirerror ] im Verzeichnis $NonCGIPath konnten nicht erstellt werden oder existieren bereits.</p><p>Hier die Fehlermeldung:</p><p>$!</p><p>&Uuml;berpr&uuml;fen Sie Pfadangaben und/oder Zugriffsrechte.</p>") )};

}

###############################################
## Perform diagnostic checks/update if necessary
if (-e "$NonCGIPath/ubbdiagnostic.file") {
@diag = &OpenFile("$NonCGIPath/ubbdiagnostic.file");

foreach $diagline(@diag) {
	if ($diagline =~ m/SetLastTimes/) {
		$SLT = "true";
	}
	if ($diagline =~ m/ConvertAnnouncements/) {
		$CA = "true";
	}
	if ($diagline =~ m/ConvertToUBBFiles/) {
		$CTUF = "true";
	}
	if ($diagline =~ m/CreateLastForumNums/) {
		$CLFN = "true";
	}
}


if ($CTUF ne "true") {
	&RenameMess;
}

if ($CA ne "true") {
	&MoveAnnc;
}

if ($SLT ne "true") {
	&SetLastTimes;
}

if ($CLFN ne "true") {
	&SetLastThreadNums;
}

}  else {

$DidIt = "true";
#convert message files to ubb files
&RenameMess;
#move announcements to ANNC subdirectories
&MoveAnnc;
#reset last time files
&SetLastTimes;
#create last thread number file in each forum
&SetLastThreadNums;

#create ubbdiagnostic file--
open(DIAG, ">$NonCGIPath/ubbdiagnostic.file");
print DIAG ("SetLastTimes\n");
print DIAG ("ConvertAnnouncements\n");
print DIAG ("ConvertToUBBFiles\n");
print DIAG ("CreateLastForumNums\n");
close(DIAG);
chmod (0777, "$NonCGIPath/ubbdiagnostic.file");
}

if (($in{'Diagnostic'} eq "yes") && ($DidIt ne "true")) {
&SetLastTimesCycle;
}  else {

## END DIAGNOSTIC CHECK/UPDATE
#check to see if members are in proper format
&ConvertMembers;

$UserName = "$UserNameCheck";
$UserName =~ tr/ /+/;
$Password = "$PasswordCheck";
$Password =~ tr/ /+/;
unlink("$MembersPath/holdmems.cgi");
unlink("$NonCGIPath/temp.file");
unlink("$MembersPath/temp.file");

$ConfirmLine = "Die Einstellungen Ihres Ultimate Bulletin Boards wurden gespeichert.<P>
Damit Ihre &Auml;nderungen bei vorhandenen Beitr&auml;gen wirken, m&uuml;ssen Sie die Funktion \"Update der Beitr&auml;ge\" durchf&uuml;hren.<P>";
&ConfirmHTML2;
exit;
}

}  else { # parse the error message further

	$setup_message = "<p><b>Achtung!</b> Die Speicherung der generellen Einstellungen wurde nicht aktzeptiert.</p><p>Hier die Fehlermeldung:";

	unless (-e "$CGIPath") {
		$setup_message .= "<p>Der von Ihnen angegebene absolute CGI-Pfad <p>$CGIPath</p><p>konnte nicht gefunden werden.</p><p>&Uuml;berpr&uuml;fen Sie Ihre Angaben!</p>";
		$setup_help = "<p>Benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!<br>Sie k&ouml;nnen die Umgebungsvariablen Ihres Servers pr&uuml;fen, indem Sie <A HREF=cpanel.cgi?action=env>hier</a> klicken.</p>";
	}
	elsif ( !(-e "$CGIPath/Ultimate.cgi") )  {
		$setup_message .= "<p>Haben Sie alle Dateien aus dem cgi-Verzeichnis der ZIP-Datei in korrekter Gro&szlig;-/Kleinschreibung in das Verzeichnis $CGIPath &uuml;bertragen?</p>";		
		$setup_help .= "<p>Laden Sie ggf. alle Dateien erneut in der richtigen Schreibweise auf Ihren Server.</p>";
	}

	unless (-e "$NonCGIPath"){
		$setup_message .= "<p>Der absolute Pfad zu Ihrem nonCGI-Verzeichnis </p><p>$NonCGIPath</p><p>konnte nicht gefunden werden.</p><p> &Uuml;berpr&uuml;fen Sie Ihre Angaben.</p>";
$setup_help = "<p>Benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!<br>Sie k&ouml;nnen die Umgebungsvariablen Ihres Servers pr&uuml;fen, indem Sie <A HREF=cpanel.cgi?action=env>hier</a> klicken.</p>";
	}
	elsif ( !(-e "$NonCGIPath/ubbcode.html") )  {
		$setup_message .= "<p>Haben Sie alle Dateien aus dem NonCGI-Verzeichnis der ZIP-Datei in korrekter Gro&szlig;-/Kleinschreibung in das Verzeichnis $NonCGIPath &uuml;bertragen?</p><p>Pr&uuml;fen Sie, ob Ihr FTP-Programm die Endungen der Dateien automatisch &auml;ndert.</p>";	
		$setup_help .= "<p>Laden Sie ggf. alle Dateien erneut mit der richtigen Endung .html auf Ihren Server.</p>";
	}
	&StandardHTMLCP("$setup_message $setup_help");
}
} ## END DO PROCESS GENERAL VARS SR

sub DoIndex {
&VerifyAdminModCP($UserName, $Password);

&log_admin_activity ("DoIndex") if ($log_admin_activity eq 'YES');

if ($Proceed eq "true") {
	if ($IndexMethod eq "ONEFILE") {
		&ReIndex("1", "0");
	}  else {
		&ReIndex2("1", "0");
	}
} 
} # end DoIndex sr


sub Mods {
&VerifyAdminCP($UserName, $Password);

if ($Proceed eq "true") {
  &DoProcessMods;
  exit;
}  
} 

sub DoProcessMods {

&log_admin_activity ("DoProcessMods") if ($log_admin_activity eq 'YES');

&GetMemberListArray;  #returns @members array

## now we have our current Member list (in filename format)
@GoodMods = @blank;
@namecheck = @blank;
foreach $row(@in) {
	$row = decodeURL($row);
	($Name, $Value) = split ("=", $row);
	if ($Name =~ m/NewMod/) {
	$QValue = quotemeta($Value);
	#place name in list to check for validity first
	if ($Value ne "") {
	push(@namecheck, $Value);
	}
	#place name in mods array
	($Trash, $ArrayNumber) = split(/Mod/, $Name);
	$ArrayNumber--;
	if ($GoodMods[$ArrayNumber] eq "") {
		$GoodMods[$ArrayNumber] = "$QValue";
	}  else {
	$GoodMods[$ArrayNumber] .= "||^||$QValue";
	}
	}
} # end foreach $row

#check for validity of each mod name first
foreach $checker(@namecheck) {
$nameok = "false";
if ($checker ne "") {
	for $matcher(@members) {
		chomp($matcher);
		if ($matcher eq "$checker") {
			$nameok = "true";
		}
	}
}  else {
	$nameok = "true";
}
if ($nameok eq "false") {
	&StandardHTMLCP("Achtung! Die Einstellung Ihrer Moderatoren konnte nicht gespeichert werden:<P>Der folgende Benutzername ist nicht als registrierter Benutzer vorhanden:<P><CENTER>$checker</CENTER><P>Nur registrierte Benutzer k&ouml;nnen eine Moderator-Funktion &uuml;bernehmen.");
exit;
}
}

#update mods.file
$ForumNum = 0;
&Lock("lock.file");
open (MODS, ">$VariablesPath/mods.file") || die( &StandardHTML("Die Datei mods.file konnte nicht zum Schreiben ge&ouml;ffnet werden. Hier die Fehlermeldung: $! &Uuml;berpr&uuml;fen Sie die Pfadangabe und Zugriffsrechte") );
for $eachrow(@GoodMods) {
$ForumNum++;
$modline = ('$Forum' . "$ForumNum" . 'Moderator = "' . "$eachrow" . '"' . ";\n");
print MODS "$modline";
}
print MODS ("1;\n");
close(MODS);
&Unlock("lock.file");

#remove dupes from namecheck list-- move to goodlist array
@goodlist = &RemoveDupes(@namecheck);

## UPDATE MEMBER PROFILES FOR ALL MODERATORS

foreach $ModName(@goodlist) {
	chomp($ModName);
	$ProfileNumber = &GetUserNumber($ModName);
	@modprof = &OpenProfile("$ProfileNumber.cgi");
	$Status = $modprof[8];
	&CheckStatus;
	if ($AdminStatus ne "true") {
		$modprof[8] = "Moderator";
		&Lock("lock.file");
		open (UPDATE, ">$MembersPath/$ProfileNumber.cgi");
			foreach $thisline(@modprof) {
				chomp($thisline);
				print UPDATE ("$thisline\n");
			}
		close (UPDATE);
		&Unlock("lock.file");
	}  ## END IF not admin
} # end for


## Delete Moderator status from users who are no longer Moderators

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	if ($Name =~ m/OldMod/) {
	if ($Value ne "") {
	@alloldmods = split(/\|\|\^\|\|/, $Value);
	foreach $unomod(@alloldmods) {
	chomp($unomod);
	push (@OldMods, $unomod);
	}
	}
	}
} # end foreach $row

#delete dupes from old mods
@FinalOldMods = &RemoveDupes(@OldMods);

for $oldie(@FinalOldMods) {
	$SaveOldie = "no";
	chomp($oldie);
	for $checkthis(@goodlist) {
		chomp($checkthis);
		if ($oldie eq "$checkthis") {
		$SaveOldie = "yes";
		}
	}
	if (($SaveOldie ne "yes") && ($oldie ne "")) {
		$ProfileNumber = &GetUserNumber($oldie);
		@oldmod = &OpenProfile("$ProfileNumber.cgi");  
			$Status = $oldmod[8];
			$TotalPosts = $oldmod[7];
			&CheckStatus;
			
			if ($AdminStatus ne "true") {
				if ($TotalPosts < $MemberMinimum) {
					$Status = "Junior-Mitglied";
				}  else {
					$Status = "Mitglied";
				}
				$oldmod[8] = "$Status";
				&Lock("lock.file");
				open (UPDATE, ">$MembersPath/$ProfileNumber.cgi");
				foreach $separate(@oldmod) {
					chomp($separate);
					print UPDATE ("$separate\n");
				}
				close (UPDATE);
				&Unlock("lock.file");
		}  ## END IF ADMIN status ne true
	}

} 

$ConfirmLine = "Die Einstellung Ihrer Moderatoren wurde &uuml;bernommen.";
&ConfirmHTML2;

}  ## END DO PROCESS SR

sub CheckStatus {
		if ($Status =~ m/Administrator/) {
			$AdminStatus = "true";
			} else {
			$AdminStatus = "false";
		}
		if ($Status =~ m/Moderator/) {
			$ModStatus = "true";
		} else {
			$ModStatus = "false";
		}
		if ($Permission =~ m/Write/) {
			$AdminWrite = "true";
		} else {
			$AdminWrite = "false";
		}
} #end CheckStatus



sub RenameMess {

#convert old files to new files--- (new in 5.10)
@sortforums = &OpenForumsFile;

for (@sortforums) {

@thisforuminfo = split(/\|/, $_);
chomp($thisforuminfo[8]);
$x = "$thisforuminfo[8]";

opendir (FORUMDIR, "$ForumsPath/Forum$x"); 
    @thesefiles = readdir(FORUMDIR);
closedir (FORUMDIR);

@thefiles = grep(/\.(n|m)/, @thesefiles);
@files = sort(@thefiles);
$oldfiletotal = @files;

foreach $one(@files) {
$Notes = "";

if ($one =~ /^\d\d\d\d\d\d-000000/) {
#it is a father
@father = &OpenFile("$ForumsPath/Forum$x/$one");
($threadnum, $junk, $junk2, $replies) = split(/-/, $one);
($replies, $junk3) = split(/\./, $replies);
$TotReplies = substr($replies, 0, 6);
$TotReplies = $TotReplies + 0;

if ($one =~ /X/) {
	$Notes = "X";
	}
if ($one =~ /n/) {
	$Notes .= "N";
	}

chomp($father[0]);
chomp($father[1]);
chomp($father[2]);
$Subject = $father[3];
chomp($Subject);
$email = $father[4];
chomp($email);
chomp($father[5]);

$StatsLine = "A||$Notes||$TotReplies||$father[0]||$Subject";

$NewFatherName = "$threadnum.cgi";
$FatherLine = "Z||000000||$father[0]||$father[1]||$father[2]||$email||$father[5]";

open (RENAMEPOP, ">$ForumsPath/Forum$x/$NewFatherName");
print RENAMEPOP ("$StatsLine\n");
print RENAMEPOP ("$FatherLine\n");
close (RENAMEPOP);


chmod (0666, "$ForumsPath/Forum$x/$NewFatherName");
unlink "$ForumsPath/Forum$x/$one";


}  else {
#add to reply file
@reply = &OpenFile("$ForumsPath/Forum$x/$one");
($threadnum, $replynum, $junk, $junk2) = split(/-/, $one);
$NewReplyName = "$threadnum.cgi";

#put reply info on one line
$UName = $reply[0];
chomp($UName);
$Date = $reply[1];
chomp($Date);
$TheTime = $reply[2];
chomp($TheTime);
$Subject = $reply[3];
chomp($Subject);
$Email = $reply[4];
chomp($Email);
$Message = $reply[5];
chomp($Message);
$ReplyLine = ("Z||$replynum||$UName||$Date||$TheTime||$Email||$Message");

open (RENAMEPOP, ">>$ForumsPath/Forum$x/$NewReplyName");
print RENAMEPOP ("$ReplyLine\n");
close (RENAMEPOP);

chmod (0666, "$ForumsPath/Forum$x/$NewReplyName");
unlink "$ForumsPath/Forum$x/$one";
}
}

}  # end for each forum
}  # end Rename Mess sr

sub MoveAnnc {
#move annc to sep. ANNC directories- new in 5.10
@sortforums = &OpenForumsFile;

for (@sortforums) {

@thisforuminfo = split(/\|/, $_);
chomp($thisforuminfo[8]);
$x = "$thisforuminfo[8]";

opendir (FORUMDIR, "$ForumsPath/Forum$x"); 
    @files = readdir(FORUMDIR);
closedir (FORUMDIR);

@annc = grep(/\.annc/, @files);

mkdir("$ForumsPath/Forum$x/ANNC", 0777) ;
chmod (0777, "$ForumsPath/Forum$x/ANNC");


foreach $one(@annc) {
@thisann = &OpenFile("$ForumsPath/Forum$x/$one");
	
open (ANNC, ">$ForumsPath/Forum$x/ANNC/$one");
foreach $line(@thisann) {
chomp($line);
print ANNC ("$line\n");
}
close (ANNC);
chmod (0777, "$ForumsPath/Forum$x/ANNC/$one");
}
}  # end for each forum

}  # end Move Annc sr (new in 5.10)

sub SetLastThreadNums {

# set thread number info to lastnumber.file
# new in 5.10
@sortforums = &OpenForumsFile;

for (@sortforums) {
@thisforuminfo = split(/\|/, $_);
chomp($thisforuminfo[8]);
$x = "$thisforuminfo[8]";

if ($thisforum[6] eq "private") {
	$ExactPath = "Forum$x/private-$thisforum[7]";
	} else {
	$ExactPath = "Forum$x";
	}

opendir (FORUMDIR, "$ForumsPath/$ExactPath"); 
    @files = readdir(FORUMDIR);
closedir (FORUMDIR);

@theubbfiles = grep(/\.[cgi|ubb]/, @files);
$topiccount = @theubbfiles;
#sort the ubb files
@sortubbfiles = sort(@theubbfiles);
#reverse array so that largest number is first
@ubbfiles = reverse(@sortubbfiles);
my $lastnumber = $ubbfiles[0];
($lastnumber, $junk) = split(/\./, $lastnumber);

$ThreadTotal = 0;
#determine number of total posts
foreach $threadfile(@ubbfiles) {
@thecountit = &OpenFile("$ForumsPath/$ExactPath/$threadfile");
@countit = grep(/^Z/, @thecountit);
$ThisTotal = @countit;
$ThreadTotal = $ThreadTotal + $ThisTotal;
}

if (-e "$ForumsPath/$ExactPath/lastnumber.file") {
chmod (0666, "$ForumsPath/$ExactPath/lastnumber.file");
}

#print number to lastnumber.file
open (UBB, ">$ForumsPath/$ExactPath/lastnumber.file");
print UBB ("$lastnumber\n");
print UBB ("$topiccount\n");
print UBB ("$ThreadTotal\n");
close (UBB);

chmod (0666, "$ForumsPath/$ExactPath/lastnumber.file");
}  # end for each forum
} #end SetLastThreadNums sr


sub ConvertMembers {

#check to see if memberlist.cgi exists - if not, create it
if (-e "$MembersPath/memberslist.cgi") {
	$ConversionOne = "done";
}
if (-e "$MembersPath/emailfile.cgi") {
	$ConversionTwo = "done";
}

if ($ConversionOne ne "done") {
	$OldFormat = "true";
}

if ($ConversionTwo ne "done") {

open (TEMP, ">$NonCGIPath/temp.file");
print TEMP "Tempor&auml;re Datei - bei Problemen mit Ihrem UBB k&ouml;nnen Sie diese Datei l&ouml;schen!";
close(TEMP);
chmod(0777, "$NonCGIPath/temp.file");

#create private index directory
mkdir ("$MembersPath/pindex", 0777) || die ( &StandardHTML("Innerhalb des Members-Verzeichnis konnte das Unterverzeichnis pindex nicht angelegt werden: $! <P>&Uuml;berpr&uuml;fen Sie die Pfadangaben und Zugriffsrechte Ihres Members-Verzeichnisses") );
chmod(0777, "$MembersPath/pindex");

mkdir ("$MembersPath/OldMembers", 0777);
chmod(0777, "$MembersPath/OldMembers");

#batch old members files to memberslist.cgi
opendir (MEMS, "$MembersPath");
@thememberarray = readdir(MEMS);
closedir (MEMS);
if ($OldFormat eq "true") {
@memberarray = grep(/\.cgi/, @thememberarray);
}  else {
@memberarray = grep(/\d\d\.cgi/, @thememberarray);
}

@sortmems = sort(@memberarray);

#store names/numbers in a temporary file
open (MEM, ">$MembersPath/holdmems.cgi");
foreach $memone(@sortmems) {
chomp($memone);
print MEM ("$memone\n");
}
close (MEM);
chmod (0777, "$MembersPath/holdmems.cgi");

my $Count = 0;
my $thisnumber = 0;
$SubTotal = @sortmems;
$MemTotal = $SubTotal - 1;

$Maximum = 39;
if ($MemTotal > $Maximum) {
$Max = $Maximum;
$Continue = "true";
$StartWith = $Maximum + 1;
$StartDisplay = 1;
$EndDisplay = $StartWith;
}  else {
$Max = $MemTotal;
}
	@adjmembers = @sortmems[0... $Max];
	
foreach $oneeach(@adjmembers) {
$Count++;
$thisnumber = sprintf("%8d", $Count);
$thisnumber =~tr/ /0/;
	@thismember = &OpenFile("$MembersPath/$oneeach");
	$memberline = $thismember[0];
	chomp($memberline);

if ($OldFormat eq "true") {
@memberstats = split(/\|/, $memberline);
}  else {
$OldFormat = "false";
@memberstats = @thismember;
}

$ThisEmail = $memberstats[2];
$ThisName = $memberstats[0];
chomp($ThisEmail);
chomp($ThisName);

if ($OldFormat ne "true") {
($thisnumber, $junk) = split(/\./, $oneeach);
}

$thisline = ("$ThisName|!!|$thisnumber");
$thisline2 = ("$ThisEmail||$thisnumber");
push (@memberlist, $thisline);
push (@emailfile, $thisline2);

#rename old members files

rename("$MembersPath/$oneeach", "$MembersPath/OldMembers/$oneeach");

if (-e "$MembersPath/$oneeach") {
unlink("$MembersPath/$oneeach");
}
&Lock ("lock.file");
open (THISONE, ">$MembersPath/$thisnumber.cgi");
foreach $line(@memberstats) {
chomp($line);
	print THISONE "$line\n";
}
close (THISONE);
&Unlock ("lock.file");
chmod (0777, "$MembersPath/$thisnumber.cgi");

}
&Lock ("lock.file");
open (LIST, ">$MembersPath/memberslist.cgi");
	foreach $uno(@memberlist) {
		chomp($uno);
		print LIST "$uno\n";
	}
close (LIST);
&Unlock ("lock.file");
chmod (0777, "$MembersPath/memberslist.cgi");

&Lock ("lock.file");
open (LIST, ">$MembersPath/emailfile.cgi");
	foreach $dos(@emailfile) {
		chomp($dos);
		print LIST "$dos\n";
	}
close (LIST);
&Unlock ("lock.file");
chmod (0777, "$MembersPath/emailfile.cgi");

if ($Continue eq "true") {
&ContinueMCWording("$OldFormat");
exit;
}


}  else {

$UserName = "$UserNameCheck";
$UserName =~ tr/ /+/;
$Password = "$PasswordCheck";
$Password =~ tr/ /+/;
unlink("$MembersPath/holdmems.cgi");
$ConfirmLine = "Die Einstellungen Ihres Ultimate Bulletin Boards wurden gespeichert.<P>
Damit die neuen Einstellungen bei bereits vorhandenen Beitr&auml;gen &uuml;bernommen werden, m&uuml;ssen Sie die Funktion \"Update der Beitr&auml;ge\" in der System-Administration durchf&uuml;hren. Abh&auml;ngig von der Menge der vorhandenen Beitr&auml;ge kann diese Funktion zeitintensiv sein, es empfiehlt sich daher, diese Funktion nur zu starten, wenn Sie wirklich alle Einstellungen vorgenommen haben.<P>";
&ConfirmHTML2;
exit;
}

} #end ConvertMembers

sub ContinueMCWording {
my $ThisOldFormat = shift;

$UserNameCheckCoded = $in{'UserNameCheck'};
$UserNameCheckCoded =~ tr/ /+/;
print<<TheMail;
<HTML><HEAD>
<meta http-equiv="Refresh" content="2; URL=$CGIURL/cpanel2.cgi?action=continueMC&startwith=$StartWith&UserName=$UserNameCheckCoded&Password=$PasswordCheckCoded&OldFormat=$ThisOldFormat">
</head>
<BODY bgcolor=#FFFFFF>
<center>
<FONT FACE="Verdana, Arial" SIZE="2"><B>
<FONT FACE="Courier New" SIZE="5" COLOR="Maroon"><B>System arbeitet .... bitte warten!</B></FONT>
<P>
Derzeit werden alle vorhandenen Mitglieder-Dateien auf das aktuelle Dateiformat konvertiert - bitte warten Sie!
<P>
Es wurden die Dateien der Mitglieder <FONT FACE="Verdana" SIZE="3" COLOR="Navy">$StartDisplay</font> bis <FONT FACE="Verdana" SIZE="3" COLOR="Navy">$EndDisplay</font> konvertiert ...
<P><FONT FACE="Courier New" SIZE="5" COLOR="Maroon"><B>
BITTE WARTEN - UNTERBRECHEN SIE KEINESFALLS DIESEN PROZESS!</B></FONT>
</center>
</FONT>
</BODY>
</HTML>
TheMail
}

sub ContinueMC {
$StartWith = shift;
$OldFormat = shift;
@members = &OpenFile("$MembersPath/holdmems.cgi");
@sortmems = sort(@members);

$MemTotal = @sortmems;
$MemTotal--;

$StartWith = $StartWith + 0;
$Maximum = 249;
$MaximumNumber = $StartWith + $Maximum;

if ($MemTotal > $MaximumNumber) {
$Max = $MaximumNumber;
$Continue = "true";
$StartDisplay = $StartWith + 1;
$EndDisplay = $Max + 1;
}  else {
$Max = $MemTotal;
}
	@adjmembers = @sortmems[$StartWith... $Max];
	
	$Count = $StartWith; #arraynumber
	
foreach $thisuno(@adjmembers) {
chomp($thisuno);
$Count++;
if ($OldFormat eq "true") {
$thisnumber = sprintf("%8d", $Count);
$thisnumber =~tr/ /0/;
}
@thismember = &OpenFile("$MembersPath/$thisuno");
rename("$MembersPath/$thisuno", "$MembersPath/OldMembers/$thisuno");

if (-e "$MembersPath/$thisuno") {
unlink("$MembersPath/$thisuno");
}

$memberline = $thismember[0];
chomp($memberline);
if ($OldFormat eq "true") {
@memberstats = split(/\|/, $memberline);
}  else {
@memberstats = @thismember;
($thisnumber, $junk) = split(/\./, $thisuno);
}

$ThisEmail = $memberstats[2];
$ThisName = $memberstats[0];
chomp($ThisEmail);
chomp($ThisName);

$thisline = ("$ThisName|!!|$thisnumber");
push (@memberlist, $thisline);
$thisline2 = ("$ThisEmail||$thisnumber");
push (@emailfile, $thisline2);
#rename old members files
&Lock ("lock.file");
open (THISONE, ">$MembersPath/$thisnumber.cgi");
foreach $line(@memberstats) {
chomp($line);
	print THISONE "$line\n";
}
close (THISONE);
&Unlock ("lock.file");
chmod (0777, "$MembersPath/$thisnumber.cgi");

}
&Lock ("lock.file");
open (LIST, ">>$MembersPath/memberslist.cgi");
	foreach $uno(@memberlist) {
		chomp($uno);
		print LIST "$uno\n";
	}
close (LIST);
&Unlock ("lock.file");
chmod (0666, "$MembersPath/memberslist.cgi");

&Lock ("lock.file");
open (LIST, ">>$MembersPath/emailfile.cgi");
	foreach $uno2(@emailfile) {
		chomp($uno2);
		print LIST "$uno2\n";
	}
close (LIST);
&Unlock ("lock.file");
chmod (0666, "$MembersPath/emailfile.cgi");
if ($Continue eq "true") {
$StartWith = $EndDisplay;
&ContinueMCWording($OldFormat);;
exit;
}  else {

$UserName = "$UserName";
$UserName =~ tr/ /+/;
$Password = "$Password";
$Password =~ tr/ /+/;

unlink("$MembersPath/temp.file");
unlink("$MembersPath/holdmems.cgi");
unlink("$NonCGIPath/temp.file");
$ConfirmLine = "Die Einstellungen Ihres Ultimate Bulletin Boards wurden gespeichert.<P>
Damit die neuen Einstellungen bei bereits vorhandenen Beitr&auml;gen &uuml;bernommen werden, m&uuml;ssen Sie die Funktion \"Update der Beitr&auml;ge\" in der System-Administration durchf&uuml;hren. Abh&auml;ngig von der Menge der vorhandenen Beitr&auml;ge kann diese Funktion zeitintensiv sein, es empfiehlt sich daher, diese Funktion nur zu starten, wenn Sie wirklich alle Einstellungen vorgenommen haben.<P>";
&ConfirmHTML2;
exit;
}
}  # end continue MC

sub InputTextRow {
my $RowColor = shift;
my $FieldName = shift;
my $Notes = shift;
my $InputField = shift;
my $Size = shift;
my $MaxSize = shift;
if ($Notes ne "") {
	$Notes = "<BR>$Notes";
}
print<<ROW;
<tr bgcolor="$RowColor">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>$FieldName</B></FONT>
<FONT SIZE="1" FACE="Verdana, Arial"><B>$Notes</B></FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="$InputField" VALUE="$$InputField" SIZE=$Size MAXLENGTH=$MaxSize>
</td></tr>
ROW
}


sub log_admin_activity {
	
my $admin_action = shift;
open(ADMINLOG, ">>$NonCGIPath/BanLists/adminlog.cgi");
print ADMINLOG localtime() . " $admin_action $in{'UserName'}$in{'UserNameCheck'} $ENV{'REMOTE_ADDR'} $ENV{'REMOTE_HOST'} $ENV{'HTTP_USER_AGENT'} $ENV{'HTTP_REFERER'}\n";
close(ADMINLOG);
chmod (0777, "$NonCGIPath/BanLists/adminlog.cgi");
return 1;
} # end SR


sub checkpathlock { # don't process change to paths if the BB is locked

if ( (-e "$NonCGIPath/BanLists/ubbpathlock.cgi") &&  (-e "$CGIPath/edit.cgi") && (-e "$MembersPath/memberslist.cgi") && (-e "$VariablesPath/UltBB.setup")  ) {
	if ($CGIPath ne $in{'CGIPath'}) {
	  $change = " $in{'CGIPath'}";	
	}	
	if ($NonCGIPath ne $in{'NonCGIPath'}) {
	  $change .= " $in{'NonCGIPath'}";	
	}	
	if ($MembersPath ne $in{'MembersPath'}) {
	  $change .= " $in{'MembersPath'}";	
	}	
	if ($VariablesPath ne $in{'VariablesPath'}) {
	  $change .= " $in{'VariablesPath'}";	
	}	
	if ($change) {
	  &log_admin_activity ("Change Locked Path to $change");	
	  &PostHackDetails;
	  &StandardHTMLCP("Achtung! Alle Pfadangaben in diesem UBB wurden durch den Administrator aus Sicherheitsgr&uuml;nden gesperrt. Der Besitzer dieses UBB mu&szlig; die Datei \"ubbpathlock.cgi\" entfernen, bevor Ver&auml;nderungen vorgenommen werden k&ouml;nnen. <p>Dieser Zugriff wurde protokolliert.<p>Bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers.");
	  exit;
	}
}	
else {
	return 1;	
}	
} # end SR

exit(0); # comply with SafePerl
