#!/usr/bin/perl
#
###                         PRIMARY UBB SCRIPT                ##
#
# Ultimate Bulletin Board is copyright Infopop Corporation, 1998-2000.
#
#       ------------ ubbmisc.cgi -------------
#
#  This file contains miscellaneous functionality for the UBB.
#
#  Infopop Corporation offers no
#  warranties on this script.  The owner/licensee of the script is
#  solely responsible for any problems caused by installation of
#  the script or use of the script, including messages that may be
#  posted on the BB.
#
#  All copyright notices regarding the Ultimate Bulletin Board
#  must remain intact on the scripts and in the HTML
#  for the scripts.
#
# For more info on the Ultimate BB, 
# see http://www.UltimateBB.com
#
###############################################################
#
#If you are running UBB on IIS,
#you may need to add the following line
#if so, just remove the "#" sign before the print line below
#print "HTTP/1.0 200 OK\n";

eval {

  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "UltBB.setup";
require "Date.pl";
require "mods.file";
require "mail-lib.pl";
require "Styles.file";
require "ubb_library.pl";
require "ubb_library2.pl";

};

if ($@) {
    print ("Content-type: text/html\n\n");
    print "Fehler beim Aufruf der Datei(en): $@\n";
    print "Stellen Sie sicher, da&szlig; diese Datei(en) vorhanden ist/sind, die Zugriffsrechte und Systempfade korrekt eingestellt sind.";
 exit;
}

use Socket;
&ReadParse;

foreach $row(@in) {
	($Name, $Value) = split ("=", $row);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	
	if ($Name eq "forum") {
		$Forum = $Value;
		$Forum =~ s/\/\\//g;
		$ForumCoded = &HTMLIFY($Forum);
		$ForumCoded =~ tr/ /+/;
		$Forum = &UNHTMLIFY($Forum);
	}
	if ($Name eq "TopicSubject") {
		$TopicSubject = $Value;
		$TopicSubject =~ s/<.+?>//g;
		$TopicSubject =~ s/</\&lt\;/g;
		$TopicSubject = &UNHTMLIFY($TopicSubject);
	}
	if ($Name eq "UserName") {
		$UserName = $Value;
		$UserName = &UNHTMLIFY($UserName);
		$UserNameFile = $UserName;
		$UserNameFile =~ s/ /_/g; #remove spaces
	}
	if ($Name eq "PasswordConfirm") {
		$PasswordConfirm = $Value;
	}

	if ($Name eq "number") {
		$number = $Value;
		$number =~ s/\D//sg;
	}
	if ($Name eq "topic") {
		$topic = $Value;
	}
	if ($Name eq "Email") {
		$Email = $Value;
		$Email =~tr/A-Z/a-z/; 
	}
	if ($Name eq "URL") {
		$URL = &CleanThis($Value);
		$URL = &PipeCleaner($URL);
	}
	if ($Name eq "Occupation") {
		$Occupation = &CleanThis($Value);
		$Occupation = &PipeCleaner($Occupation);
	}
	if ($Name eq "Location") {
		$Location = &CleanThis($Value);
		$Location = &PipeCleaner($Location);
	}
	if ($Name eq "TotalPosts") {
		$TotalPosts = $Value;
	}
	if ($Name eq "Interests") {
		$Interests = &CleanThis($Value);
		$Interests = &PipeCleaner($Value);
	}
}  # end FOREACH $row

if ($VariablesPath eq "") {
	$VariablesPath = $CGIPath;
}

# if necessary set Random Number - for use in Banner Ads, etc.
if ( ($Header ne "") || ($Footer ne "") ) {

$RandomNumber = &MakeRandomNumber;
$RandomNumber2 = $RandomNumber + 100074;

 if ($Header ne "") {
   $Header =~ s/UBBrandomX/$RandomNumber/isg;
   $Header =~ s/UBBrandomY/$RandomNumber2/isg;
 }
 if ($Footer ne "") {
   $Footer =~ s/UBBrandomX/$RandomNumber/isg;
   $Footer =~ s/UBBrandomY/$RandomNumber2/isg;
 }

} # end if header or footer

#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($AltColumnColor1 ne ""){
$AltColumnColor1 = qq(bgcolor="$AltColumnColor1");
}
if ($AltColumnColor2 ne ""){
$AltColumnColor2 = qq(bgcolor="$AltColumnColor2");
}
if ($CategoryStripColor ne ""){
$CategoryStripColor = qq(bgcolor="$CategoryStripColor");
}
if ($TableColorStrip ne ""){
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($PageBackground ne ""){
$PageBackground = qq(background="$NonCGIURL/$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}

if ($BBStatus eq "OFF") {
print ("Content-type: text/html\n\n");
&StandardHTML($BBClosedMessage);
exit;
}

$ReplyMessage = $in{'ReplyMessage'};
$Message = $in{'Message'};

$SubjectCoded = &HTMLIFY($TopicSubject);
$SubjectCoded =~ tr/ /+/;

if ($in{'action'} eq "findthread") {
 &FindThread;
 } 

print ("Content-type: text/html\n\n");

if ($in{'action'} eq "clearcookies") {
 &ClearCookies;
 }  
if ($in{'action'} eq "sockettest") {
 &SocketTest;
 }  

if ($in{'action'} eq "getannounce") {
 &GetAnnounce;
 }
  
if ($in{'action'} eq "getbio") {
 &GetBio;
 } 
 
if ($in{'action'} eq "sendthread") {
 &SendThreadForm;
 } 
 
if ($in{'action'} eq "SubmitThreadEmail") {
 &SubmitThreadEmail;
 } 
if ($in{'action'} eq "editbio") {
 &EditBio;
 } 
if ($in{'action'} eq "setprefs") {
 &SetPrefs;
 } 
if ($in{'action'} eq "PrefsSubmit") {
 &PrefsSubmit;
 } 
if ($in{'action'} eq "getip") {
 &GetIP;
 } 
if ($in{'action'} eq "checkbioid") {
&CheckBioID;
 } 
if ($in{'action'} eq "modifybio") {
   &ModifyBio;
 }
if ($in{'action'} eq "RegSubmit") {
 &RegSubmit;
 }
 if ($in{'action'} eq "pwrequest") {
 &PWRequest;
} 
if ($in{'action'} eq "showcoppaform") {
 if ($COPPAType eq "COPPADenied") {
  &StandardHTML("Die Teilnahme an diesem Forum ist fr Personen mit einem Alter von 13 oder weniger Jahren nicht mglich.");
 } else {
  &PrintCOPPARegistrationHTML;
 }
}
 
sub ClearCookies {
print<<COOKIES;
<HTML>
<HEAD>
$HeaderInsert
<SCRIPT LANGUAGE="JAVASCRIPT">
<!-- Hide
if (document.cookie != "") {
if (confirm("Sind Sie sicher, da Sie alle Cookies lschen mchten?")) {
	thisCookie = document.cookie.split(";");
	expireDate = new Date;
	if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 - 1);
} else {
expireDate.setYear(expireDate.getYear()-1);
}

	for (i=0; i<thisCookie.length; i++) {
		cookieName = thisCookie[i].split("=")[0];
		document.cookie = cookieName + "=;expires=" + expireDate.toGMTString();
	}
	
}
}
// End hiding  -->
</SCRIPT>
</HEAD>
<BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<FONT SIZE="$TextSize" FACE="$FontFace">
<CENTER><P><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A></CENTER>
<P><blockquote>
Vielen Dank.  Alle Cookies f&uuml;r dieses System wurden gel&ouml;scht. Sie sollten jetzt Ihre Voreinstellungen erneut vornehmen.<P><A HREF="$CGIURL/ubbmisc.cgi?action=setprefs">Voreinstellungen vornehmen</A>.<P><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">Zur&uuml;ck zu den Foren</a></blockquote></font>$Footer
</BODY>
</HTML>
COOKIES

}

sub FindThread {

@thisfor = &GetForumRecord($number);
my $LWA = $thisfor[6];
$DIRPW = $thisfor[7];
my $PrivateMax = $thisfor[13];
chomp($PrivateMax);

if (-e "$ForumsPath/$in{'forum'}/forum$number.threads") {

open(THREADLIST, "$ForumsPath/$in{'forum'}/forum$number.threads");
my @thisthreadlist = <THREADLIST>;
close(THREADLIST);

if ($in{'go'} eq "older") {
	@threadlist = reverse(@thisthreadlist);
}  else {
	@threadlist = @thisthreadlist;
}

my $Next = "false";

FINDIT: foreach $uno(@threadlist) {
	@topicarray = split(/\|\^\|/, $uno);
	if ($Next eq "true") {
		$RetrieveTopic = "$topicarray[1]";
		last FINDIT;
	}
	if ($topicarray[1] eq "$in{'thisthread'}") {
		$Next = "true"	
	}
}

if ($RetrieveTopic ne "") {

if (($LWA eq "private") && ($PrivateMax eq "yes")) {
&get_cookie;  #retrieves all current cookies
	$PasswordPrivate = "$cookie{PasswordPrivate}";
	$UserNamePrivate = "$cookie{UserNamePrivate}";
	$NumbersPrivate = "$cookie{ForumNumberPrivate}";
	&VerifyID;
	
	if ($ProceedNow ne "true") {
	print ("Content-type: text/html\n\n");
		&StandardHTML("Dies ist ein privates Forum, f&uuml;r welches Sie nicht autorisiert sind.");
		exit;
	}

$GoTo = "$CGIURL/forumdisplay.cgi?action=displayprivate&number=$number&topic=$RetrieveTopic";
}  else {
$GoTo = "$NonCGIURL/$in{'forum'}/HTML/$RetrieveTopic.html";
}
print "Location: $GoTo\n\n";
exit;
}  else {
print ("Content-type: text/html\n\n");

&StandardHTML("Es sind keine weiteren Beitr&auml;ge verf&uuml;gbar.  Benutzen Sie den Zur&uuml;ck-Button Ihres Browser um zur&uuml;ckzukehren.");
exit;
}

} else {
print ("Content-type: text/html\n\n");
&StandardHTML("Der n&auml;chste Beitrag kann nicht ermittelt werden");
exit;
}
}
  
sub GetBio {
$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber eq "") {
&StandardHTML("Der Benutzer ($UserName) ist in unserem System nicht (mehr) registriert.  Es sind keine Profil-Informationen verf&uuml;gbar.");
exit;
}
@thisprofile = &OpenProfile("$ProfileNumber.cgi");

$EmailView = $thisprofile[11];
$Signature = $thisprofile[12];
my $TheEmail = $thisprofile[2];


if (($EmailBlock eq "ON") || ($EmailView eq "no")) {
$EmailField = "Nicht verf&uuml;gbar.";
}  else {
$EmailField = qq(<A HREF="mailto:$TheEmail">$TheEmail</A>);
}
&ViewBioHTML;
}  ## END GET BIO sr

sub CheckBioID {
if (($in{'UserName'} eq "") || ($in{'Password'} eq "")) {
&StandardHTML("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
} else {

$NameFound = "no";

$ProfileNumber = &GetUserNumber($UserName);
if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

	if ($NameFound eq "yes") {
		#Check Password Now
		
	@thisprofile = &OpenProfile("$ProfileNumber.cgi");
	
         if ($in{'Password'} eq "$thisprofile[1]") {
		     $pwmatch = "true";
			$Password = $thisprofile[1];
			$Email = $thisprofile[2];
			$URL = $thisprofile[3];
			$Occupation = $thisprofile[5];
			$Location = $thisprofile[6];
			$Interests = $thisprofile[9];
			$Status = $thisprofile[8];
			$TotalPosts = $thisprofile[7];
			$Permissions = $thisprofile[4];
			$DateRegistered = $thisprofile[10];
			$EmailView = $thisprofile[11];
			$Signature = $thisprofile[12];
			$ICQnumber = $thisprofile[13];
			$AllowMassMail = $thisprofile[14];
			chomp($AllowMassMail);
            &ProcessEdit;
         }
    } ## END IF MEMBER = Username.cgi condition

if ($NameFound ne "yes") {
   &StandardHTML("Der angegebene Benutzername existiert nicht - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
}
if (($NameFound eq "yes") && ($pwmatch ne "true")) {
   	&StandardHTML("Das eingegebene Kennwort ist nicht korrekt - versuchen Sie es erneut, bitte nutzen Sie die Zur&uuml;ck-Funktion Ihres Browsers.");
}
} # end check for missing fields
}  ## END CheckBioID SR ###


sub ModifyBio {
if (($Email eq "") || ($in{'NewPassword'} eq "") || ($Email !~ /\S+\@\S+\.\S+/)) {
&StandardHTML("Sie haben entweder nicht alle Pflichtfelder ausgef&uuml;llt oder eine eMail-Adresse mit falschem Format angegeben - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
 }  else {
 
## Confirm UserName and Password to prevent hacking
$ProfileNumber = &GetUserNumber($UserName);
@profileinfo = &OpenProfile("$ProfileNumber.cgi");  
$CurrentEmail = "$profileinfo[2]";
chomp($CurrentEmail);
$Permissions = "$profileinfo[4]";
chomp($Permissions);
$TotalPosts = "$profileinfo[7]";
$Status = "$profileinfo[8]";
$DateRegistered = "$profileinfo[10]";

if ($profileinfo[1] eq "$in{'Password'}") {

## check for duplicate email addresses, if applicable
&GetMemberListArray;
&GetEmails;
if ($EmailCheck eq "true") {

### members, EmailList arrays...

#Check For Duplicate Email
my $duplicate = "";
$RegEmail = lc($Email);
$CurrEmail = lc($CurrentEmail);

#only check if email is being changed
if ($RegEmail ne "$CurrEmail") {
$UpdateEmailFile = "true";

&CheckBans;

if (-e "$MembersPath/temp.file") {
&StandardHTML("Zur Zeit wird ein Update der Mitglieder-Daten durchgef&uuml;hrt - bitte versuchen Sie es sp&auml;ter noch einmal!");
exit;
}
unless ($Permissions =~ /Write/) {
&StandardHTML("Die &Auml;nderung Ihres Profils kann aus folgendem Grund nicht durchgef&uuml;hrt werden:<P>Mitglieder, denen keine Berechtigung zum Erstellen von Beitr&auml;gen gestattet ist, k&ouml;nnen ihre eMail-Adresse nicht &auml;ndern."); 
exit;
}

CHECKEMAIL: for $thisemail(@EmailList) {
($theemail, $junk) = split(/\?\?/, $thisemail);
$checkemail = lc($theemail);
if ($RegEmail eq "$checkemail") {
	$duplicate = "yes";
	last CHECKEMAIL;
} #end if regemail
} # end foreach
} #end regemail/curremail compare
}  #END if Email check eq TRUE

if ($duplicate eq "yes") { 
	&StandardHTML("Die von Ihnen angegebene eMail-Adresse wird bereits von einem anderen registrierten Mitglied verwendet.");
} else {

# if email verify is on, then we can't let users change
# email address without sending a new password generated
# by system to them
$Password = "$in{'NewPassword'}";
$ModifyWarning = "";

if (($CurrentEmail ne "$Email") && ($UseEmail eq "ON") && ($EmailVerify eq "ON")){
#generate new password
$NewPassword = &GeneratePassword;
$sendto = "$Email";
$from = "$BBEmail";
$subject = "$BBName Registration - Registrierung - Ihr neues Kennwort!";
$message = "Hallo!\n\r\nSie haben Ihre eMail-Adresse im System $BBName gendert, wir senden Ihnen hiermit ein neues Kennwort.  Im folgenden finden Sie Ihre Registrierungs-Informationen, inkl. Ihrem neuem Kennwort.  Sie bentigen diese Informationen, um Beitrge in unseren Foren erstellen zu knnen.\n\r\nIhr Benutzername: $UserName\nIhr Kennwort: $NewPassword\nIhre neue eMail-Adresse: $Email";
$Password = "$NewPassword";
$ModifyWarning = "HINWEIS: Sie haben Ihre eMail-Adresse ge&auml;ndert. Wir pr&uuml;fen, ob Ihre eMail-Adresse g&uuml;ltig ist, indem wir Ihnen das neue Kennwort an die eMail-Adresse $Email senden. Sie k&ouml;nnen Ihr Kennwort &auml;ndern. &Auml;ndern Sie jedoch nicht gleichzeitig Ihre eMail-Adresse und Ihr Kennwort. Vielen Dank!"; 
if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$BBEmail", "$sendto", "$subject", "$message");
}
}  

@amend = @blank;
if ($UpdateEmailFile eq "true") {
open (EMAILFILE, "$MembersPath/emailfile.cgi"); 
    my @emailsfile = <EMAILFILE>;
close (EMAILFILE);

$CurrEmail =~ s/([\.|\@])/\\$1/isg;

foreach $checker(@emailsfile) {
chomp($checker);

if ($checker =~ m/^$CurrEmail\|\|/i) {
	($junk, $thisnum) = split(/\|\|/, $checker);
	$NewLine = "$RegEmail||$thisnum";
	push(@amend, $NewLine);
} else {
	push(@amend, $checker);
}
}

&Lock("lock.file");
open(EMAILFILE, ">$MembersPath/emailfile.cgi");
foreach $dos(@amend) {
chomp($dos);
print EMAILFILE "$dos\n";
}
close(EMAILFILE);
&Unlock("lock.file");
chmod (0666, "$MembersPath/emailfile.cgi");
}

$Signature = &CensorCheck($in{'Signature'});
$Signature =~ s/(<IMG SRC)(.*?)(>)//isg;
$Signature =~ s/</&lt;/g;
$Signature =~ s/>/&gt;/g;
$Signature =~ s/\s+$//g;

$Signature = &ConvertReturns("$Signature");

if ($AllowSignatureImage eq 'no'){	
$OverrideImages = "yes"; 
} else {
$OverrideImages = "no"; 	
$UBBImages = 'ON';
}
$Signature = &UBBCode("$Signature");

$in{'ICQnum'} =~ s/\D//g; # rem non numbers

@filter_these = ("Occupation","Location","URL","Interests","RegEmail"); # rem HTML and unclosed tags
	foreach(@filter_these){
		$$_ =~ s/<.+?>//g;
		$$_ =~ s/</&lt;/g;
	}

&Lock("lock.file");
##print profile fields to file
open (MEMBERSHIP, ">$MembersPath/$ProfileNumber.cgi") || die(&StandardHTML("Das Mitglieder-Verzeichnis kann nicht ge&ouml;ffnet werden - hier der Fehler: $!") );
	print MEMBERSHIP ("$profileinfo[0]\n");
	print MEMBERSHIP ("$Password\n");
	print MEMBERSHIP ("$Email\n");
	print MEMBERSHIP ("$URL\n");
	print MEMBERSHIP ("$Permissions\n");
	print MEMBERSHIP ("$Occupation\n");
	print MEMBERSHIP ("$Location\n");
	print MEMBERSHIP ("$TotalPosts\n");
	print MEMBERSHIP ("$Status\n");
	print MEMBERSHIP ("$Interests\n");
	print MEMBERSHIP ("$DateRegistered\n");
	print MEMBERSHIP ("$in{'EmailView'}\n");
	print MEMBERSHIP ("$Signature\n");
	print MEMBERSHIP ("$in{'ICQnum'}\n");
	print MEMBERSHIP ("$in{'AllowMassMail'}\n");
close (MEMBERSHIP);
&Unlock("lock.file");
#confirm processing to user, provide links to other places

&BioModifyConfirmHTML;
}
}  else  {
&StandardHTML("Anscheinend versuchen Sie, da&szlig; Profil eines anderen Benutzers zu ver&auml;ndern. Zur Ver&auml;nderung des Profils mu&szlig; Ihnen das Kennwort bekannt sein.");
exit;
}

}
}  ## END Modify Bio SR
sub GetAnnounce {
$ForumNumber = $in{'ForumNumber'};
@thisforum = &GetForumRecord($ForumNumber);
if ($thisforum[6] eq "private") {
	$ExactPath = "Forum$ForumNumber/private-$thisforum[7]";
}  else {
	$ExactPath = "Forum$ForumNumber";
}

opendir (GETANNC, "$ForumsPath/$ExactPath/ANNC");
	my @forummsgs = readdir(GETANNC);
closedir (GETANNC);

	my @announcements = grep(/annc/, @forummsgs);
	#now we have all announcements in the forum
	my $announce = "";
	foreach $announce(@announcements) {
		my ($start, $end, $trash) = split("-", $announce);
		&DateCompare("$start", "$end");
		if ($Live eq "true") {
			$sortline = ("$StartJulian|$announce");
			push(@livelist, $sortline);
		}	
	} #end foreach $announce
	$listtotal = @livelist;
	
@sortlist = sort(@livelist);  #the sorted list of announcements
@sortlist = reverse(@sortlist);
#now we need to print the announcements

$Moderator = ("Forum" . "$ForumNumber" . "Moderator");
$Moderator = $$Moderator;
@mods = split(/\|\|\^\|\|/, $Moderator);

foreach $unomod(@mods) {
chomp($unomod);
$ModNumber = &GetUserNumber($unomod);
if ($ModNumber ne "") {
@theprofile = &OpenProfile("$ModNumber.cgi");
$ModeratorEmail = "$theprofile[2]";
if ($ModeratorLine ne "") {
$ModeratorLine .= qq(, <A HREF="mailto:$ModeratorEmail">$unomod</A>);
}  else {
$ModeratorLine = qq(<A HREF="mailto:$ModeratorEmail">$unomod</A>);
}
} 

}

$Forum = $thisforum[1];
$CustomTitle = $thisforum[9];
chomp($CustomTitle);
if ($CustomTitle eq "") {
$CustomTitle = "$BBTitle";
}

$ForumCoded = &HTMLIFY($Forum);
$ForumCoded =~ tr/ /+/;

&AnnounceTopHTML;       

$AltColor = "$AltColumnColor1";

#print each announcement
foreach $liveannounce(@sortlist) {
($StartCheck, $anncfile) = split(/\|/, $liveannounce);

open (ANNC, "$ForumsPath/$ExactPath/ANNC/$anncfile");
	@anncinfo = <ANNC>;
close (ANNC);
#format end date
($startdate, $enddate, $trash2) = split("-", $anncfile);
my $StartMonth = substr($startdate, 0, 2);
my $StartDay = substr($startdate, 2, 2);
my $StartYear = substr($startdate, 4, 4);
my $EndMonth = substr($enddate, 0, 2);
my $EndDay = substr($enddate, 2, 2);
my $EndYear = substr($enddate, 4, 4);

$DateStart = "$StartMonth-$StartDay-$StartYear";
$DateEnd = "$EndMonth-$EndDay-$EndYear";

if ($DateFormat eq "US") {
$FormatStart = $DateStart;
$FormatEnd =  $DateEnd;
}
elsif ($DateFormat eq "Euro") {
	$FormatStart = &DateFormat("$DateStart", "Euro");
	$FormatEnd = &DateFormat("$DateEnd", "Euro");
}
elsif ($DateFormat eq "USX") {
	$FormatStart = &DateFormat("$DateStart", "USExpanded");
	$FormatEnd = &DateFormat("$DateEnd", "USExpanded");

}  else {
$FormatStart =  &DateFormat("$DateStart", "EuroExpanded");
$FormatEnd = &DateFormat("$DateEnd", "EuroExpanded");
}


my $Author = $anncinfo[0];
my $Subject = $anncinfo[1];
my $Status = $anncinfo[2];
my $ForumList = $anncinfo[3];
my $Message	 = $anncinfo[4];
chomp($Author);
chomp($Subject);
chomp($Status);
chomp($ForumList);
chomp($Message);

$StartCheck = ($StartCheck + .99);
if ($StartCheck >= $in{'Session'}) {
$NewGIF = "<IMG SRC=\"$NonCGIURL/posticonnew.gif\"  BORDER=0 ALT=\"Neue Ank&uuml;ndigung!\">";
}  else {
$NewGIF = "<IMG SRC=\"$NonCGIURL/posticon.gif\"  BORDER=0 ALT=\"Ank&uuml;ndigung!\">";
}


print<<LINE;
<TR $AltColor>
<TD valign=top><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">
$Subject
</font>
</td>
<TD valign=top>
<FONT SIZE="1" FACE="$FontFace">
$NewGIF erstellt von: $Author&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<FONT SIZE="1" FACE="$FontFace" COLOR="$LinkColor">(g&uuml;ltig vom $FormatStart bis $FormatEnd)</FONT><HR>
<FONT SIZE="$TextSize" FACE="$FontFace">$Message</FONT>
</FONT>
<BR>
</td>
</tr>
LINE

if ($AltColor eq "$AltColumnColor1") {
$AltColor = "$AltColumnColor2"
} else {
$AltColor = "$AltColumnColor1"
}
} #end foreach $liveannounce

print <<ALMOSTBOTTOM;
<tr><td colspan=2><FONT SIZE="1" FACE="$FontFace" COLOR="$TextColor">
<IMG SRC="$NonCGIURL/posticonnew.gif" BORDER=0 ALT="Neue Ank&uuml;ndigung">&nbsp;&nbsp;Neue Ank&uuml;ndigung! (seit Ihrem letzten Besuch)<BR>
</font>
</td></tr>
<tr><td colspan=2><FONT SIZE="1" FACE="$FontFace" COLOR="$TextColor">
<IMG SRC="$NonCGIURL/posticon.gif" BORDER=0 ALT="Ank&uuml;ndigung!">&nbsp;&nbsp;Alte Ank&uuml;ndigung!<P><center>
</font>
</td></tr>
</table><br><center>

ALMOSTBOTTOM

&PageBottomHTML;    #in ubb_library.pl
} #end GetAnnounce sr


## HTML CODE ####
  
sub EditBio {
print<<EDITbioHTML;
<HTML>
<HEAD><TITLE>$BBName - Profil editieren</TITLE>
$HeaderInsert
</HEAD>
<BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
$Header
<table width="$TableWidth" border="0" cellspacing="0" cellpadding="0" align="center">
    <tr> 
      <td><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A></td>
      <td align="center"><FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor""><b>&Auml;nderung 
        Ihres Profils</b></font></td>
    </tr>
    <tr> 
      <td colspan="2">
        <p><FONT SIZE="$TextSize" FACE="$FontFace"><br>
        Sie sind daf&uuml;r verantwortlich, da&szlig; Ihre pers&ouml;nlichen Daten immer auf dem aktuellsten Stand sind.<br> F&uuml;r die &Auml;nderung Ihrer pers&ouml;nlichen Daten ist nicht der Administrator zust&auml;ndig.
        </font></p></td>
    </tr>
    <tr> 
      <td colspan="2"><p>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor"><br>Um Ihre pers&ouml;nlichen Daten zu &auml;ndern, identifizieren Sie sich bitte:<br></FONT></p></td>
    </tr>
  </table>
<FORM ACTION="$CGIURL/ubbmisc.cgi" METHOD="POST" NAME="EditProfile">
<table width="$TableWidth" border="0" cellspacing="0" cellpadding="0" align="center">
<tr>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Benutzername:</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" SIZE=25 MAXLENGTH=25>
</td></tr>
<tr>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Kennwort:</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="Password" SIZE=13 MAXLENGTH=13>
</td></tr>
<tr><td>
<FONT SIZE="1" FACE="$FontFace"><A HREF="$CGIURL/Ultimate.cgi?action=lostpw">Kennwort vergessen?</A></font>
</td><td>&nbsp;</td></tr>
<tr><td>&nbsp;</td><td>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="checkbioid">
<br>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Identifikation senden">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Felder l&ouml;schen">
</td></tr>
</table>
</center>

</form>
<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE
var dc = document.cookie;
var testUserName = getCookie("UserName");
var testPassword = getCookie("Password");

if (document.cookie) {

	if (testUserName == null) {  
document.EditProfile.UserName.focus();
	} else {
	document.EditProfile.UserName.value = getCookie("UserName");
document.EditProfile.Password.value = getCookie("Password");
	}
}  else {
document.EditProfile.UserName.focus();
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</FONT>$Footer
</BODY></HTML>
EDITbioHTML

}  ##END EDIT BIO SR

sub BioModifyConfirmHTML {
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
} else {
	$ExtraInfo = "";
}

print<<HTML;
<HTML>
<HEAD><TITLE>
Modifikation Ihres Profils - Identit&auml;ts-Best&auml;tigung</title>
$HeaderInsert
<script language="JavaScript"> 
<!-- HIDE

expireDate2 = new Date;
if (expireDate2.getYear() < 1900) {
expireDate2.setYear(expireDate2.getYear() + 1900 + 1);
} else {
expireDate2.setYear(expireDate2.getYear()+1);
}
var nameStorage = getCookie("NameStorage");

var CookieName = escape("$UserName");
var CookiePW = escape("$in{'NewPassword'}");

	if (nameStorage == "no") {
	  	document.cookie = "UserName=" + CookieName + ";$ExtraInfo";
		document.cookie = "Password=" + CookiePW + ";$ExtraInfo";
	}
	if (nameStorage == "yes") {
	  	document.cookie = "UserName=" + CookieName + ";expires=" + expireDate2.toGMTString() + ";$ExtraInfo";
document.cookie = "Password=" + CookiePW + ";expires=" + expireDate2.toGMTString() + ";$ExtraInfo";
	}
	if (nameStorage == null) {
	  	document.cookie = "UserName=" + CookieName + ";$ExtraInfo";
		document.cookie = "Password=" + CookiePW + ";$ExtraInfo";
	}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}
//-->
</script>
</head>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<p>
<table width="$TableWidth" border="0" cellspacing="0" cellpadding="0" align="center">
<tr><td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>
Vielen Dank, $UserName.  Ihr Profil wurde erfolgreich ver&auml;ndert.
<P>
$ModifyWarning
<P>
</td></tr>
<TR>
<TD valign=top>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Zur&uuml;ck zu:</B></FONT></td>
<td valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">&Uuml;bersicht der Foren</A>
<BR><A HREF="$CGIURL/ubbmisc.cgi?action=editbio">
Profil editieren</a>
<BR>
<A HREF="$NonCGIURL/faq.html" target=_blank>Hilfe</A>

</B></FONT>

</td></tr></table>
</B>
</FONT><p>
$Footer
</body>
</html>
HTML
}  ## END Bio Modify Confirmation sr

sub SetPrefs {
&get_cookie;  #retrieves all current cookies
	$CurrentDaysPrune = "$cookie{DaysPrune}";
	$CurrentNS = "$cookie{NameStorage}";

if ($CurrentNS eq "yes") {
	$NSOn = "CHECKED";
	$NSOff  = "";
}
elsif ($CurrentNS eq "no") {
	$NSOff = "CHECKED";
	$NSOn = "";
}  else {
	$NSOn = "CHECKED";
	$NSOff   = "";
}
	
if ($CurrentDaysPrune eq "1") {
	$DP1On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "2") {
	$DP2On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "5") {
	$DP5On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "10") {
	$DP10On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "20") {
	$DP20On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "30") {
	$DP30On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "45") {
	$DP45On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "60") {
	$DP60On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "75") {
	$DP75On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "100") {
	$DP100On = "SELECTED";
}
elsif ($CurrentDaysPrune eq "365") {
	$DP365On = "SELECTED";
}  
elsif ($CurrentDaysPrune eq "1000") {
	$DP1000On = "SELECTED";
}  else {
    $DP1On = "SELECTED";
}

	
if ($DisplayRegistration eq "NO") {
	$StoreNameWording = qq(<INPUT TYPE="HIDDEN" NAME="NameStorage" VALUE="no">);
	$NameOption = "";
	$NSCookieSlot = "";
}  else {
	$StoreNameWording = qq%<tr $AltColumnColor1>
<TD valign=top><FONT SIZE="$TextSize" FACE="$FontFace">Soll Ihr Benutzername und Kennwort im Browser f&uuml;r 1 Jahr gespeichert werden (w&auml;hlen Sie 'nein', wenn Sie bei jedem Aufruf des Forums Ihren Benutzernamen und Ihr Kennwort eingeben wollen)</FONT></TD>
<TD valign=top><CENTER><FONT SIZE="$TextSize" FACE="$FontFace"><INPUT TYPE="RADIO" NAME="NameStorage" VALUE="yes" $NSOn>
 Ja <INPUT TYPE="RADIO" NAME="NameStorage" VALUE="no" $NSOff> Nein</font>
</CENTER> </TD>
</TR>%;
$NameOption = qq%<LI>Die Option, Ihren Benutzernamen und Ihr Kennwort f&uuml;r ein Jahr in Ihrem Browser zu speichern (Sie m&uuml;ssen in diesem Jahr Ihren Benutzernamen und Ihr Kennwort nicht jedesmal neu eingeben). W&auml;hlen Sie nein, dann wird Ihr Benutzername und Ihr Kennwort f&uuml;r diese Sitzung im Speicher abgelegt, beim erneuten Aufruf Ihres Browsers und des Forums m&uuml;ssen Sie Ihre Daten dann erneut eingeben.%;
$NSCookieSlot = qq%if (NameStorage == "yes") {
		document.PREFS.NameStorage[0].checked = true;
		} else {
		document.PREFS.NameStorage[1].checked = true;
	}%;
}
print<<PrefsHTML;
<HTML>
<HEAD>
<TITLE>$BBName Ihre Voreinstellungen</TITLE>
$HeaderInsert
</HEAD>
 <BODY $BGColor $PageBackground  text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
$Header
<table border=0 cellpadding=0 cellspacing=1 width=$TableWidth align=center>
<tr><td>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A>
</td>
<td align=center>
<FONT SIZE="3" FACE="$FontFace" color="$LinkColor"><B>Ihre Voreinstellungen</B></FONT>
</td></tr>
<tr><td colspan=2><FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
<p>Wir benutzen Cookies um Ihre Voreinstellungen in Ihrem Browser zu speichern. Es kann passieren, da&szlig; die Cookies in Ihrem Browser besch&auml;digt oder gel&ouml;scht werden. Sie haben die M&ouml;glichkeit, die Cookies (welche durch dieses Forum gesetzt wurden) zu l&ouml;schen. Klicken Sie <A HREF="$CGIURL/ubbmisc.cgi?action=clearcookies">hier</A>, um alle Cookies zu l&ouml;schen, welche durch dieses Forum gesetzt wurden!</p>
</font>
</td></tr></table>
<center>
<FORM NAME="PREFS" METHOD=POST ACTION="$CGIURL/ubbmisc.cgi">
$BorderTop
<table border=0 cellpadding=4 cellspacing=1 width=$TableWidth2>
<tr $BGColor>
<TD colspan=2><FONT SIZE="$TextSize" FACE="$FontFace">
Sie k&ouml;nnen f&uuml;r dieses System verschiedene Voreinstellungen speichern. Im folgenden Ihre Optionen:
<ul>
$NameOption
<LI>Standardanzeige f&uuml;r Beitr&auml;ge
<BR><BR>
</ul>
</FONT>
</td></tr>
<FORM NAME="PREFS" METHOD=POST ACTION="$CGIURL/ubbmisc.cgi">
$StoreNameWording
<TR $AltColumnColor2>
	<TD valign=top><FONT SIZE="$TextSize" FACE="$FontFace">Standardanzeige der Beitr&auml;ge:</FONT></TD>
	<TD valign=top><CENTER><SELECT NAME="DaysPrune">
	<OPTION value="1" $DP1On>Zeige Beitr&auml;ge des letzten Tages
	<OPTION value="2" $DP2On>Zeige Beitr&auml;ge der letzten zwei Tage
	<OPTION value="5" $DP5On>Zeige Beitr&auml;ge der letzten f&uuml;nf Tage
	<OPTION value="10" $DP10On >Zeige Beitr&auml;ge der letzten 10 Tage
	<OPTION value="20" $DP20On>Zeige Beitr&auml;ge der letzten 20 Tage
	<OPTION value="30" $DP30On>Zeige Beitr&auml;ge der letzten 30 Tage
	<OPTION value="45" $DP45On >Zeige Beitr&auml;ge der letzten 45 Tage
	<OPTION value="60" $DP60On>Zeige Beitr&auml;ge der letzten 60 Tage
	<OPTION value="75" $DP75On>Zeige Beitr&auml;ge der letzten 75 Tage
	<OPTION value="100" $DP100On>Zeige Beitr&auml;ge der letzten 100 Tage
	<OPTION value="365" $DP365On >Zeige Beitr&auml;ge der letzten 365 Tage
	<OPTION value="1000" $DP1000On>Zeige alle Beitr&auml;ge

	</SELECT>
</CENTER>
	
 </TD></tr>
</TABLE>
$BorderBottom
</center>
<BR><BR><CENTER>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="PrefsSubmit">

<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Felder l&ouml;schen">

</CENTER></FORM>
<BR>
<table border=0 cellpadding=0 cellspacing=1 width=$TableWidth align=center>
<tr><td>
<FONT SIZE="1" FACE="$FontFace"><p><B>Hinweis:</b> Ihre Voreinstellungen werden als Cookie in Ihrem Browser gespeichert. Um diese Funktion nutzen zu k&ouml;nnen, m&uuml;ssen Sie einen Browser benutzen, der Cookies unterst&uuml;tzt (Netscape und Microsoft Internet Explorer unterst&uuml;tzen Cookies). Sollte Ihr Browser keine Cookies unterst&uuml;tzen oder sollten Sie diese Funktion in Ihrem Browser abgeschalten haben, dann werden Ihre Voreinstellungen nicht gespeichert. Ihre Voreinstellungen werden nur f&uuml;r ein Jahr gespeichert. Nach diesem Jahr m&uuml;ssen Sie Ihre Voreinstellungen erneut setzen.</p></FONT>
<BR>
</td></tr></table>
$Footer
</font>
</BODY>
</HTML>
PrefsHTML
}  ## END Set Prefs SR ##


sub PrefsSubmit {
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
	$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
}  else {
	$ExtraInfo = "";
}

print<<CONFIRMHTML;
<HTML><HEAD>
<meta http-equiv="Refresh" content="4; URL=$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">
$HeaderInsert
<SCRIPT LANGUAGE="JavaScript">
<!--HIDE

expireDate = new Date;
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}
 
var DaysPrune2 = escape("$in{'DaysPrune'}");
var NameStorage2 = escape("$in{'NameStorage'}");

document.cookie = "DaysPrune=" + DaysPrune2 + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
document.cookie = "NameStorage=" + NameStorage2 + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</HEAD>
 <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<br><br>
<ul><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Ihre Voreinstellungen wurden gespeichert.  Sie gelangen in drei Sekunden automatisch zur Foren-&Uuml;bersicht.
<P>
<BR><BR>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">Klicken Sie hier, wenn Sie nicht l&auml;nger warten wollen oder Ihr Browser keine automatische Weiterleitung unterst&uuml;tzt.</A>
</B><br><br>
</FONT>
</ul>$Footer</body></html>
CONFIRMHTML
}

sub ViewBioHTML {


if ($thisprofile[3] eq "") {
	$thisprofile[3] = "&nbsp;";
}
if ($thisprofile[5] eq "") {
	$thisprofile[5] = "&nbsp;";
}
if ($thisprofile[6] eq "") {
	$thisprofile[6] = "&nbsp;";
}
if ($thisprofile[7] eq "") {
	$thisprofile[7] = "&nbsp;";
}
if ($thisprofile[9] eq "") {
	$thisprofile[9] = "&nbsp;";
}
if ($thisprofile[10] eq "") {
$DateRegistered = "-";
}  else {
$DateRegistered = "$thisprofile[10]";

#format date-----------------------------------

if ($DateFormat eq "US") {
	$DateRegistered = $DateRegistered;
}
elsif ($DateFormat eq "Euro") {
	$DateRegistered = &DateFormat("$DateRegistered", "Euro");
}
elsif ($DateFormat eq "USX") {
	$DateRegistered = &DateFormat("$DateRegistered", "USExpanded");
} else {
	$DateRegistered = &DateFormat("$DateRegistered", "EuroExpanded");
}

}  #end if/else thisprofile[10]


if ($thisprofile[8] eq "Administrator") {
	$ThisStatus = "$AdminTitle";
}
elsif ($thisprofile[8] eq "Moderator") {
	$ThisStatus = "$ModeratorTitle";
}
elsif (($thisprofile[8] eq "Member") or ($thisprofile[8] eq "Mitglied")) {
	$ThisStatus = "$MemberTitle";
}  else {
	$ThisStatus = "$JrMemberTitle";
}
$ICQline = "$thisprofile[13]";
if ($ICQline eq "") {
	$ICQline = "&nbsp;";
}

$SearchName = "$thisprofile[0]";
$SearchName = &HTMLIFY($SearchName);
$SearchName =~ tr/ /+/;


# remove all HTML code from display fields of profile
$profile_index = 0;
foreach(@thisprofile){
	$thisprofile[$profile_index] =~ s/<.+?>//g;	
	$profile_index++;
}

$ICQline =~ s/<.+?>//g;


print <<BioHTML;
<HTML>
<HEAD>$HeaderInsert</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
 $Header
 
<table width="$TableWidth2" border="0" cellspacing="0" cellpadding="0" align="center">
    <tr> 
      <td><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A></td>
      <td align="center"><FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor""><b>Profil von $thisprofile[0]</b></font>
      </td>
    </tr>
      <tr> 
      <td colspan="2"><P>
<FONT SIZE="1" FACE="$FontFace"><A HREF="$CGIURL/search.cgi?action=simplesearch&ForumChoice=ALL&ExactName=yes&SearchUser=$SearchName">Suchen: Alle Beitr&auml;ge f&uuml;r diesen registrierten Benutzer.</A></FONT>
<P></td>
    </tr>
  </table> 
 
$BorderTop
<table border=0 cellpadding=4 cellspacing=1 border=0 width=$TableWidth2 align=center>
<tr $AltColumnColor1><td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Datum der Registration:</B></FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$DateRegistered</FONT>
</td></tr>
<tr $AltColumnColor2><td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Status:</B></FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$ThisStatus</FONT>
</td></tr>
<tr $AltColumnColor1><td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Erstellte Beitr&auml;ge:</B></FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$thisprofile[7]</FONT>
</td></tr>
<tr $AltColumnColor2><td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>eMail-Adresse:</B></FONT></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$EmailField</FONT>
</td></tr>
<TR $AltColumnColor1>
<td><FONT SIZE="$TextSize" FACE="$FontFace"><B>Homepage:</B></font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor"><A HREF="$thisprofile[3]" target=_top>$thisprofile[3]</A></font>
</td></tr>
<TR $AltColumnColor2>
<td><FONT SIZE="$TextSize" FACE="$FontFace"><B>Beruf:</B></font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$thisprofile[5]</font>
</td></tr>
<TR $AltColumnColor1>
<td><FONT SIZE="$TextSize" FACE="$FontFace"><B>Wohnort:</B></font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$thisprofile[6]</font>
</td></tr>
<TR $AltColumnColor2>
<td><FONT SIZE="$TextSize" FACE="$FontFace"><B>Hobbies:</B></font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$thisprofile[9]</font>
</td></tr>
<TR $AltColumnColor1>
<td><FONT SIZE="$TextSize" FACE="$FontFace"><B>ICQ-Nummer:</B></font></td>
<td><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$ICQline</font>
</td></tr>
</table>
$BorderBottom
<P><center>
<FONT SIZE="1" FACE="$FontFace" COLOR="$CopyrightTextColor">$YourCopyrightNotice
<P>
<BR><BR>$infopopcopy<BR>
Ultimate Bulletin Board $Version<BR><BR><br><br></FONT>
</center>
<P>
$Footer
</BODY></HTML>
BioHTML
}  ## END View BIO HTML sr

sub ProcessEdit {

if ($EmailView eq "no") {
	$EVno = "CHECKED";
} else {
	$EVyes = "CHECKED";
}


if ($Status eq "Administrator") {
	$Status = "$AdminTitle";
}
elsif ($Status eq "Moderator") {
	$Status = "$ModeratorTitle";
}
elsif (($Status eq "Member") or ($Status eq "Mitglied")) {
	$Status = "$MemberTitle";
}  else {
	$Status = "$JrMemberTitle";
}
if (($UseEmail eq "ON") && ($EmailVerify eq "ON")) {
$WarningHTML = "<b>ACHTUNG:</b> Wir pr&uuml;fen, ob Ihre eMail-Adresse g&uuml;ltig ist. Wenn Sie Ihre eMail-Adresse &auml;ndern, bekommen Sie automatisch ein neues Kennwort an die neue e-Mail Adresse gesandt. &Auml;ndern Sie Ihre eMail-Adresse also erst, wenn Ihre neue e-Mail Adresse f&uuml;r den Empfang von e-Mails eingerichtet ist.";
}  else {
$WarningHTML = "";
}

	$Signature = &EditUBBConvert("$Signature");
	$Signature =~ s/<p>/\n\r\n/isg;
	$Signature =~ s/<br>/\n/isg;
	if ($AllowSignature eq "YES") {
		$SigStatus = "aktiviert";
	}else {
		$SigStatus = "deaktiviert";
	}
	unless ($AllowSignatureImage eq 'YES') {
		$SigImageAllowed  = 'HINWEIS: UBB-Image-Code ist deaktiviert.'
	}
	
	if ($AllowMassMail eq "no") {
		$AllowMailNo = "CHECKED";
		$AMM = qq(<INPUT TYPE="HIDDEN" NAME="OldAMM" VALUE="no">);
	}
	elsif ($AllowMassMail eq "") {
		$AllowMailYes = "CHECKED";
		$AMM = qq(<INPUT TYPE="HIDDEN" NAME="OldAMM" VALUE="blank">);
	} else {
		$AllowMailYes = "CHECKED";
		$AMM = qq(<INPUT TYPE="HIDDEN" NAME="OldAMM" VALUE="yes">);
	}


print<<EditHTML;
<HTML>
<HEAD>$HeaderInsert</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>
 $Header
<table width="$TableWidth" border="0" cellspacing="0" cellpadding="0" align="center">
    <tr> 
      <td><A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$BBTitle" BORDER=0></A></td>
      <td align="center"><FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor""><b>Ver&auml;ndern Sie Ihr Profil!
       </b></font></td>
    </tr>
    <tr> 
      <td colspan="2">
        <p>
        <font size="$TextSize" face="$FontFace" COLOR="$TextColor"><br><b>Vielen Dank! Ihre Identit&auml;t wurde 
        best&auml;tigt, $UserName ($Status) 
        <p>Sie k&ouml;nnen jetzt Ihr pers&ouml;nliches Profil &auml;ndern.</b> 
        </font></p></td>
    </tr>
    <tr> 
      <td colspan="2"><p><b>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor"><br>$WarningHTML</FONT></b></p></td>
    </tr>
  </table>

<center>
<FORM ACTION="$CGIURL/ubbmisc.cgi" METHOD="POST">
$AMM
$BorderTop
<table border=0 cellspacing=1 cellpadding=4 width=$TableWidth2>
<tr $AltColumnColor1>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>eMail-Adresse:</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Email" VALUE="$Email" SIZE=30 MAXLENGTH=150>
</td></tr>
<tr $AltColumnColor2>
<td>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Kennwort:</B></FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="NewPassword" VALUE="$Password" SIZE=13 MAXLENGTH=13>
</td></tr>
<tr $AltColumnColor1>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Homepage:</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="URL" VALUE="$URL" SIZE=30 MAXLENGTH=200>
</td></tr>
<tr $AltColumnColor2>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Beruf:</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Occupation" VALUE="$Occupation" SIZE=30 MAXLENGTH=100>
</td></tr>
<tr $AltColumnColor1>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Land, PLZ, Ort:</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Location" VALUE="$Location" SIZE=30 MAXLENGTH=150>
</td></tr>
<tr $AltColumnColor2>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">Hobbies:</FONT></B>
</td>
<td>
<INPUT TYPE="TEXT" NAME="Interests" VALUE="$Interests" SIZE=50 MAXLENGTH=200>
</td></tr>

<tr $AltColumnColor1>
<td>
<B><FONT SIZE="$TextSize" FACE="$FontFace">ICQ-Nummer:</FONT></B><br><FONT SIZE="1" FACE="$FontFace"><b>Hinweis: </b>Sollten Sie kein ICQ benutzen, lassen Sie dieses Feld bitte leer.</FONT>
</td>
<td>
<INPUT TYPE="TEXT" NAME="ICQnum" VALUE="$ICQnumber" SIZE=7 MAXLENGTH=20>
</td></tr>

<tr $AltColumnColor2>
<td valign=top>
<p><B><FONT SIZE="$TextSize" FACE="$FontFace">Signatur</FONT></B><BR><FONT SIZE="1" FACE="$FontFace">Hinweis: </b> Die Signatur-Funktion dieses Systems ist derzeit <b>$SigStatus</b>.  Sie k&ouml;nnen <A HREF="$NonCGIURL/ubbcode.html">UBB-Code</A> in diesem Feld benutzen, jedoch keinen HTML-Code. $SigImageAllowed</font></p>
</td>
<td>
<TEXTAREA NAME="Signature" ROWS=3 COLS=25>$Signature
</TEXTAREA>
</td></tr>

 <TR $AltColumnColor1>
	<TD><FONT SIZE="$TextSize" FACE="$FontFace"><B>Erlauben Sie dem Forum-Administrator und Moderator Ihnen e-Mails zu senden?</B></FONT></TD>
	<TD><CENTER><FONT SIZE="$TextSize" FACE="$FontFace"><INPUT TYPE="RADIO" NAME="AllowMassMail" VALUE="yes" $AllowMailYes> Ja  &nbsp;&nbsp;&nbsp;<INPUT TYPE="RADIO" NAME="AllowMassMail" VALUE="no" $AllowMailNo> Nein</FONT></CENTER>
 </TD></tr>
 
<tr $AltColumnColor2>
<TD valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>Soll Ihre eMail-Adresse f&uuml;r andere Benutzer in Ihren Nachrichten einsehbar sein?</B></FONT></TD>
<TD valign=top><CENTER><FONT SIZE="$TextSize" FACE="$FontFace"><INPUT TYPE="RADIO" NAME="EmailView" VALUE="yes" $EVyes>
 Ja <INPUT TYPE="RADIO" NAME="EmailView" VALUE="no" $EVno> Nein</font>
</CENTER> </TD>
</TR>
</table>
$BorderBottom
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="modifybio">
<INPUT TYPE="HIDDEN" NAME="UserName" VALUE="$UserName">
<INPUT TYPE="HIDDEN" NAME="Password" VALUE="$in{'Password'}">
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="&Auml;nderungen speichern">
<INPUT TYPE="RESET" NAME="Reset" VALUE="Felder l&ouml;schen"><center>
</center>
</form></font>
$Footer
</BODY></HTML>
EditHTML
}  ##END Process Edit SR


sub AnnounceTopHTML {
print<<TOP;
<HTML>
<HEAD><TITLE>$BBName - Ank&uuml;ndigungen</TITLE>
$HeaderInsert
</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
<table border=0 width=$TableWidth align=center>
<tr>
<td align=left valign=top>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/$CustomTitle" BORDER=0></A>
<BR>
<FONT SIZE="$TextSize" FACE="$FontFace" color="$LinkColor"><B>$Forum</B>
<br><FONT size= "1" COLOR="$VisitedLinkColor">(moderiert von: $ModeratorLine)
</FONT></font>
</td>
<td valign=top nowrap><FONT SIZE="1" FACE="$FontFace">
<IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">$BBName</A>
<br>
<IMG SRC="$NonCGIURL/tline.gif" BORDER=0><IMG SRC="$NonCGIURL/open.gif"  BORDER=0>&nbsp;&nbsp;<A HREF="$CGIURL/forumdisplay.cgi?action=topics&forum=$ForumCoded&number=$ForumNumber">$Forum</a>
<P><CENTER><BR>
<A HREF="$CGIURL/ubbmisc.cgi?action=editbio&Browser=$Browser&DaysPrune=$DaysPrune&LastLogin=$in{'LastLogin'}"><ACRONYM TITLE="Ver&auml;ndern Sie Ihr Profil!">Profil</ACRONYM></A> | <A HREF="$CGIURL/Ultimate.cgi?action=agree"><ACRONYM TITLE="Registration ist kostenlos!">Registrieren</ACRONYM></A> | <A HREF="$CGIURL/ubbmisc.cgi?action=setprefs"><ACRONYM TITLE="&Auml;ndern Sie Ihre Voreinstellungen!">Voreinstellungen</ACRONYM></A> | <A HREF="$NonCGIURL/faq.html" target=_blank><ACRONYM TITLE="Fragen und Antworten">Hilfe</ACRONYM></A> | <A HREF="$CGIURL/search.cgi?action=intro"><ACRONYM TITLE="Suchen Sie nach Begriff, Datum oder Benutzername">Suchen</ACRONYM></A>
</center>
</td></tr>
<tr><td colspan=2><FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
<B>Aktuelle Ank&uuml;ndigungen: $listtotal</B>
</td></tr>
<tr><td colspan=2><FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
<b>HINWEIS:</b> Ank&uuml;ndigungen k&ouml;nnen ausschie&szlig;lich Forum-Administratoren und Moderatoren erstellen. Sie k&ouml;nnen keine Antworten schreiben. 
</font></td></tr>
</table>
<table border=0 width=$TableWidth align=center>
<TR $TableColorStrip>
<TD width=35%><FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">
Thema</font>
</td>
<td>
<FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">Ank&uuml;ndigung</FONT>
</td>
</tr>
TOP
} #end AnnounceTopHTML sr

sub RegSubmit {
&HackChecker;

if ($SuspendRegister eq "true") {
&StandardHTML("Zur Zeit ist keine Registration m&ouml;glich - bitte versuchen Sie es sp&auml;ter noch einmal!");
exit;
}
#get user's IP number:
my $IPNumber = $ENV{'REMOTE_ADDR'};

unless (-e "$MembersPath/emailfile.cgi") {
&StandardHTML("Zur Zeit wird ein Update unserer Software durchgef&uuml;hrt, deswegen sind derzeit leider keine Registrationen m&ouml;glich, bitte versuchen Sie es sp&auml;ter noch einmal, Vielen Dank!");
exit;
}

if (-e "$MembersPath/temp.file") {
&StandardHTML("Zur Zeit wird die Datenbank unserer Mitglieder vom System gepflegt, bitte versuchen Sie es sp&auml;ter noch einmal, vielen Dank!");
exit;
}
if (-e "$NonCGIPath/temp.file") {
&StandardHTML("Zur Zeit wird die Datenbank unserer Mitglieder vom System gepflegt, bitte versuchen Sie es sp&auml;ter noch einmal, vielen Dank!");
exit;
}

#Check Email Ban List--
&CheckBans;

## Check to make sure censored words are not used in username
if ($Censor eq "ON") {
@censored = split(/ /, $censorwords);
$BadWord = "false";
CHECKCENSORLIST: for (@censored) {
		if (m/({)(.*)(})/) {
			$_ = ("$2");
		}
		if ($UserName =~ /$_/i) {
			$BadWord = "true";
			$CensorWord = $_;
			last CHECKCENSORLIST;
		}
} #end for checkcensorlist
if ($BadWord eq "true") {
	$RejectUserName = "true";
	&StandardHTML("Sie haben einen Benutzernamen benutzt, der das Wort (\"$CensorWord\") enth&auml;lt. Dieses Wort ist durch unser System zensiert, bitte w&auml;hlen Sie einen anderen Benutzernamen.");
}
} #end if censor is on

if (($BannedEmail ne "true") && ($RejectUserName ne "true")){

if (($UseEmail eq "ON") && ($EmailVerify eq "ON")) {

	if ( ($UserName eq "") || ($Email !~ /\S+\@\S+\.\S+/) )   {
		&StandardHTML("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt!  Stellen Sie sicher, da&szlig; Sie eine g&uuml;ltige eMail-Adresse angegeben haben - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
		} else {
		&GoAhead;
	}

} else {

	if ( ($UserName eq "") || ($Email !~ /\S+\@\S+\.\S+/) || 	($in{'Password'} eq "") || ($PasswordConfirm eq "") )  {
		&StandardHTML("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt!  Stellen Sie sicher, da&szlig; Sie eine g&uuml;ltige eMail-Adresse angegeben haben - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	}  else {
	
		if ($in{'Password'} eq "$PasswordConfirm") {
			&GoAhead; 
			}  else {
			&StandardHTML("Registration fehlgeschlagen!<P>Sie m&uuml;ssen Ihr Kennwort korrekt wiederholen - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
		}
	}
}
} # end if banned email ne true
}  ## END RegSubmit SR ##


sub GoAhead  {	

#check for illegal (non alphanumeric characters)
if (($UserName =~ m/^\s/) || ($UserName =~ m/\&nbsp/) || ($UserName =~ m/\s$/) || ($UserName =~ m/\s{2,}/) || ($UserName =~ m/\|\!/) || ($UserName =~ m/\|\|/) || ($UserName =~ m/\|$/) || ($UserName =~ m/^\#\!/) || ($UserName =~ m/^\|/) || ($UserName =~ m/\"/) || ($Email =~ m/\s/) || ($UserName =~ m/>|</) || ($UserName =~ m/memberslist/) || ($UserName =~ m/emailfile/) ||  ($UserName =~ m/;/)  || ($UserName !~ /^[a-zA-Z0-9\!\?\#\$\@\*\&\^\+\-\~\:\]\[\']/) || ($UserName !~ /[a-zA-Z0-9\!\?\#\$\@\*\&\^\+\-\~\:\]\[\']$/) ) {
&StandardHTML("Der gew&auml;hlte Benutzername enth&auml;lt ung&uuml;ltige Zeichen, beachten Sie bitte folgende Regeln:<P><blockquote>1.  Der Benutzername darf nicht mit einem Leerzeichen beginnen und/oder enden. <P>2. Sie d&uuml;rfen keine zwei Leerzeichen in Folge verwenden.<p>3.  Verwenden Sie keinen Benutzernamen mit einem Ausrufungszeichen.<P>4.  Sie d&uuml;rfen im einem Benutzernamen keine Pipes verwenden.<P>5.  Sie d&uuml;rfen in einem Benutzernamen keine Anf&uuml;hrungszeichen benutzen.<P>6.  Ihre eMail-Adresse darf keine Leerschritte enthalten.<P>7.  Der Benutzername darf die Zeichen &lt; und/oder a &gt; nicht enthalten.<P>8.  Sie d&uuml;rfen keinen Benutzernamen verwenden, der die Begriffe 'memberslist' oder 'emailfile' enth&auml;lt.<P>9. Der Benutzernamee mu&szlig; am Anfang und am Ende einen Buchstaben, eine Zahl oder eines der folgenden Symbole besitzen: !, ?, #, $, @, *, &, ^, +, -, ~, :, ], [, '.<P>10.  Sie d&uuml;rfen im Benutzernamen kein Semikolon benutzen.
</B></blockquote><p><CENTER>Bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!</center>");
exit;
}  else {
#check to make sure Username is unique
#determine EmailList array, members array & LastNumber
	$UserName =~ s/\s+/ /g;  
	$Email =~ s/\s+//g;

	&GetMemberListArray;
	&GetEmails;

# LastNumber = last number used in members file
my $LastNum = $LastNumber;

$AddOne = $LastNum + 1;
$NextNumber = sprintf("%8d", $AddOne);
$NextNumber =~ tr/ /0/;

$duplicate = "no";

$LCusername = lc($UserName);

CHECKDUPES: for $checkthis(@members) {
	$LCcheckthis = lc($checkthis);
	if ($LCcheckthis eq "$LCusername") {
		$duplicate = "yes";
		&StandardHTML("Der Benutzername existiert bereits - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
		last CHECKDUPES;
	}
}
#CHECK to make sure email isn't a duplicate too

$RegEmail = lc($Email);

if (($duplicate ne "yes") && ($EmailCheck eq "true")) {
# @EmailList contains all registered emails

 CHECKEMAIL: 
 foreach $thisemail(@EmailList) {
 ($theemail, $junk) = split(/\?\?/, $thisemail);
 $checkemail = lc($theemail);
	if ($RegEmail eq "$checkemail") {
		$duplicate = "yes";
		&StandardHTML("Die von Ihnen angegebene eMail-Adresse wird bereits durch einen Benutzer verwendet - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
		last CHECKEMAIL;
	}
 }

}  #END if duplicate ne yes



if ($duplicate ne "yes") {

	if (($UseEmail eq "ON") && ($EmailVerify eq "ON")) {
	#generate password
	$Password = &GeneratePassword;
	}  else {
	$Password = "$in{'Password'}";
	}

# Get Today's Date so we can log the date of registration

&GetDateTime;

#Prepare Signature - prevent HTML, strip returns, do UBB Code

$Signature = &CensorCheck($in{'Signature'});
$Signature =~ s/(<IMG SRC)(.*?)(>)//isg;

$Signature =~ s/</&lt;/g;
$Signature =~ s/>/&gt;/g;


$SignatureHTML = &ConvertReturns($Signature);
if ($AllowSignatureImage eq 'no'){
$OverrideImages = "yes"; 
} else {
$OverrideImages = "no"; 	
$UBBImages = 'ON';
}
$SignatureHTML = &UBBCode("$SignatureHTML");

$in{'ICQnum'} =~ s/\D//sg; # rem non numbers

@filter_these = ("Occupation","Location","URL","Interests","RegEmail"); # rem HTM and unclosed tags
	foreach(@filter_these){
		$$_ =~ s/<.+?>//sg;
		$$_ =~ s/</&lt;/sg;
	}

if ($in{'regtype'} eq 'COPPA') {
	$WritePermission = '&COPPA';
	$in{'AllowMassMail'} = 'no';
}
elsif($ModerateRegs eq 'ON') {
	$WritePermission = '&';	
}
else {
	$WritePermission = 'Write&';	
}

#Create Registration File
&Lock ("lock.file");
open (MEMBERSHIP, ">$MembersPath/$NextNumber.cgi") or die("Das Verzeichnis Members kann nicht ge&ouml;ffnet werden.");
	print MEMBERSHIP ("$UserName\n");
	print MEMBERSHIP ("$Password\n");
	print MEMBERSHIP ("$RegEmail\n");
	print MEMBERSHIP ("$URL\n");
	print MEMBERSHIP ("$WritePermission\n");
	print MEMBERSHIP ("$Occupation\n");
	print MEMBERSHIP ("$Location\n");
	print MEMBERSHIP ("0\n");
	print MEMBERSHIP ("Junior-Mitglied\n");
	print MEMBERSHIP ("$Interests\n");
	print MEMBERSHIP ("$HyphenDate\n");
	print MEMBERSHIP ("$in{'EmailView'}\n");
	print MEMBERSHIP ("$SignatureHTML\n");
	print MEMBERSHIP ("$in{'ICQnum'}\n");
	print MEMBERSHIP ("$in{'AllowMassMail'}\n");
close (MEMBERSHIP);
chmod (0777, "$MembersPath/$NextNumber.cgi");

## APPEND NEW REGISTRATION TO REG FILE
open (LIST, ">>$MembersPath/memberslist.cgi");
	print LIST "$UserName|!!|$NextNumber\n";
close (LIST);
chmod (0666, "$MembersPath/memberslist.cgi");

open (LIST, ">>$MembersPath/emailfile.cgi");
	print LIST "$RegEmail||$NextNumber\n";
close (LIST);
chmod (0666, "$MembersPath/emailfile.cgi");

$totalmembers = (@members + 1); #the total number of registered users

open (MEMTOTAL, ">$MembersPath/membertotal.cgi");
	print MEMTOTAL $totalmembers; 
close (MEMTOTAL);
chmod (0666, "$MembersPath/membertotal.cgi");

&Unlock ("lock.file");

if ($UseEmail eq "ON")  {

### EMAIL VERIFY 'ON' section
	# standard email verification -> send new user a password
	if ( ($ModerateRegs eq 'OFF') && ($EmailVerify eq "ON") ){
	$sendto = "$Email";
	$from = "$RegsAdminEmail";
	$subject = "$BBName Registration - Ihr Kennwort";
	$message = "Hallo!\n\r\nVielen Dank fr die Registration bei $BBName ($CGIURL/Ultimate.cgi).  Ihre Registrierung war erfolgreich.  Sie bentigen die folgenden Informationen, um neue Beitrge in unserem Forum ($CGIURL/Ultimate.cgi) schreiben zu knnen.\n\r\nIhr Benutzername: $UserName\nIhr Kennwort: $Password\nIhre eMail-Adresse lautet: $RegEmail\n\r\nBeachten Sie, da Sie Ihr Kennwort online im Menpunkt \"Profil\" unseres Forums ndern sollten.  Sollten Sie Ihre eMail-Adresse ndern, erhalten Sie automatisch ein neues Kennwort, um Ihre eMail-Adresse prfen zu knnen.\n\r\nNochmals vielen Dank fr Ihre Registrierung.";
	$RegWording1 = "Sie haben Ihren Benutzernamen $UserName erfolgreich bei $BBName registriert! ";
	$RegWording2 = "Ihr Kennwort wird Ihnen an folgende eMail-Adresse gesandt: $Email";
	}
	# standard email verification but no posting until approval -> send adult user a password
	elsif ( ($ModerateRegs eq 'ON') && ($EmailVerify eq "ON") && ($in{'regtype'} ne 'COPPA') ) {
	$sendto = "$Email";
	$from = "$RegsAdminEmail";
	$subject = "$BBName Registrationsanfrage";
	$message = "Hallo!\n\r\nVielen Dank fr die Registration bei $BBName ($CGIURL/Ultimate.cgi). \n\r\nHINWEIS: Ihre Registration mu durch einen Administrator geprft und freigeschaltet werden, bitte gedulden Sie sich. Im Folgenden die Details Ihrer Registration bei $CGIURL/Ultimate.cgi .\n\r\nIhr Benutzername: $UserName\nIhr Kennwort: $Password\nIhre eMail-Adresse: $RegEmail\n\r\nSollten Sie die in unserem System gespeicherte eMail-Adresse ndern, erhalten Sie aus Sicherheitsgrnden ein neues Kennwort an die neue eMail-Adresse zugesandt.\n\r\nVielen Dank f&uuml;r die Registration.\n\r\nBei Fragen zur Registration senden Sie uns an die Adresse $RegsAdminEmail eine eMail.\n\r\n";
	$RegWording1 = "Sie haben sich den Benutzernamen $UserName bei $BBName erfolgreich registriert.";
	$RegWording2 = "Ihr Kennwort wird Ihnen an folgende eMail-Adresse gesandt: $Email";
	}
	# standard email verification but no posting until approval -> send COPPA user a password
	elsif ( ($ModerateRegs eq 'ON') && ($EmailVerify eq "ON") && ($in{'regtype'} eq 'COPPA') ) {
	$sendto = "$Email";
	$from = "$RegsAdminEmail";
	$subject = "$BBName Registrationsanfrage";
	$instructions = $COPPAInstructions;
	$instructions =~ s/&quot;/"/ig;
	$instructions =~ s/<BR>/\n/ig;
	$instructions =~ s/<p>/\n\n/ig;
	$message = "Hallo!\n\r\nVielen Dank fr die Registrationsanfrage bei $BBName ($CGIURL/Ultimate.cgi).\n\r\nDie folgenden Daten wurden fr Sie reserviert:\n\r\nIhr Benutzername: $UserName\nIhr Kennwort: $Password\n\r\nDa Sie ein Alter von bis zu 13 Jahren angegeben haben, muIhr Registrationsantrag von den Eltern oder Erziehungsberechtigten geprft werden, bevor Sie Beitrge in unserem System erstellen knnen. Der Freischaltungsantrag mu an uns gesandt werden, andernfalls werden die Daten Ihrer Registration gelscht.\n\r\nDrucken Sie die folgende Best&auml;tigung aus:\n\r\n$instructions \n\r\nBei Fragen zur Registration senden Sie uns an die Adresse $RegsAdminEmail eine eMail.\n\r\n";
	$RegWording1 = "Sie haben den Benutzernamen $UserName bei $BBName erfolgreich reserviert. ";
	$RegWording2 = "Ihr Kennwort wird Ihnen an folgende eMail-Adresse gesandt: $Email";
	}

	if ($EmailVerify eq "ON") {
		$BBEmail = $RegsAdminEmail;
		if ($SMTPEmail eq "On") {
		&SendEmail;
		}  else {
		&send_mail("$BBEmail", "$sendto", "$subject", "$message");
		}	
	}


### EMAIL VERIFY 'OFF' section
	# This is an ADULT request
	elsif ( ($ModerateRegs eq 'ON') && ($EmailVerify eq "OFF") && ($in{'regtype'} ne 'COPPA') ) {
	$RegWording1 = "Sie haben sich den Benutzernamen $UserName bei $BBName erfolgreich registriert.";
	$RegWording2 = "$Password";
	}

	# This is a COPPA request
	elsif ( ($ModerateRegs eq 'ON') && ($EmailVerify eq "OFF") && ($in{'regtype'} eq 'COPPA') ) {
	$RegWording1 = "Hallo!\n\r\nVielen Dank fr die Registrationsanfrage bei $BBName ($CGIURL/Ultimate.cgi).\n\r\nDie folgenden Daten wurden fr Sie reserviert:\n\r\nIhr Benutzername: $UserName\nIhr Kennwort: $Password\n\r\nDa Sie ein Alter von bis zu 13 Jahren angegeben haben, mu Ihr Registrationsantrag von den Eltern oder Erziehungsberechtigten geprft werden, bevor Sie Beitrge in unserem System erstellen knnen. Der Freischaltungsantrag mu an uns gesandt werden, andernfalls werden die Daten Ihrer Registration gelscht.\n\r\nDrucken Sie die folgende Besttigung aus:\n\r\n$instructions \n\r\nBei Fragen zur Registration senden Sie uns an die Adresse $RegsAdminEmail eine eMail.\n\r\n";
	$RegWording2 = "$Password";
	}


	if ($in{'regtype'} eq 'COPPA') {
		&PrintCOPPARegistrationHTML;
	} else {
		&PrintRegistrationHTML;
	}


# Send email to parent if listed
	if ($in{'ParentEmail'} =~ /\S+\@\S+\.\S+/) {
		$BBEmail = $RegsAdminEmail;
		$sendto = $in{'ParentEmail'};
		$from = "$RegsAdminEmail";
		$subject = "Registrationsanfrage bei $BBName";
		$message = qq(
		
Hallo!
		
Wir haben eine Registrationsanfrage einer Person mit einem Alter von bis zu 13 Jahren fr unser System erhalten.
Unsere Foren bei $BBName verlangen gem dem COPPA-Jugendschutzgesetz eine Genehmigung fr Ihren Sohn/Ihre Tochter.
		
Bei der Registration wurde Ihr Sohn/Ihre Tochter gebeten, einen Freischaltungsauftrag auszudrucken, Ihnen diesen
zur Unterschrift vorzulegen und uns dann zu bermitteln.

Unseren Freischaltungsauftrag finden Sie online bei folgender URL: $CGIURL/ubbmisc.cgi?action=showcoppaform 
		
Rechtliche Hinweise zu unserer Website finden Sie online bei folgender URL: $PrivacyURL
		 
Bitte sehen Sie sich unseren Freischaltungsantrag mit Ihrem Sohn/Ihrer Tochter gemeinsam an und folgen Sie den
dort angegebenen Anweisungen am Anfang der Seite.
		
Bei Fragen zur Registration senden Sie uns an die folgende Adresse $RegsAdminEmail eine eMail.
		
Vielen Dank!
Webmaster
$BBName
); # end qq
	
	if ($SMTPEmail eq "On") {
		&SendEmail;
	}  else {
		&send_mail("$BBEmail", "$sendto", "$subject", "$message");
	}	
	}# end if parent email 



}  else { # email is turned off !

	if ($in{'regtype'} eq 'COPPA') {
	$RegWording1 = "Sie haben sich erfolgreich bei $BBName registriert, knnen jedoch bis zum Erhalt des durch die Eltern/Erziehungsberechtigten unterschriebenen Freischaltungsantrag keine Beitrge erstellen. Bitte drucken Sie dieses Formular aus: $COPPAInstructions";
	$RegWording2 = "$Password";
	&PrintCOPPARegistrationHTML;
	}

	else {
	$RegWording1 = "Sie haben sich erfolgreich bei $BBName registriert!";
	$RegWording2 = "$Password";
	&PrintRegistrationHTML;
	}
} # end if/else email #1


if ( ($OnRegsNotifyAdmin ne 'OFF') && ($UseEmail eq 'ON') ) { 

	# COPPA notify only - no adults
	if (($OnRegsNotifyAdmin eq 'COPPA') && ($in{'regtype'} eq 'COPPA')) {
	$notifyadmin++; # flag it
	$sendto = "$RegsAdminEmail";
	$from = "$RegEmail";
	$subject = "COPPA Registrationsanfrage!";
	$message = "eMail-Adresse der Eltern/Erziehungsberechtigten: $in{'ParentEmail'}\n\r\n";
	$message = "Die folgenden Informationen wurden durch den Benutzer eingegeben:\n\r\n";
	}

	# All Regs Notify
	elsif ($OnRegsNotifyAdmin eq 'ON') {  
	$notifyadmin++; # flag it
	$sendto = "$RegsAdminEmail";
	$from = "$RegEmail";
	$subject = "Neue Registration!";
	$message = "Die folgenden Informationen wurden durch den Benutzer eingegeben:\n\r\n";
	}

	# else do nothing if flag isn't set
	if ($notifyadmin) { # only email if the flag is set
		$message .= &PrintProfileText();
		if ($WritePermission !~ /Write/) {
		$message .= "\n\r\n Klicken Sie hier, um Schreibrechte fr diesen Benutzer zu aktivieren:\n\r\n";
		$message .= "$CGIURL/cpanel4.cgi?action=updatepermiss&AdminWrite::$NextNumber=true&RemoteUpdate=TRUE\n\r\n";
		$message .= "[Sie mssen einen Login als Administrator durchgefhrt haben, um diesen direkten Link nutzen zu knnen.]\n\r\n";
		} else {
		$message .= "\n\r\nSchreibrechte f&uuml;r diesen Benutzer sind AKTIVIERT.\n\r\n";
		}
		$BBEmail = $RegsAdminEmail;
		if ($SMTPEmail eq "On") {
		&SendEmail;
		}else {
		&send_mail("$RegsAdminEmail", "$sendto", "$subject", "$message");
		}
	} # end if notifyadmin

} # end if Notify Admin



} # end use email/verify on check

} ### end if dupe ne yes

}  # end GoAhead subroutine


sub PrintRegistrationHTML {
&GetCookieInfo;
if ($SetCookies eq "DirectorySpecific") {
$ExtraInfo = qq(domain=$TheDomain;path=/$ThePath;);
} else {
$ExtraInfo = qq(domain=$TheDomain;path=/);
} 

if ($in{'regtype'} eq 'COPPA') {
$welcomewording = "<p>Solange der Freischaltungs-Antrag unterschrieben von den Eltern/Erziehungsberechtigten dem Website-Betreiber nicht vorliegt, k&ouml;nnen Sie keine Beitr&auml;ge erstellen. Drucken Sie diese Seite oder die eMail, die Sie jetzt erhalten aus. Folgen Sie den dort aufgef&uuml;hrten Anweisungen.<p>";	
$finalwords = $COPPAInstructions;
}
elsif ($ModerateRegs eq 'ON'){
$welcomewording = "<p>Die Administration mu&szlig; Ihre Registration freischalten, bevor Sie Beitr&auml;ge erstellen k&ouml;nnen. Bei Fragen zur Registration senden Sie uns an die folgende Adresse: <A HREF=mailto:$RegsAdminEmail>$RegsAdminEmail</a> eine eMail.<p>Es folgen die Details Ihrer Registration.";		
}
else {
$welcomewording = "<p>Sie k&ouml;nnen sofort in unseren Foren Beitr&auml;ge erstellen.  Es folgen die Details Ihrer Registration.</p>";	
}

print <<HTML;
<HTML>
<HEAD><TITLE>
Best&auml;tigung der Registration</title>
$HeaderInsert
</head>
 <BODY $BGColor $PageBackground  text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<FONT SIZE="$TextSize" FACE="$FontFace" color="$TextColor">
<BR>
<TABLE BORDER="0" WIDTH="$TableWidth">
<tr><td colspan=2>
<FONT SIZE="$TextSize" FACE="$FontFace"><B>Herzlichen Gl&uuml;ckwunsch!
<P>
$RegWording1  $welcomewording</B></FONT>
</td></tr>
<tr>
<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>Benutzername:</B></FONT></TD>
<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$UserName</font>
 </TD>
</tr>

<TR>
	<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>Kennwort:</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$RegWording2</font>
 </TD>
</tr>
<TR>
	<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>eMail-Adresse:</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Email</font>
 </TD>
</TR>
<TR>
	<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>Land, PLZ und Ort:</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Location</font>
 </TD>
</TR>
<TR>
	<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>Beruf:</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Occupation</font>
 </TD>
</tr>
<TR>
	<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>Hobbies:</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Interests</font>
 </TD>
</tr>
<TR>
	<TD $AltColumnColor1><FONT SIZE="$TextSize" FACE="$FontFace"><B>Homepage</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$URL</font>
 </TD>
</tr>

<TR>
	<TD $AltColumnColor1 valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>Signatur</B></FONT></TD>
	<TD $AltColumnColor2><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$SignatureHTML</font>
 </TD>
</tr>

</TABLE>

<p><FONT SIZE="$TextSize" FACE="$FontFace">$finalwords</font></p>

<p><FONT SIZE="$TextSize" FACE="$FontFace">
Klicken Sie <A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true">hier</A>, um unsere Foren zu betreten!<br><br>
</FONT>
<br><br><br><br>

<SCRIPT LANGUAGE="JavaScript">
<!--HIDE

expireDate = new Date;
if (expireDate.getYear() < 1900) {
expireDate.setYear(expireDate.getYear() + 1900 + 1);
} else {
expireDate.setYear(expireDate.getYear()+1);
}

var DaysPrune = escape("$in{'DaysPrune'}");
var NameStorage = escape("$in{'NameStorage'}");
var CookieName = escape("$in{'UserName'}");
var CookiePW =  escape("$in{'Password'}");
var EmailVerify = escape("$EmailVerify");

document.cookie = "DaysPrune=" + DaysPrune + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
document.cookie = "NameStorage=" + NameStorage + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
 
if (EmailVerify == "OFF") {
if (NameStorage == "no") {
	  	document.cookie = "UserName=" + CookieName + ";$ExtraInfo";
		document.cookie = "Password=" + CookiePW + ";$ExtraInfo";
	}
if (NameStorage == "yes") {
	  	document.cookie = "UserName=" + CookieName + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
document.cookie = "Password=" + CookiePW + ";expires=" + expireDate.toGMTString() + ";$ExtraInfo";
	}
}
// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

</font>$Footer</body></html>
HTML
} ## END Print Registration sr

sub PWRequest {
# Find the right registration
&GetMemberListArray;
&GetEmails; # returns @EmailList array
$Found = "";

#lowercase the email input
$sendto = lc($in{'sendto'});
$CountIt = 0;
foreach $emailline(@EmailList) {
       ($theemail, $thenumber) = split(/\?\?/, $emailline);
		$theemail = lc("$theemail");
		
	if ($theemail eq "$sendto") {
	chomp($thenumber);
		@thisprofile = &OpenProfile("$thenumber.cgi");
		$YourName = "$thisprofile[0]";
		$YourPassword = "$thisprofile[1]";
		$CountIt = $CountIt + 1;
		$Found = "yes";
	}
}

if ($CountIt >= 2) {
&StandardHTML("Diese Funktion kann nicht durchgef&uuml;hrt werden, da die von Ihnen angegebene eMail-Adresse von mehr als einem Benutzer verwendet wird.");
exit;
}

if ($Found eq "yes") {

#Send the Email

$from = "$BBEmail";
$subject = "Ihr Benutzername und Kennwort - $BBName";
$message = ("Im folgenden bermitteln wir Ihnen Ihre Registrierungs-Informationen fr $BBName. \n\n Ihr Benutzername: $YourName\n Ihr Kennwort: $YourPassword \n\n Unser System finden Sie unter $CGIURL/Ultimate.cgi \n\nVielen Dank!");
if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$BBEmail", "$sendto", "$subject", "$message");
}
#Notify user that email has been sent
&Forward("$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true", "Ihren Benutzernamen und Ihr Kennwort haben wir an Ihre eMail-Adresse gesandt!<P>Sie gelangen jetzt automatisch zur Foren-&Uuml;bersicht.");

}  else {
&StandardHTML("Die angegebene eMail-Adresse ist bei uns nicht gespeichert - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
}
} #end PWRequest sr


sub SocketTest {
&StandardHTML("Das Socket-Modul ist auf Ihrem Webserver installiert, Sie k&ouml;nnen es f&uuml;r den Versand von eMails verwenden.<P>Benutzen Sie die ZUR&Uuml;CK-Funktion, um zu den Variablen zur&uuml;ckzukehren.");
}

sub SendThreadForm {

if ($UBBFriendUSE eq 'OFF'){
&StandardHTML("Die Funktion UBBFriend ist in diesem System deaktiviert worden!");
exit;	
}

$Subject = &UNHTMLIFY($in{'Subject'});

print<<SendThread;
<HTML>
<HEAD>
$HeaderInsert


</HEAD>
 <BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor" marginheight=0 marginwidth=0 topmargin=0 leftmargin=0 rightmargin=0>$Header
<FONT SIZE="2" FACE="$FontFace" COLOR="$TextColor">
<BR>
<CENTER>
<FORM ACTION="$CGIURL/ubbmisc.cgi" METHOD="POST" NAME="UBBFriend">
<table border=0 width="$TableWidth">
<TR $BGColor><TD align=left>
<A HREF="$CGIURL/Ultimate.cgi?action=intro&BypassCookie=true"><IMG SRC="$NonCGIURL/ubbfriend.gif" BORDER=0 ALT="UBBFriend"></A></TD>
<TD align=right valign=bottom>
<FONT SIZE="3" FACE="$FontFace" COLOR="$LinkColor"><B>Senden Sie diese Seite an einen Freund!</B></FONT></td></tr>
</TABLE>
<BR>
$BorderTop
<TABLE BORDER=0 cellspacing=1 cellpadding=4 width=$TableWidth2>
SendThread

if ($UBBFriendUSE eq 'ON'){

print qq(	
<TR $AltColumnColor1>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Ihr Name:</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="FromName" Value="" SIZE=25 MAXLENGTH=100>
</td>
</tr>
<TR $AltColumnColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Ihre eMail-Adresse (damit Ihr Freund antworten kann!):</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="FromEmail" Value="" SIZE=25 MAXLENGTH=100>
</td>
</tr>
);# end qq
} # end if UBBFriend ON 

else {
print qq(	

<tr $TableColorStrip><td colspan=2><FONT SIZE="$TextSize" FACE="$FontFace" color=$TableStripTextColor>* Diese Funktion ist nur f&uuml;r registrierte Benutzer verf&uuml;gbar.<br>&nbsp;&nbsp; Die in Ihrem Profil angegebene eMail-Adresse wird bei Antworten auf diese eMail verwendet.</font></td>
</tr>
<TR $AltColumnColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Ihr Benutzername:</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="UserName" Value="" SIZE=25 MAXLENGTH=100>
</td>
</tr>
<TR $AltColumnColor1>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Ihr Kennwort:</B></font>
</td>
<td>
<INPUT TYPE="Password" NAME="Password" Value="" SIZE=25 MAXLENGTH=100>
</td>
</tr>
<TR $AltColumnColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Ihr Name:</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="FromName" Value="" SIZE=25 MAXLENGTH=100>
</td>
</tr>

);# end qq	
	
	
}

print qq(

<TR $AltColumnColor1>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Name des Empf&auml;ngers:</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="SendToName" SIZE=25 MAXLENGTH=75>
</td>
</tr>
<TR $AltColumnColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>eMail-Adresse des Empf&auml;ngers:</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="SendToEmail" SIZE=25 MAXLENGTH=100>
</td>
</tr>
<TR $AltColumnColor1>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Betreff:</B></font>
</td>
<td>
<INPUT TYPE="TEXT" NAME="EmailSubject" Value="$Subject" SIZE=25 MAXLENGTH=100>
</td>
</tr>
<TR $AltColumnColor2>
<TD valign=top><FONT SIZE="$TextSize" FACE="$FontFace">
<B>Nachricht:</B></font>
</td>
<td>
<TEXTAREA NAME="EmailMessage" ROWS=4 COLS=30>Diese Website m&uuml;ssen Sie sich ansehen: $in{'thread'}</TEXTAREA>
</td>
</tr>
</table>
$BorderBottom

<P>

<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="eMail jetzt senden!">

<INPUT TYPE="HIDDEN" NAME="ForwardURL" VALUE="$in{'thread'}">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="SubmitThreadEmail">
</FORM>
</font>

<SCRIPT LANGUAGE="JavaScript">
<!-- HIDE

var dc = document.cookie;
var testUserName = getCookie("UserName");
var testPassword = getCookie("Password");

if ( (document.cookie) && (document.UBBFriend.UserName) ) {
	if (testUserName == null) {  
	document.UBBFriend.UserName.focus();
	} else {
	document.UBBFriend.UserName.value = getCookie("UserName");
	document.UBBFriend.Password.value = getCookie("Password");
	document.UBBFriend.FromName.focus();
	}
}

function getCookie(name){
var cname = name + "=";               
var dc = document.cookie;
if (dc.length > 0) {              
    begin = dc.indexOf(cname);
	 if (begin != -1) {           
        begin += cname.length;
		end = dc.indexOf(";", begin);
            if (end == -1) end = dc.length;
            return unescape(dc.substring(begin, end));        }
}
return null;
}

// STOP HIDING FROM OTHER BROWSERS -->
</SCRIPT>

); # end qq

&PageBottomHTML;
} #end SendThreadForm

sub SubmitThreadEmail {

if ($UBBFriendUSE eq 'OFF'){
	&StandardHTML("Die Funktion UBBFriend ist auf diesem System deaktiviert worden.");
	exit;	
}


if ($UBBFriendUSE eq 'RegUsers') {


if (($in{'UserName'} eq "") || ($in{'Password'} eq "")) {
	&StandardHTML("Sie m&uuml;ssen Ihren Benutzernamen und Ihr Kennwort eingeben - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	exit;
}
$ProfileNumber = &GetUserNumber($UserName);

if ($ProfileNumber ne "") {
	$NameFound = "yes";
} else {
	$NameFound = "no";
}

if ($NameFound eq "yes") {
	#Check Password Now
		
	@thisprofile = &OpenProfile("$ProfileNumber.cgi");
	
         if ($in{'Password'} eq "$thisprofile[1]") {
		     $pwmatch = "true";
			$Email = $thisprofile[2];
			$Permissions = $thisprofile[4];
         }
} ## END IF MEMBER = Username.cgi condition

if ($NameFound ne "yes") {
  	&StandardHTML("Der von Ihnen angegebene Benutzername existiert nicht in unserem System - bitte nutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	exit;
}
if (($NameFound eq "yes") && ($pwmatch ne "true")) {
   	&StandardHTML("Das eingegebene Kennwort ist nicht korrekt - bitte benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
	exit;
}

if ($Permissions !~ /Write/) {
   	&StandardHTML("Die von Ihnen gew&uuml;nschte eMail konnte nicht versandt werden, da Sie in diesem System keine Schreibrechte besitzen.");
	exit;	
}

else {
	$in{'FromEmail'} = $Email; # use the member's email address	
}

} # end if UBBfriend eq RegUsers


##
#validate required fields
if (($in{'FromName'} eq "") || ($in{'EmailMessage'} eq "") || ($in{'SendToEmail'} !~ m/\S+\@\S+\.\S+/) || ($in{'EmailSubject'} eq "") || ($in{'FromEmail'} !~ m/\S+\@\S+\.\S+/) || ($in{'SendToName'} eq "") ) {
&StandardHTML("Sie haben nicht alle Pflichtfelder ausgef&uuml;llt oder das Format der angegebenen eMail-Adresse ist falsch - benutzen Sie die ZUR&Uuml;CK-Funktion Ihres Browsers und versuchen Sie es erneut!");
}  else {

$ReplyTo = "$in{'FromName'}<$in{'FromEmail'}>";


$sendto = $in{'SendToEmail'};
$subject = "$in{'EmailSubject'}";

$message = "$in{'EmailMessage'}";

if ($SMTPEmail eq "On") {
&SendEmail;
}  else {
&send_mail("$ReplyTo", "$sendto", "$subject", "$message");
}

&Forward("$in{'ForwardURL'}", "Wir haben Ihre eMail an $in{'SendToEmail'} versandt. Sie werden jetzt an die Seite weitergeleitet, von der Sie die eMail versendet haben.");
} #end if/else form validation
}  #end SubmitThreadEmail

sub VerifyID {
$NameFound = "no";
$ProfileNumber = &GetUserNumber($UserNamePrivate);

if ($NumbersPrivate ne "") {
	if ($NumbersPrivate =~ /\:\:/) {
	@CheckAccess = split(/\:\:/, $NumbersPrivate);
	}  else {
		@CheckAccess = $NumbersPrivate;
	}
	
	CHECKER: foreach $checker(@CheckAccess) {
		chomp($checker);
		($checknum, $checkdir) = split(/\:/, $checker);
		if ($checknum eq "$number") {
			if ($checkdir eq "$DIRPW") {
			$ProceedNow = "true";
			last CHECKER;
			}  else {
				&StandardHTML("Ihr Identit&auml;t kann nicht ermittelt werden.");
				exit;
			} #if checkdir
		}# if checknum
	} #foreach
}  #if np

if ($ProceedNow ne "true") {

	if ($ProfileNumber ne "") {
		$NameFound = "yes";
		} else {
		$NameFound = "no";
	}
	
		@thisprofile = &OpenProfile("$ProfileNumber.cgi");
if ($PasswordPrivate eq "$thisprofile[1]") {
		$Permission = "$thisprofile[4]";
		$Status = $thisprofile[8];
		($GenPerms, $SpecificPerms) = split(/\&/, $Permission);
		
			$Moderator = ("Forum" . "$number" . "Moderator");
$Moderator = $$Moderator;
#split up Mod var
@mods = split(/\|\|\^\|\|/, $Moderator);

$ModMatch = "";
foreach $unomod(@mods) {
if ($unomod eq "$UserNamePrivate") {
	$ModMatch = "true";
}
}
		if (($Status eq "Administrator") || ($ModMatch eq "true")) {
	  		$ProceedNow = "true";
	   }
		if (($SpecificPerms ne "") && ($ProceedNow ne "true")){
			chomp($specificPerms);
			@accessarray = split(",", $SpecificPerms);
			CHECKARRAY: foreach $uno(@accessarray) {
				if ($uno eq "$number") {
					$ProceedNow = "true";
					last CHECKARRAY;
				}
			}
		}
	}
}

} #end VerifyID

sub GetIP {
#print authorization screen- must be admin or mod
my $IPTitle = qq($BBName - Gespeicherte IP-Nummer f&uuml;r diesen Beitrag anzeigen);
my $IPRunner = qq(I P &nbsp;&nbsp;&nbsp;&nbsp; L O G &nbsp;&nbsp;&nbsp;&nbsp; A N Z E I G E);
my $IPIntro = qq(Um die gespeicherte IP-Nummer f&uuml;r diesen Beitrag anzusehen, identifizieren Sie sich bitte:);
$IPHidden = qq(<FORM ACTION="$CGIURL/postings.cgi" NAME="Authorize" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="IPDisplay" VALUE="yes">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="submitedit">
<INPUT TYPE="HIDDEN" NAME="EditedMessage" VALUE="none">
<INPUT TYPE="HIDDEN" NAME="TopicSubject" VALUE="$TopicSubject">
<INPUT TYPE="HIDDEN" NAME="forum" VALUE="$Forum">
<INPUT TYPE="HIDDEN" NAME="ReplyNum" VALUE="$in{'ReplyNum'}">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$number">
<INPUT TYPE="HIDDEN" NAME="topic" VALUE="$topic">);

&AuthorizeCheck($IPTitle, $IPIntro, $IPHidden, $IPRunner);

}

sub CheckBans {

my @banlist = &OpenFile("$NonCGIPath/BanLists/EmailBan.cgi");

if ($banlist[0] ne "") {
my $banword = "";
CheckBanList: for $banword(@banlist) {
	chomp($banword);
	$banword2 = quotemeta($banword);
		if ($Email =~ m/$banword2/i) {
			&StandardHTML("Die von Ihnen bei der Registration verwendete eMail-Adresse ist von der Administration f&uuml;r dieses System gesperrt worden.  Zur Zeit erlauben wir keine Registrationen auf die folgende eMail-Adresse: <P>$banword<P> Bei Fragen k&ouml;nnen Sie uns an $BBEmail eine eMail senden.");
	$BannedEmail = "true";
	exit;
	last CheckBanList;
		}
	}
} #if EmailBan list is not empty


#Check IP Ban List--
my @IPbanlist = &OpenFile("$NonCGIPath/BanLists/IPBan.cgi");

if ($IPbanlist[0] ne "") {
my $bannum = "";
CheckIPBanList: for $bannum(@IPbanlist) {
	chomp($bannum);
	$bannum2 = quotemeta($bannum);
		if ($IPNumber =~ m/^$bannum2/i) {
			&StandardHTML("Die von Ihnen verwendete IP-Nummer ist von der Administration f&uuml;r dieses System gesperrt worden.  Ihre IP-Nummer lautet: $IPNumber.<P> Bei Fragen k&ouml;nnen Sie uns an $BBEmail eine eMail senden.");
	$BannedEmail = "true";
	exit;
	last CheckIPBanList;
		}
	}
} #if IPBan list is not empty

}

sub PrintProfileText {
	if ($in{'EmailView'} eq "yes") { $emailansicht = "Ja"; }
        if ($in{'EmailView'} eq "no") { $emailansicht = "Nein"; }
        if ($in{'AllowMassMail'} eq "yes") { $bulkmail = "Ja"; }
        if ($in{'AllowMassMail'} eq "no") { $bulkmail = "Nein"; }
        if ($WritePermission eq "Write&") { $schreiben = "Benutzer kann Beitrge und/oder Antworten verfassen."; 
        } else { $schreiben = "Benutzer kann keine Beitrge und/oder Antworten verfassen."; }
        my $message .= ("Benutzername: $UserName\n");
	$message .= ("Kennwort: $Password\n");
	$message .= ("eMail-Adresse: $RegEmail\n");
	$message .= ("Homepage: $URL\n");
	$message .= ("Rechte: $schreiben\n");
	$message .= ("Beruf: $Occupation\n");
	$message .= ("Wohnort: $Location\n");
	$message .= ("Erstellte Beitrge: 0\n");
	$message .= ("Status: $Status\n");
	$message .= ("Hobbies: $Interests\n");
	$message .= ("Datum: $HyphenDate\n");
	$message .= ("Anzeige der eMail erlaubt: $emailansicht\n");
	$message .= ("Signatur: $in{'Signature'}\n");
	$message .= ("ICQ-Nummer: $ICQ\n");
	$message .= ("eMail-Empfang durch UBB-Administration erlaubt: $bulkmail\n");
return $message;	
}



sub PrintCOPPARegistrationHTML {
	
print <<"COPPA"
	
	
<html>
<head>
<title>Freischaltungsauftrag f&uuml;r $BBName</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<BODY $BGColor  $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
<table width="$TableWidth" border="0" cellspacing="1" cellpadding="3" align=center>
  <tr > 
    <td > 
      <A HREF="$CGIURL/Ultimate.cgi?action=intro&bypasscookie=true"><IMG SRC=$NonCGIURL/$BBTitle border=0></a>
      <td align=center><h4> <font face="$FontFace" color="$LinkColor">Freischaltungs-Antrag
        f&uuml;r&nbsp; $BBName</font></h4>
    </td>
  </tr>
  
    <tr $CategoryStripColor> 
    <td colspan="2"> 
      <p><font face="$FontFace" size="2" color="$CategoryStripTextColor"><h5>Anweisungen
      f&uuml;r die Eltern oder Erziehungsberechtigten</h></font></h5>
    </td>
  </tr>
 
  
  <tr $AltColumnColor1> 
    <td colspan="2"> 
      <p><font face="$FontFace" size="2"><a name="COPPAInstructions"></a>$COPPAInstructions</font></p>
    </td>
  </tr>
  <tr $CategoryStripColor> 
    <td colspan="2"> 
      <p><font size="2" face="$FontFace" color="$CategoryStripTextColor"><b>Nachfolgend
      die durch den Benutzer eingegebenen <u>Pflichtdaten</u>:</b></font></p>
    </td>
  </tr>
  
 <tr $AltColumnColor2>
<TD width=22%><font size="$TextSize" face="$FontFace"><b>Benutzername</b></font></TD>
<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$UserName</font>
 </TD>
</tr>

<tr $AltColumnColor1>
	<TD ><font size="$TextSize" face="$FontFace"><b>Kennwort</b></font></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$RegWording2</font>
 </TD>
</tr>
<tr $AltColumnColor2>
	<TD ><font size="$TextSize" face="$FontFace"><b>eMail-Adresse</b></font></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Email</font>
 </TD>
</TR>
<tr $CategoryStripColor>
	<TD colspan="2"><FONT SIZE="$TextSize" FACE="$FontFace" color="$CategoryStripTextColor"><B><p>Die
      nachfolgenden Angaben wurden durch den Benutzer <u>optional</u> angegeben.
      Bitte &uuml;berpr&uuml;fen Sie die Angaben:</p></B></FONT></TD>
</TR>
<tr $AltColumnColor2>
	<TD colspan="2"><p><FONT SIZE="$TextSize" FACE="$FontFace">Um &Auml;nderungen
      dieser Angaben vorzunehmen, klicken Sie bitte <A HREF="$CGIURL/ubbmisc.cgi?action=editbio" TARGET="_blank">hier</a><A>
      und geben dann den o.g. Benutzernamen und Kennwort zu Identifikation ein.</p></a></font></TD>
</TR>
<tr $AltColumnColor1>
	<TD ><font size="$TextSize" face="$FontFace"><b>Land, PLZ und Ort</b></font></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Location</font>
 </TD>
</TR>
<tr $AltColumnColor2>
	<td><font size="$TextSize" face="$FontFace"><b>Beruf</b></font></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Occupation</font>
 </TD>
</tr>
<tr $AltColumnColor1>
	<TD ><font size="$TextSize" face="$FontFace"><b>Hobbies</b></font></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$Interests</font>
 </TD>
</tr>
<tr $AltColumnColor2>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace"><B>Homepage</B></FONT></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$URL</font>
 </TD>
</tr>

<tr $AltColumnColor1>
	<TD  valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>Signatur</B></FONT></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$SignatureHTML</font>
 </TD>
</tr>
<tr $AltColumnColor2>
	<TD  valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>D&uuml;rfen
      Administratoren und/oder Moderatoren dem Benutzer eMails senden?</B></FONT></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$in{'AllowMassMail'}</font>
 </TD>
</tr>
<tr $AltColumnColor1>
	<TD  valign=top><font size="$TextSize" face="$FontFace"><b>Soll die
      eMail-Adresse f&uuml;r andere Benutzer einsehbar sein?</b></font></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$in{'EmailView'}</font>
 </TD>
</tr>
<tr $AltColumnColor2>
	<TD  valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>ICQ-Nummer</B></FONT></TD>
	<TD ><FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$LinkColor">$in{'ICQ'}</font>
 </TD>
</tr>
<tr $AltColumnColor1>
	<TD valign=top>&nbsp;</TD>
	<TD >&nbsp;</font>
 </TD>
</tr>

   <tr $CategoryStripColor> 
    <td colspan="2"> 
      <p><font face="$FontFace" size="2" color="$CategoryStripTextColor"><b>Bitte
      drucken Sie dieses Formular aus und senden Sie uns das unterzeichnete
      Formular zu.</b><br>[Detaillierte Anweisungen &uuml;ber die Zusendungen finden
      Sie <a href="#COPPAInstructions">hier</a>.]</font></p>
    </td>
  </tr>
  <tr $AltColumnColor1>
    <td colspan="2"><p><font face="$FontFace" size="2"><b>JA:</b>
      Ich habe die Angaben meines Kindes &uuml;berpr&uuml;ft und mich &uuml;ber die <a href="$PrivacyURL">rechtlichen
      Hinweise</a> zu dieser Website informiert. Ich habe verstanden, da&szlig; mein
      Kind die o.g. Profil-Angaben jederzeit mit dem Benutzernamen $UserName und
      dem genannten Kennwort &auml;ndern kann. Mir ist bekannt, da&szlig; ich den
      Webmaster um L&ouml;schung der hier genannten Daten bitten kann.</font></p>   
    </td>
  </tr>
  <tr $AltColumnColor2> 
    <td> 
      <p><font face="$FontFace" size="2">Vor- und Nachname</font></p>
    </td>
    <td> 
<br><hr>
    </td>
  </tr>
    <tr $AltColumnColor2> 
    <td> 
      <p><font size="2" face="$FontFace">Unterschrift</font></p>
    </td>
    <td> 
      <br><hr> </td>
  </tr>
  <tr $AltColumnColor1> 
    <td> 
      <p><font size="2" face="$FontFace">Beziehung zum Kind</font></p>
    </td>
    <td> 
      <p><font size="2"><br><hr>
    </td>
  </tr>
  <tr $AltColumnColor2> 
    <td> 
      <p><font size="2" face="$FontFace">Telefon</font></p>
    </td>
    <td> 
      <br><hr>  </td>
  </tr>
  <tr $AltColumnColor1> 
    <td> 
      <p><font size="2" face="$FontFace">eMail-Adresse</font></p>
    </td>
    <td> 
      <br><hr>    </td>
  </tr>
  <tr $AltColumnColor1> 
    <td><font size="2" face="$FontFace">Datum</font>
         </td>
    <td> 
     <br><hr>   </td>
  </tr>
  <tr $AltColumnColor2> 
    <td><font size="2" face="$FontFace">Datum der Registration</font></td>
    <td> 
     <font size="2" face="$FontFace">$HyphenDate <font size=-1>[</font></font><font size="-1" face="$FontFace">nur
     online sichtbar</font><font size="2" face="$FontFace">]</font></td>
  </tr>
  <tr $CategoryStripColor> 
    <td colspan="2"> 
      <p><font size="2" face="$FontFace" color="$CategoryStripTextColor">F&uuml;r
      weitere Fragen klicken&nbsp; Sie <a href="mailto:$RegsAdminEmail">hier</a>
      und schreiben uns eine eMail.</font></p>
    </td>
  </tr>
</table>

<center><p><b><font size="$TextSize" face="$FontFace">
<A HREF="$ContactLink">Kontakt</A> | <A HREF="$HomePageURL" target=_top>$MyHomePage</A> | <A HREF="$PrivacyURL">rechtliche
Hinweise</A></font></b>
<P>
<FONT COLOR="$CopyrightTextColor" size="1" FACE="$FontFace">$YourCopyrightNotice
<P>
$infopopcopy<br>
Ultimate Bulletin Board $Version
<br><br>
</FONT>
</CENTER></font>
</p>
</body>
</html>
	
COPPA



	
} # end SR



exit(0); # comply with SafePerl
